diff -pruN 2.5.10.1+dfsg-1/CHANGES.md 2.5.12.0+dfsg-1/CHANGES.md
--- 2.5.10.1+dfsg-1/CHANGES.md	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/CHANGES.md	2024-06-01 19:59:05.000000000 +0000
@@ -1,3 +1,30 @@
+Release 2.5.12.0 (June 1, 2024) -- compared to 2.5.11.0
+-------------------------------------------------------
+- *exr*: Add IOProxy support for EXR multipart output [#4263](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4263) [#4264](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4264) (by jreichel-nvidia)
+- *pnm*: Improvements to pnm plugin: support for uint16 and 32-float, "pnm:bigendian" and "pnm:pfmflip" controls for output. [#4253](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4253) (by Vlad (Kuzmin) Erium)
+- *ImageBuf*: Improve behavior of IB::nsubimages and other related fixes [#4228](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4228)
+- *simd.h*: Fix longstanding problem with 16-wide bitcast for 8-wide HW [#4268](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4268)
+- *strutil.h*: Add Strutil::eval_as_bool [#4250](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4250)
+- *tests*: Add new heif test output [#4262](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4262)
+- *tests*: Fix windows quoting for test [#4271](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4271)
+- *build*: More warning elimination for clang18 [#4257](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4257)
+- *build*: Add appropriate compiler defines and flags for SIMD with MSVC [#4266](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4266) (by Jesse Yurkovich)
+- *build*: Gcc-14 support, testing, CI [#4270](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4270)
+- *docs*: Fix stray references to the old repo home [#4255](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4255)
+
+
+Release 2.5.11.0 (May 1, 2024) -- compared to 2.5.10.0
+-------------------------------------------------------
+- *dds*: DDS support more DXGI formats [#4220](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4220) (by alexguirre)
+- *psd*: Add support for 16- and 32-bit Photoshop file reads [#4208](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4208) (by EmilDohne)
+- *fix(fmt.h)*: Fix build break from recent fmt change [#4227](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4227)
+- *fix(openexr)*: Fix out-of-bounds reads when using OpenEXR decreasingY lineOrder. [#4215](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4215) (by Aaron Colwell)
+- *fix*: Don't use (DY)LD_LIBRARY_PATH as plugin search paths [#4245](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4245) (by Brecht Van Lommel)
+- *fix*: Fix crash when no default fonts are found [#4249](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4249)
+- *build*: Disable clang18 warnings about deprecated unicode conversion [#4246](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4246)
+- *security*: Better documentation of past CVE fixes in SECURITY.md [#4238](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4238)
+
+
 Release 2.5.10.1 (Apr 1, 2024) -- compared to 2.5.9.0
 ------------------------------------------------------
 - *oiiotool*: Expression substitution now understands pseudo-metadata `NONFINITE_COUNT` that returns the number of nonfinite values in the image, thus allowing decision making about fixnan [#4171](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4171)
@@ -20,7 +47,6 @@ Release 2.5.10.1 (Apr 1, 2024) -- compar
 - *admin*: Add a ROADMAP document [#4161](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4161)
 
 
-
 Release 2.5.9.0 (Mar 1, 2024) -- compared to 2.5.8.0
 -----------------------------------------------------
 - *oiiotool*: Overhaul and fix bugs in mixed-channel propogation [#4127](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/4127)
diff -pruN 2.5.10.1+dfsg-1/CMakeLists.txt 2.5.12.0+dfsg-1/CMakeLists.txt
--- 2.5.10.1+dfsg-1/CMakeLists.txt	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/CMakeLists.txt	2024-06-01 19:59:05.000000000 +0000
@@ -4,7 +4,7 @@
 
 cmake_minimum_required (VERSION 3.15)
 
-set (OpenImageIO_VERSION "2.5.10.1")
+set (OpenImageIO_VERSION "2.5.12.0")
 set (OpenImageIO_VERSION_OVERRIDE "" CACHE STRING
      "Version override (use with caution)!")
 mark_as_advanced (OpenImageIO_VERSION_OVERRIDE)
diff -pruN 2.5.10.1+dfsg-1/CONTRIBUTING.md 2.5.12.0+dfsg-1/CONTRIBUTING.md
--- 2.5.10.1+dfsg-1/CONTRIBUTING.md	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/CONTRIBUTING.md	2024-06-01 19:59:05.000000000 +0000
@@ -143,8 +143,9 @@ The best way to submit changes is via Gi
 All code must be formally reviewed before being merged into the official
 repository. The protocol is like this:
 
-1. Get a GitHub account, fork OpenImageIO/oiio to create your own repository
-on GitHub, and then clone it to get a repository on your local machine.
+1. Get a GitHub account, fork AcademySoftwareFoundation/OpenImageIO to create
+your own repository on GitHub, and then clone it to get a repository on your
+local machine.
 
 1. Edit, compile, and test your changes. Run clang-format (see the
 instructions on coding style below).
diff -pruN 2.5.10.1+dfsg-1/CREDITS.md 2.5.12.0+dfsg-1/CREDITS.md
--- 2.5.10.1+dfsg-1/CREDITS.md	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/CREDITS.md	2024-06-01 19:59:05.000000000 +0000
@@ -4,10 +4,12 @@ by first name.
 If you know of somebody that I missed or have corrections, please email:
 lg@openimageio.org
 
+* Aaron Colwell
 * Adam Mains
 * Akihiro Yamasaki
 * Alan Jones
 * Alejandro Conty
+* Alex Guirre
 * Alex Hughes
 * Alex Schworer
 * Alexander Kuleshov
@@ -19,6 +21,8 @@ lg@openimageio.org
 * Aman Shah
 * Ananth Garre
 * Anders Langlands
+* Andy Chan
+* AngryLoki
 * Angus Davis
 * Anthony Nemoff
 * Anton Dukhovnikov
@@ -46,11 +50,13 @@ lg@openimageio.org
 * Changlin Hsieh
 * Chris Crosetto
 * Chris Foster
+* Chris Hellmuth
 * Chris Kulla
 * Chris Whalen
 * Christoph Willing
 * Cliff Stein
 * Clément Champetier
+* D-Spirits
 * Dalai Felinto
 * Dan Wexler
 * Daniel Dresser
@@ -64,11 +70,13 @@ lg@openimageio.org
 * Dieter De Baets
 * Dinko Galetik
 * Dominik Bartkiewicz
+* Dominik Wójt
 * Duncan Chan
 * Dustin Rodrigues
 * Edgar Velazquez-Armendariz
 * Eloi Du Bois
 * Elvic Liang
+* Emil Dohne
 * Fabien Castan
 * Fabien Servant
 * Fredrik Averpil
@@ -110,6 +118,7 @@ lg@openimageio.org
 * Julien Enche
 * Justin Israel
 * Justina Mikonyte
+* Kaarrot
 * Kazuki Takahashi
 * Kevin Brightwell
 * Kimball Thurston
@@ -165,6 +174,7 @@ lg@openimageio.org
 * Paul Molodowitch
 * Pavel Karneliuk
 * Pete Larabell
+* Peter Kovář
 * Philip Nemec
 * Pino Toscano
 * Povilas Kanapickas
@@ -188,6 +198,7 @@ lg@openimageio.org
 * SebTV
 * Seifeddine Dridi
 * Sergey Sharybin
+* Sergio Rojas
 * Shane Ambler
 * Simon Boorer
 * Solomon Boulos
@@ -202,6 +213,7 @@ lg@openimageio.org
 * Tim Grant
 * Tom Knowles
 * Troy James Sobotka
+* Vic P
 * Vinod Khare
 * Vishal Agrawal
 * Vitor Franchi
diff -pruN 2.5.10.1+dfsg-1/INSTALL.md 2.5.12.0+dfsg-1/INSTALL.md
--- 2.5.10.1+dfsg-1/INSTALL.md	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/INSTALL.md	2024-06-01 19:59:05.000000000 +0000
@@ -18,7 +18,7 @@ NEW or CHANGED MINIMUM dependencies sinc
      * The default build mode is C++14. This can be controlled by via the
        CMake configuration flag: `-DCMAKE_CXX_STANDARD=17`, etc.
      * ADVISORY: We expect that OIIO 2.6 in 2024 will require C++17 or higher.
- * Compilers: gcc 6.1 - 13.1, clang 3.4 - 17, MSVS 2017 - 2019,
+ * Compilers: gcc 6.1 - 14.1, clang 3.4 - 18, MSVS 2017 - 2019,
    Intel icc 17+, Intel OneAPI C++ compiler 2022+.
  * **CMake >= 3.15** (tested through 3.28)
  * **OpenEXR/Imath >= 2.4** (recommended: 3.1 or higher; tested through 3.2
@@ -26,26 +26,26 @@ NEW or CHANGED MINIMUM dependencies sinc
  * libTIFF >= 3.9 (recommended: 4.0+; tested through 4.6)
  * libjpeg >= 8 (tested through jpeg9e), or **libjpeg-turbo >= 2.1** (tested
    through 3.0)
- * Boost >= 1.53 (recommended: at least 1.66; tested through 1.84)
- * **[fmtlib](https://github.com/fmtlib/fmt) >= 7.0** (tested through 10.1).
+ * Boost >= 1.53 (recommended: at least 1.66; tested through 1.85)
+ * **[fmtlib](https://github.com/fmtlib/fmt) >= 7.0** (tested through 10.2).
    If not found at build time, this will be automatically downloaded unless
    the build sets `-DBUILD_MISSING_FMT=OFF`.
 
 ### Optional dependencies -- features may be disabled if not found
  * If you are building the `iv` viewer (which will be disabled if any of
    these are not found):
-     * Qt5 >= 5.6 (tested through 5.15) or Qt6 (tested through 6.6)
+     * Qt5 >= 5.6 (tested through 5.15) or Qt6 (tested through 6.7)
      * OpenGL
  * If you are building the Python bindings or running the testsuite:
-     * Python >= 2.7 (tested against 2.7, 3.7, 3.8, 3.9, 3.10, 3.11)
-     * pybind11 >= 2.4.2 (Tested through 2.11. Note that pybind11 v2.10+ does
+     * Python >= 2.7 (tested against 2.7, 3.7, 3.8, 3.9, 3.10, 3.12)
+     * pybind11 >= 2.4.2 (Tested through 2.12. Note that pybind11 v2.10+ does
        not support Python < 3.6.)
      * NumPy
  * If you want support for camera "RAW" formats:
      * LibRaw >= 0.18 (tested though 0.21.2; if
        building with C++17 or higher, LibRaw >= 0.20 is necessary)
  * If you want support for a wide variety of video formats:
-     * ffmpeg >= 3.0 (tested through 6.1)
+     * ffmpeg >= 3.0 (tested through 7.0)
  * If you want support for jpeg 2000 images:
      * OpenJpeg >= 2.0 (tested through 2.5; we recommend 2.4 or higher
        for multithreading support)
@@ -68,7 +68,7 @@ NEW or CHANGED MINIMUM dependencies sinc
  * If you want support for DICOM medical image files:
      * DCMTK >= 3.6.1 (tested through 3.6.8)
  * If you want support for WebP images:
-     * WebP >= 0.6.1 (tested through 1.3.2)
+     * WebP >= 0.6.1 (tested through 1.4)
  * If you want support for OpenColorIO color transformations:
      * OpenColorIO >= 1.1 (tested through 2.3; 2.0+ is recommended)
  * If you want support for Ptex:
diff -pruN 2.5.10.1+dfsg-1/RELEASING.md 2.5.12.0+dfsg-1/RELEASING.md
--- 2.5.10.1+dfsg-1/RELEASING.md	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/RELEASING.md	2024-06-01 19:59:05.000000000 +0000
@@ -253,7 +253,7 @@ The following are the steps for making t
 6. Push it to GitHub: `git push OpenImageIO release --tags`
 
    (This example assumes "OpenImageIO" is the name of the remote for the
-   GitHub `OpenImageIO/oiio` repo.)
+   GitHub `AcademySoftwareFoundation/OpenImageIO` repo.)
 
 7. Draft a release on GitHub: On https://github.com/AcademySoftwareFoundation/OpenImageIO/releases
    select "Draft a new release." Choose the new tag you just pushed. Make the
diff -pruN 2.5.10.1+dfsg-1/SECURITY.md 2.5.12.0+dfsg-1/SECURITY.md
--- 2.5.10.1+dfsg-1/SECURITY.md	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/SECURITY.md	2024-06-01 19:59:05.000000000 +0000
@@ -23,3 +23,30 @@ respond to vulnerability reports within
 
 Our policy is to address critical security vulnerabilities rapidly and post
 patches as quickly as possible.
+
+
+## Outstanding Security Issues
+
+None known
+
+
+## History of CVE Fixes
+
+Most recent fixes listed first, more or less
+
+- CVE-2023-42295: Fix signed integer overflow when computing total number of pixels while reading BMP files. [#3948](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/3948) (by xiaoxiaoafeifei) (Fixed in 2.5.3.0/2.6.0.1)
+- CVE-2023-36183: Heap-buffer-overflow while reading ICO files [#3872](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/3872)  (by xiaoxiaoafeifei)
+- TALOS-2023-1709 / CVE-2023-24472: Race condition in TIFF reader. [#3772](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/3772) (2.5.1.0/2.4.8.1)
+- TALOS-2023-1707 / CVE-2023-24473, TALOS-2023-1708 / CVE-2023-22845: Guard against corrupted Targa. [#3768](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/3768) (2.5.1.0/2.4.8.1)
+- TALOS-2022-1654 / CVE-2022-43596, TALOS-2022-1655 / CVE-2022-43597 CVE-2022-43598, TALOS-2022-1656 / CVE-2022-43599 CVE-2022-43600 CVE-2022-43601 CVE-2022-43602: Fix possible IFF write errors [#6876](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/3676) (2.4.6/2.5.0.0)
+- TALOS-2022-1653 / CVE-2022-43594: Fix possible errors when writing BMP files. [#3673](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/3673) (by lgritz) (2.4.6/2.5.0.0)
+- TALOS-2022-1651 / CVE-2022-43592, TALOS-2022-1652 / CVE-2022-4359: Fix possible DPX write errors. [#3672](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/3672) (2.4.6/2.5.0.0)
+- TALOS-2022-1657 / CVE-2022-43603: Zfile write safety. [#3670](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/3670) (2.4.6/2.5.0.0)
+- TALOS-2022-1633 / CVE-2022-41639, TALOS-2022-1643 / CVE-2022-41988: Guard TIFF against buffer overflow for certain CMYK files. [#3632](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/3632) (2.4.5/2.5.0.0)
+- TALOS-2022-1626, CVE-2022-41794: PSD files protect against corrupted embedded thumbnails. [#3629](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/3629) (2.4.5/2.5.0.0)
+- TALOS-2022-1627, CVE-2022-41977: Guard TIFF reads against corrupt files with buffer overflows. [#3628](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/3628) (2.4.5/2.5.0.0)
+- TALOS-2022-1626 / CVE-2022-41794, TALOS-2022-1632 / CVE-2022-41684, TALOS-2022-1636 / CVE-2022-41837: Exif (all formats that support it, TIFF/JPEG/PSD) fix bugs where corrupted Exif blocks could overrun memory. [#3627](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/3627) (2.4.5/2.5.0.0)
+- TALOS-2022-1634 / CVE-2022-41838, TALOS-2022-1635 / CVE-2022-41999: Fix DDS reading crashes for cubemap files when a cube face was not present, and check for invalid bits per pixel. [#3625](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/3625) (2.4.5/2.5.0.0) #3625 (2.4.5/2.5.0.0)
+- TALOS-2022-1629, CVE-2022-36354: RLA potential buffer overrun. [#3624](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/3624) (2.4.5/2.5.0.0)
+- TALOS-2022-1628, CVE-2022-41981: Targa file string overflow safety. [#3622](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/3622) (2.4.5/2.5.0.0)
+- TALOS-2022-1630, CVE-2022-38143: Protect against corrupt pixel coordinates while reading BMP files. [#3620](https://github.com/AcademySoftwareFoundation/OpenImageIO/pull/3620) (by lgritz) (Fixed in 2.4.5/2.5.0.0)
diff -pruN 2.5.10.1+dfsg-1/debian/changelog 2.5.12.0+dfsg-1/debian/changelog
--- 2.5.10.1+dfsg-1/debian/changelog	2024-04-13 13:48:53.000000000 +0000
+++ 2.5.12.0+dfsg-1/debian/changelog	2024-06-15 09:32:35.000000000 +0000
@@ -1,3 +1,10 @@
+openimageio (2.5.12.0+dfsg-1) experimental; urgency=medium
+
+  * New upstream release
+  * debian/control: S-V bump 4.6.2 -> 4.7.0 (no changes needed)
+
+ -- Matteo F. Vescovi <mfv@debian.org>  Sat, 15 Jun 2024 11:32:35 +0200
+
 openimageio (2.5.10.1+dfsg-1) experimental; urgency=medium
 
   * New upstream release
diff -pruN 2.5.10.1+dfsg-1/debian/control 2.5.12.0+dfsg-1/debian/control
--- 2.5.10.1+dfsg-1/debian/control	2024-04-13 13:30:28.000000000 +0000
+++ 2.5.12.0+dfsg-1/debian/control	2024-06-15 09:29:20.000000000 +0000
@@ -38,7 +38,7 @@ Build-Depends:
  qtbase5-dev,
  robin-map-dev (>= 0.2.0),
  txt2man
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://www.openimageio.org/
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/openimageio.git
diff -pruN 2.5.10.1+dfsg-1/src/build-scripts/gh-installdeps.bash 2.5.12.0+dfsg-1/src/build-scripts/gh-installdeps.bash
--- 2.5.10.1+dfsg-1/src/build-scripts/gh-installdeps.bash	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/build-scripts/gh-installdeps.bash	2024-06-01 19:59:05.000000000 +0000
@@ -69,7 +69,9 @@ if [[ "$ASWF_ORG" != ""  ]] ; then
 else
     # Using native Ubuntu runner
 
-    time sudo apt-get update
+    if [[ "${SKIP_APT_GET_UPDATE}" != "1" ]] ; then
+        time sudo apt-get update
+    fi
 
     time sudo apt-get -q install -y \
         git cmake ninja-build ccache g++ \
@@ -82,7 +84,6 @@ else
             libavcodec-dev libavformat-dev libswscale-dev libavutil-dev \
             dcmtk libopenvdb-dev \
             libfreetype6-dev \
-            locales wget \
             libopencolorio-dev \
             libtbb-dev \
             libopencv-dev
@@ -100,12 +101,11 @@ else
     # Nonstandard python versions
     if [[ "${PYTHON_VERSION}" == "3.9" ]] ; then
         time sudo apt-get -q install -y python3.9-dev python3-numpy
-        pip3 --version
-        pip3 install numpy
     elif [[ "$PYTHON_VERSION" == "2.7" ]] ; then
         time sudo apt-get -q install -y python-dev python-numpy
-    else
-        pip3 install numpy
+    fi
+    if [[ "${PIP_INSTALLS:=numpy}" != "none" ]] ; then
+        time pip3 install ${PIP_INSTALLS}
     fi
 
     if [[ "$USE_LIBHEIF" != "0" ]] ; then
@@ -132,13 +132,17 @@ else
         time sudo apt-get install -y g++-11
     elif [[ "$CXX" == "g++-12" ]] ; then
         time sudo apt-get install -y g++-12
+    elif [[ "$CXX" == "g++-13" ]] ; then
+        time sudo apt-get install -y g++-13
+    elif [[ "$CXX" == "g++-14" ]] ; then
+        time sudo apt-get install -y g++-14
     fi
 
     if [[ "$CXX" == "icpc" || "$CC" == "icc" || "$USE_ICC" != "" || "$USE_ICX" != "" ]] ; then
+        time sudo apt-get -q install -y wget
         wget https://apt.repos.intel.com/intel-gpg-keys/GPG-PUB-KEY-INTEL-SW-PRODUCTS-2023.PUB
         sudo apt-key add GPG-PUB-KEY-INTEL-SW-PRODUCTS-2023.PUB
         echo "deb https://apt.repos.intel.com/oneapi all main" | sudo tee /etc/apt/sources.list.d/oneAPI.list
-        time sudo apt-get update
         time sudo apt-get install -y intel-oneapi-compiler-dpcpp-cpp-and-cpp-classic
         set +e; source /opt/intel/oneapi/setvars.sh; set -e
     fi
diff -pruN 2.5.10.1+dfsg-1/src/build-scripts/gh-win-installdeps.bash 2.5.12.0+dfsg-1/src/build-scripts/gh-win-installdeps.bash
--- 2.5.10.1+dfsg-1/src/build-scripts/gh-win-installdeps.bash	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/build-scripts/gh-win-installdeps.bash	2024-06-01 19:59:05.000000000 +0000
@@ -103,8 +103,8 @@ vcpkg list
 # export PNG_ROOT=$PWD/ext/dist
 
 # We're currently getting libtiff from vcpkg
-#src/build-scripts/build_libtiff.bash
-#export TIFF_ROOT=$PWD/ext/dist
+src/build-scripts/build_libtiff.bash
+export TIFF_ROOT=$PWD/ext/dist
 
 # We're currently getting jpeg from vcpkg
 # LIBJPEGTURBO_CONFIG_OPTS=-DWITH_SIMD=OFF
diff -pruN 2.5.10.1+dfsg-1/src/build-scripts/install_homebrew_deps.bash 2.5.12.0+dfsg-1/src/build-scripts/install_homebrew_deps.bash
--- 2.5.10.1+dfsg-1/src/build-scripts/install_homebrew_deps.bash	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/build-scripts/install_homebrew_deps.bash	2024-06-01 19:59:05.000000000 +0000
@@ -20,7 +20,9 @@ if [[ `which brew` == "" ]] ; then
 fi
 
 
-#brew update >/dev/null
+if [[ "${DO_BREW_UPDATE:=0}" != "0" ]] ; then
+    brew update >/dev/null
+fi
 echo ""
 echo "Before my brew installs:"
 brew list --versions
@@ -48,6 +50,10 @@ fi
 if [[ "${USE_QT}" != "0" ]] ; then
     brew install --display-times -q qt${QT_VERSION}
 fi
+if [[ "${USE_LLVM:=0}" != "0" ]] || [[ "${LLVMBREWVER}" != "" ]]; then
+    brew install --display-times -q llvm${LLVMBREWVER}
+    export PATH=/usr/local/opt/llvm/bin:$PATH
+fi
 
 echo ""
 echo "After brew installs:"
@@ -61,7 +67,6 @@ pip${PYTHON_VERSION} install numpy
 export PATH=/usr/local/opt/qt5/bin:$PATH
 export PATH=/usr/local/opt/python/libexec/bin:$PATH
 export PYTHONPATH=/usr/local/lib/python${PYTHON_VERSION}/site-packages:$PYTHONPATH
-#export PATH=/usr/local/opt/llvm/bin:$PATH
 
 # Save the env for use by other stages
 src/build-scripts/save-env.bash
diff -pruN 2.5.10.1+dfsg-1/src/cmake/compiler.cmake 2.5.12.0+dfsg-1/src/cmake/compiler.cmake
--- 2.5.10.1+dfsg-1/src/cmake/compiler.cmake	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/cmake/compiler.cmake	2024-06-01 19:59:05.000000000 +0000
@@ -302,11 +302,29 @@ if (NOT USE_SIMD STREQUAL "")
     if (USE_SIMD STREQUAL "0")
         set (SIMD_COMPILE_FLAGS ${SIMD_COMPILE_FLAGS} "-DOIIO_NO_SIMD=1")
     else ()
+        set(_highest_msvc_arch 0)
         string (REPLACE "," ";" SIMD_FEATURE_LIST ${USE_SIMD})
         foreach (feature ${SIMD_FEATURE_LIST})
             message (VERBOSE "SIMD feature: ${feature}")
             if (MSVC OR CMAKE_COMPILER_IS_INTEL)
-                set (SIMD_COMPILE_FLAGS ${SIMD_COMPILE_FLAGS} "/arch:${feature}")
+                if (feature STREQUAL "sse2")
+                    list (APPEND SIMD_COMPILE_FLAGS "/D__SSE2__")
+                endif ()
+                if (feature STREQUAL "sse4.1")
+                    list (APPEND SIMD_COMPILE_FLAGS "/D__SSE2__" "/D__SSE4_1__")
+                endif ()
+                if (feature STREQUAL "sse4.2")
+                    list (APPEND SIMD_COMPILE_FLAGS "/D__SSE2__" "/D__SSE4_2__")
+                endif ()
+                if (feature STREQUAL "avx" AND _highest_msvc_arch LESS 1)
+                    set(_highest_msvc_arch 1)
+                endif ()
+                if (feature STREQUAL "avx2" AND _highest_msvc_arch LESS 2)
+                    set(_highest_msvc_arch 2)
+                endif ()
+                if (feature STREQUAL "avx512f" AND _highest_msvc_arch LESS 3)
+                    set(_highest_msvc_arch 3)
+                endif ()
             else ()
                 set (SIMD_COMPILE_FLAGS ${SIMD_COMPILE_FLAGS} "-m${feature}")
             endif ()
@@ -318,6 +336,20 @@ if (NOT USE_SIMD STREQUAL "")
                 add_compile_options ("-ffp-contract=off")
             endif ()
         endforeach()
+
+        # Only add a single /arch flag representing the highest level of support.
+        if (MSVC OR CMAKE_COMPILER_IS_INTEL)
+            if (_highest_msvc_arch EQUAL 1)
+                list (APPEND SIMD_COMPILE_FLAGS "/arch:AVX")
+            endif ()
+            if (_highest_msvc_arch EQUAL 2)
+                list (APPEND SIMD_COMPILE_FLAGS "/arch:AVX2")
+            endif ()
+            if (_highest_msvc_arch EQUAL 3)
+                list (APPEND SIMD_COMPILE_FLAGS "/arch:AVX512")
+            endif ()
+        endif ()
+        unset(_highest_msvc_arch)
     endif ()
     add_compile_options (${SIMD_COMPILE_FLAGS})
 endif ()
diff -pruN 2.5.10.1+dfsg-1/src/cmake/externalpackages.cmake 2.5.12.0+dfsg-1/src/cmake/externalpackages.cmake
--- 2.5.10.1+dfsg-1/src/cmake/externalpackages.cmake	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/cmake/externalpackages.cmake	2024-06-01 19:59:05.000000000 +0000
@@ -243,7 +243,8 @@ checked_find_package (OpenVDB
                       DEFINITIONS  -DUSE_OPENVDB=1)
 if (OpenVDB_FOUND AND OpenVDB_VERSION VERSION_GREATER_EQUAL 10.1 AND CMAKE_CXX_STANDARD VERSION_LESS 17)
     message (WARNING "${ColorYellow}OpenVDB >= 10.1 (we found ${OpenVDB_VERSION}) can only be used when we build with C++17 or higher. Disabling OpenVDB support.${ColorReset}")
-    set (OpeVDB_FOUND 0)
+    set (OpenVDB_FOUND 0)
+    add_compile_definitions(DISABLE_OPENVDB=1)
 endif ()
 
 checked_find_package (Ptex PREFER_CONFIG)
diff -pruN 2.5.10.1+dfsg-1/src/cmake/testing.cmake 2.5.12.0+dfsg-1/src/cmake/testing.cmake
--- 2.5.10.1+dfsg-1/src/cmake/testing.cmake	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/cmake/testing.cmake	2024-06-01 19:59:05.000000000 +0000
@@ -277,7 +277,7 @@ macro (oiio_add_all_tests)
                     IMAGEDIR j2kp4files_v1_5
                     URL http://www.itu.int/net/ITU-T/sigdb/speimage/ImageForm-s.aspx?val=10100803)
     set (all_openexr_tests
-         openexr-suite openexr-multires openexr-chroma
+         openexr-suite openexr-multires openexr-chroma openexr-decreasingy
          openexr-v2 openexr-window perchannel oiiotool-deep)
     if (USE_PYTHON AND NOT SANITIZE)
         list (APPEND all_openexr_tests openexr-copy)
diff -pruN 2.5.10.1+dfsg-1/src/dds.imageio/dds_pvt.h 2.5.12.0+dfsg-1/src/dds.imageio/dds_pvt.h
--- 2.5.10.1+dfsg-1/src/dds.imageio/dds_pvt.h	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/dds.imageio/dds_pvt.h	2024-06-01 19:59:05.000000000 +0000
@@ -27,11 +27,26 @@ namespace DDS_pvt {
 #define DDS_4CC_BC4U DDS_MAKE4CC('B', 'C', '4', 'U')
 #define DDS_4CC_BC5U DDS_MAKE4CC('B', 'C', '5', 'U')
 
+#define DDS_FORMAT_R10G10B10A2_UNORM 24
+#define DDS_FORMAT_R8G8B8A8_UNORM 28
+#define DDS_FORMAT_R8G8B8A8_UNORM_SRGB 29
+#define DDS_FORMAT_R16_UNORM 56
+#define DDS_FORMAT_BC1_UNORM 71
+#define DDS_FORMAT_BC1_UNORM_SRGB 72
+#define DDS_FORMAT_BC2_UNORM 74
+#define DDS_FORMAT_BC2_UNORM_SRGB 75
+#define DDS_FORMAT_BC3_UNORM 77
+#define DDS_FORMAT_BC3_UNORM_SRGB 78
 #define DDS_FORMAT_BC4_UNORM 80
 #define DDS_FORMAT_BC5_UNORM 83
+#define DDS_FORMAT_B8G8R8A8_UNORM 87
+#define DDS_FORMAT_B8G8R8X8_UNORM 88
+#define DDS_FORMAT_B8G8R8A8_UNORM_SRGB 91
+#define DDS_FORMAT_B8G8R8X8_UNORM_SRGB 93
 #define DDS_FORMAT_BC6H_UF16 95
 #define DDS_FORMAT_BC6H_SF16 96
 #define DDS_FORMAT_BC7_UNORM 98
+#define DDS_FORMAT_BC7_UNORM_SRGB 99
 
 enum class Compression {
     None,
diff -pruN 2.5.10.1+dfsg-1/src/dds.imageio/ddsinput.cpp 2.5.12.0+dfsg-1/src/dds.imageio/ddsinput.cpp
--- 2.5.10.1+dfsg-1/src/dds.imageio/ddsinput.cpp	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/dds.imageio/ddsinput.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -295,6 +295,71 @@ DecompressImage(uint8_t* rgba, int width
         opt);
 }
 
+/// Gets the bitmasks required to extract the channels of a DXGI format.
+/// Returns whether the DXGI format is supported.
+/// Compressed formats BCn are not handled by this function.
+///
+static bool
+GetDxgiFormatChannelMasks(uint32_t dxgiFormat, uint32_t masks[4])
+{
+    masks[0] = masks[1] = masks[2] = masks[3] = 0;
+
+    switch (dxgiFormat) {
+    case DDS_FORMAT_R16_UNORM: masks[0] = 0xFFFF; break;
+
+    case DDS_FORMAT_R10G10B10A2_UNORM:
+        masks[0] = 0x000003FF;
+        masks[1] = 0x000FFC00;
+        masks[2] = 0x3FF00000;
+        masks[3] = 0xC0000000;
+        break;
+
+    case DDS_FORMAT_R8G8B8A8_UNORM:
+    case DDS_FORMAT_R8G8B8A8_UNORM_SRGB:
+        masks[0] = 0x000000FF;
+        masks[1] = 0x0000FF00;
+        masks[2] = 0x00FF0000;
+        masks[3] = 0xFF000000;
+        break;
+
+    case DDS_FORMAT_B8G8R8A8_UNORM:
+    case DDS_FORMAT_B8G8R8A8_UNORM_SRGB:
+        masks[3] = 0xFF000000;
+        OIIO_FALLTHROUGH;
+    case DDS_FORMAT_B8G8R8X8_UNORM:
+    case DDS_FORMAT_B8G8R8X8_UNORM_SRGB:
+        masks[0] = 0x00FF0000;
+        masks[1] = 0x0000FF00;
+        masks[2] = 0x000000FF;
+        break;
+
+    default: return false;
+    }
+
+    return true;
+}
+
+/// Gets the bits-per-pixel of a DXGI format, or 0 if not supported.
+/// Compressed formats BCn are not handled by this function.
+///
+static uint32_t
+GetDxgiFormatBitsPerPixel(uint32_t dxgiFormat)
+{
+    switch (dxgiFormat) {
+    case DDS_FORMAT_R16_UNORM: return 16;
+
+    case DDS_FORMAT_R10G10B10A2_UNORM:
+    case DDS_FORMAT_R8G8B8A8_UNORM:
+    case DDS_FORMAT_R8G8B8A8_UNORM_SRGB:
+    case DDS_FORMAT_B8G8R8A8_UNORM:
+    case DDS_FORMAT_B8G8R8A8_UNORM_SRGB:
+    case DDS_FORMAT_B8G8R8X8_UNORM:
+    case DDS_FORMAT_B8G8R8X8_UNORM_SRGB: return 32;
+
+    default: return 0;
+    }
+}
+
 
 // Obligatory material to make this a recognizable imageio plugin:
 OIIO_PLUGIN_EXPORTS_BEGIN
@@ -390,13 +455,16 @@ DDSInput::open(const std::string& name,
     std::cerr << "[dds] mipmaps: " << m_dds.mipmaps << "\n";
     std::cerr << "[dds] fmt.size: " << m_dds.fmt.size << "\n";
     std::cerr << "[dds] fmt.flags: " << m_dds.fmt.flags << "\n";
-    
     std::cerr << "[dds] fmt.fourCC: " << ((char *)&m_dds.fmt.fourCC)[0]
                                       << ((char *)&m_dds.fmt.fourCC)[1]
                                       << ((char *)&m_dds.fmt.fourCC)[2]
                                       << ((char *)&m_dds.fmt.fourCC)[3]
                                       << " (" << m_dds.fmt.fourCC << ")\n";
     std::cerr << "[dds] fmt.bpp: " << m_dds.fmt.bpp << "\n";
+    std::cerr << "[dds] fmt.masks[0]: " << m_dds.fmt.masks[0] << "\n";
+    std::cerr << "[dds] fmt.masks[1]: " << m_dds.fmt.masks[1] << "\n";
+    std::cerr << "[dds] fmt.masks[2]: " << m_dds.fmt.masks[2] << "\n";
+    std::cerr << "[dds] fmt.masks[3]: " << m_dds.fmt.masks[3] << "\n";
     std::cerr << "[dds] caps.flags1: " << m_dds.caps.flags1 << "\n";
     std::cerr << "[dds] caps.flags2: " << m_dds.caps.flags2 << "\n";*/
 
@@ -432,6 +500,12 @@ DDSInput::open(const std::string& name,
     if (m_dds.fmt.fourCC == DDS_4CC_DX10) {
         if (!ioread(&m_dx10, sizeof(m_dx10), 1))
             return false;
+
+        /*std::cerr << "[dds:dx10] dxgiFormat: " << m_dx10.dxgiFormat << "\n";
+        std::cerr << "[dds:dx10] resourceDimension: " << m_dx10.resourceDimension << "\n";
+        std::cerr << "[dds:dx10] arraySize: " << m_dx10.arraySize << "\n";
+        std::cerr << "[dds:dx10] miscFlag: " << m_dx10.miscFlag << "\n";
+        std::cerr << "[dds:dx10] miscFlag2: " << m_dx10.miscFlag2 << "\n";*/
     }
 
     // validate the pixel format
@@ -453,6 +527,18 @@ DDSInput::open(const std::string& name,
         case DDS_4CC_BC5U: m_compression = Compression::BC5; break;
         case DDS_4CC_DX10: {
             switch (m_dx10.dxgiFormat) {
+            case DDS_FORMAT_BC1_UNORM:
+            case DDS_FORMAT_BC1_UNORM_SRGB:
+                m_compression = Compression::DXT1;
+                break;
+            case DDS_FORMAT_BC2_UNORM:
+            case DDS_FORMAT_BC2_UNORM_SRGB:
+                m_compression = Compression::DXT3;
+                break;
+            case DDS_FORMAT_BC3_UNORM:
+            case DDS_FORMAT_BC3_UNORM_SRGB:
+                m_compression = Compression::DXT5;
+                break;
             case DDS_FORMAT_BC4_UNORM: m_compression = Compression::BC4; break;
             case DDS_FORMAT_BC5_UNORM: m_compression = Compression::BC5; break;
             case DDS_FORMAT_BC6H_UF16:
@@ -461,12 +547,22 @@ DDSInput::open(const std::string& name,
             case DDS_FORMAT_BC6H_SF16:
                 m_compression = Compression::BC6HS;
                 break;
-            case DDS_FORMAT_BC7_UNORM: m_compression = Compression::BC7; break;
+            case DDS_FORMAT_BC7_UNORM:
+            case DDS_FORMAT_BC7_UNORM_SRGB:
+                m_compression = Compression::BC7;
+                break;
+
+            default:
+                if (!GetDxgiFormatChannelMasks(m_dx10.dxgiFormat,
+                                               m_dds.fmt.masks)) {
+                    errorfmt("Unsupported DXGI format: {}", m_dx10.dxgiFormat);
+                    return false;
+                }
+                break;
             }
         } break;
-        }
-        if (m_compression == Compression::None) {
-            errorf("Unsupported compression type");
+        default:
+            errorfmt("Unsupported compression type: {}", m_dds.fmt.fourCC);
             return false;
         }
     }
@@ -481,6 +577,20 @@ DDSInput::open(const std::string& name,
     if (m_compression != Compression::None) {
         m_nchans = GetChannelCount(m_compression,
                                    m_dds.fmt.flags & DDS_PF_NORMAL);
+    } else if (m_dds.fmt.fourCC == DDS_4CC_DX10) {
+        // uncompressed DXGI formats, calculate bytes per pixel and bit shifts
+        m_Bpp    = (GetDxgiFormatBitsPerPixel(m_dx10.dxgiFormat) + 7) >> 3;
+        m_nchans = 0;
+        for (int i = 0; i < 4; ++i) {
+            if (m_dds.fmt.masks[i] != 0) {
+                // place channels sequentially
+                m_dds.fmt.masks[m_nchans] = m_dds.fmt.masks[i];
+                m_nchans++;
+            }
+        }
+
+        for (int i = 0; i < m_nchans; ++i)
+            calc_shifts(m_dds.fmt.masks[i], m_BitCounts[i], m_RightShifts[i]);
     } else {
         // also calculate bytes per pixel and the bit shifts
         m_Bpp = (m_dds.fmt.bpp + 7) >> 3;
@@ -698,6 +808,7 @@ DDSInput::seek_subimage(int subimage, in
             m_spec.attribute("compression", str);
     }
 
+    uint32_t bpp = 0;
     if (m_dds.fmt.bpp
         && (m_dds.fmt.flags
             & (DDS_PF_RGB | DDS_PF_LUMINANCE | DDS_PF_YUV | DDS_PF_ALPHAONLY))) {
@@ -708,12 +819,34 @@ DDSInput::seek_subimage(int subimage, in
                 m_dds.fmt.bpp);
             return false;
         }
-        m_spec.attribute("oiio:BitsPerSample", m_dds.fmt.bpp);
+        bpp = m_dds.fmt.bpp;
+    } else if (m_dds.fmt.fourCC == DDS_4CC_DX10) {
+        bpp = GetDxgiFormatBitsPerPixel(m_dx10.dxgiFormat);
+    }
+
+    if (bpp != 0)
+        m_spec.attribute("oiio:BitsPerSample", bpp);
+
+    const char* colorspace = nullptr;
+
+    if (m_dds.fmt.fourCC == DDS_4CC_DX10) {
+        switch (m_dx10.dxgiFormat) {
+        case DDS_FORMAT_BC1_UNORM_SRGB:
+        case DDS_FORMAT_BC2_UNORM_SRGB:
+        case DDS_FORMAT_BC3_UNORM_SRGB:
+        case DDS_FORMAT_BC7_UNORM_SRGB:
+        case DDS_FORMAT_R8G8B8A8_UNORM_SRGB:
+        case DDS_FORMAT_B8G8R8A8_UNORM_SRGB:
+        case DDS_FORMAT_B8G8R8X8_UNORM_SRGB: colorspace = "sRGB"; break;
+        }
     }
 
     // linear color space for HDR-ish images
-    if (basetype == TypeDesc::HALF || basetype == TypeDesc::FLOAT)
-        m_spec.attribute("oiio:ColorSpace", "linear");
+    if (colorspace == nullptr
+        && (basetype == TypeDesc::HALF || basetype == TypeDesc::FLOAT))
+        colorspace = "linear";
+
+    m_spec.set_colorspace(colorspace);
 
     m_spec.default_channel_names();
     // Special case: if a 2-channel DDS RG or YA?
diff -pruN 2.5.10.1+dfsg-1/src/doc/builtinplugins.rst 2.5.12.0+dfsg-1/src/doc/builtinplugins.rst
--- 2.5.10.1+dfsg-1/src/doc/builtinplugins.rst	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/doc/builtinplugins.rst	2024-06-01 19:59:05.000000000 +0000
@@ -290,6 +290,9 @@ options are supported:
      - ptr
      - Pointer to a ``Filesystem::IOProxy`` that will handle the I/O, for
        example by reading from memory rather than the file system.
+   * - ``oiio:subimages``
+     - int
+     - The number of "image elements" (subimages) in the file.
 
 
 **Configuration settings for DPX output**
@@ -547,6 +550,9 @@ storage.  Currently, OpenImageIO only su
    * - ``Hierarch``
      - string
      - FITS "HIERARCH" (*)
+   * - ``oiio:subimages``
+     - int
+     - The number of subimages in the file.
    * - *other*
      - 
      - all other FITS keywords will be added to the ImageSpec as arbitrary
@@ -1216,6 +1222,10 @@ Apple M4V               :file:`.m4v`
 MPEG-1/MPEG-2           :file:`.mpg`
 =====================   ====================================================
 
+The format list include may other file types as well. We rely on the
+:program:`ffmpeg` library to read these files, so the actual list of supported
+formats may vary depending on the version of :program:`ffmpeg` that was linked
+into OpenImageIO.
 
 Currently, these files may only be read. Write support may be added in a
 future release.  Also, currently, these files simply look to OIIO like
@@ -1238,10 +1248,7 @@ Some special attributes are used for mov
      - Nonzero value for movie files
    * - ``oiio:subimages``
      - int
-     - The number of frames in the movie, positive if it can be known
-       without reading the entire file. Zero or not present if the number
-       of frames cannot be determinend from reading from just the file
-       header.
+     - The number of frames (subimages) in the movie.
    * - ``FramesPerSecond``
      - int[2] (rational)
      - Frames per second
@@ -1377,6 +1384,9 @@ The official OpenEXR site is http://www.
    * - ``captureRate``
      - int[2]
      - Frames per second capture rate (vecsemantics will be marked as RATIONAL)
+   * - ``oiio:subimages``
+     - int
+     - The number of "parts" (subimages) in the file.
    * - ``smpte:TimeCode``
      - int[2]
      - SMPTE time code (vecsemantics will be marked as TIMECODE)
@@ -1519,6 +1529,9 @@ report as tiled, using the leaf dimensio
    * - ``oiio:subimagename``
      - string
      - unique layer name
+   * - ``oiio:subimages``
+     - int
+     - The number of "layers" (subimages) in the file.
    * - ``openvdb:indextoworld``
      - matrix of doubles
      - conversion of voxel index to world space coordinates.
@@ -1678,22 +1691,38 @@ and :ref:`sec-imageinput-ioproxy`) as we
 PNM / Netpbm
 ===============================================
 
-The Netpbm project, a.k.a. PNM (portable "any" map) defines PBM, PGM,
-and PPM (portable bitmap, portable graymap, portable pixmap) files.
+The Netpbm project, a.k.a. PNM (portable "any" map) defines PBM, PGM, PPM
+and later added PFM (portable float map) as a set of simple image formats
+(portable bitmap, portable graymap, portable pixmap) files.
 Without loss of generality, we will refer to these all collectively as
-"PNM."  These files have extensions :file:`.pbm`, :file:`.pgm`, and
-:file:`.ppm` and customarily correspond to bi-level bitmaps, 1-channel
-grayscale, and 3-channel RGB files, respectively, or :file:`.pnm` for
-those who reject the nonsense about naming the files depending on the
+"PNM."  These files have extensions :file:`.pbm`, :file:`.pgm`,
+:file:`.ppm`, :file:`.pfm` and customarily correspond to bi-level bitmaps,
+1-channel grayscale, and 3-channel RGB files, respectively, or :file:`.pnm`
+for those who reject the nonsense about naming the files depending on the
 number of channels and bitdepth.
 
-PNM files are not much good for anything, but because of their
-historical significance and extreme simplicity (that causes many
-"amateur" programs to write images in these formats), OpenImageIO
-supports them.  PNM files do not support floating point images, anything
-other than 1 or 3 channels, no tiles, no multi-image, no MIPmapping.
-It's not a smart choice unless you are sending your images back to the
-1980's via a time machine.
+PNM files are widely used in the Unix world as simple ASCII or binary image 
+files that are easy to read and write. They are not compressed, and are
+not particularly efficient for large images. They are not widely used in
+the professional graphics world, but because of their historical
+significance and extreme simplicity, OpenImageIO supports them.
+PNM files do not support anything other than 1 or 3 channels, no tiles,
+no multi-image, no MIPmapping.
+
+The pbm, pgm, and ppm varieties are stored with scanlines ordered in the
+file as top-to-bottom (the same as the usual OIIO convention), but the
+float-based pfm files are conventionally ordered in the file as
+bottom-to-top. Therefore, by default, reading and writing of the pfm
+variety will automatically flip the image so that an application calling
+the OpenImageIO API can, as usual, assume that scanline 0 is the visual
+"top" (even though it is actually the last scanline stored in the file).
+
+Both the reader and writer accept configuration hints "pnm:pfmflip"
+(default: 1), which if set to 0 will disable this flipping and ensure
+that scanline 0 is written as the first in the file (therefore
+representing what PFM assumes is the visual "bottom" of the image).
+This hint only affects PFM files and has no effect on the pbm, pgm,
+or ppm varieties.
 
 **Attributes**
 
@@ -1731,6 +1760,16 @@ attributes are supported:
      - ptr
      - Pointer to a ``Filesystem::IOProxy`` that will handle the I/O, for
        example by reading from memory rather than the file system.
+   * - ``pnm:bigendian``
+     - int
+     - If nonzero, the PNM file is big-endian (the default is little-endian).  
+   * - ``pnm:pfmflip``
+      - int
+      - If this configuration hint is present and is zero, the automatic
+      vertical flipping of PFM image will be disabled (i.e., scanline 0 will
+      really be the first one stored in the file). If nonzero (the default),
+      float PFM files will store scanline 0 as the last scanline in the file
+      (i.e. the visual "top" of the image).
 
 **Configuration settings for PNM output**
 
@@ -1753,6 +1792,23 @@ control aspects of the writing itself:
      - ptr
      - Pointer to a ``Filesystem::IOProxy`` that will handle the I/O, for
        example by writing to a memory buffer.
+   * - ``pnm:bigendian``
+     - int
+     - If nonzero, the PNM file is big-endian (the default is little-endian).
+   * - ``pnm:binary``
+     - int
+     - nonzero if the file itself used the PNM binary format, 0 if it used
+       ASCII.  The PNM writer honors this attribute in the ImageSpec to
+       determine whether to write an ASCII or binary file.
+       Float PFM files are always written in binary format.
+   * - ``pnm:pfmflip``
+      - int
+      - If this configuration hint is present and is zero, for PFM files,
+      scanline 0 will really be stored first in the file, thus disabling the
+      usual automatically flipping that accounts for PFM files conventionally
+      being stored in bottom-to-top order. If nonzero (the default), float
+      PFM files will store scanline 0 as the last scanline in the file (i.e.
+      the visual "top" of the image).
 
 **Custom I/O Overrides**
 
diff -pruN 2.5.10.1+dfsg-1/src/dpx.imageio/dpxinput.cpp 2.5.12.0+dfsg-1/src/dpx.imageio/dpxinput.cpp
--- 2.5.10.1+dfsg-1/src/dpx.imageio/dpxinput.cpp	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/dpx.imageio/dpxinput.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -28,7 +28,7 @@ public:
     const char* format_name(void) const override { return "dpx"; }
     int supports(string_view feature) const override
     {
-        return (feature == "ioproxy");
+        return (feature == "ioproxy" || feature == "multiimage");
     }
     bool valid_file(Filesystem::IOProxy* ioproxy) const override;
     bool open(const std::string& name, ImageSpec& newspec) override;
@@ -297,6 +297,8 @@ DPXInput::seek_subimage(int subimage, in
     }
     m_spec.attribute("Orientation", orientation);
 
+    m_spec.attribute("oiio:subimages", (int)m_dpx.header.ImageElementCount());
+
     // image linearity
     switch (m_dpx.header.Transfer(subimage)) {
     case dpx::kLinear: m_spec.attribute("oiio:ColorSpace", "Linear"); break;
diff -pruN 2.5.10.1+dfsg-1/src/ffmpeg.imageio/ffmpeginput.cpp 2.5.12.0+dfsg-1/src/ffmpeg.imageio/ffmpeginput.cpp
--- 2.5.10.1+dfsg-1/src/ffmpeg.imageio/ffmpeginput.cpp	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/ffmpeg.imageio/ffmpeginput.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -90,6 +90,10 @@ public:
     FFmpegInput();
     ~FFmpegInput() override;
     const char* format_name(void) const override { return "FFmpeg movie"; }
+    int supports(string_view feature) const override
+    {
+        return (feature == "multiimage");
+    }
     bool valid_file(const std::string& name) const override;
     bool open(const std::string& name, ImageSpec& spec) override;
     bool close(void) override;
diff -pruN 2.5.10.1+dfsg-1/src/fits.imageio/fits_pvt.h 2.5.12.0+dfsg-1/src/fits.imageio/fits_pvt.h
--- 2.5.10.1+dfsg-1/src/fits.imageio/fits_pvt.h	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/fits.imageio/fits_pvt.h	2024-06-01 19:59:05.000000000 +0000
@@ -44,8 +44,9 @@ public:
     int supports(string_view feature) const override
     {
         return (feature == "arbitrary_metadata"
-                || feature == "exif"     // Because of arbitrary_metadata
-                || feature == "iptc"     // Because of arbitrary_metadata
+                || feature == "exif"  // Because of arbitrary_metadata
+                || feature == "iptc"  // Because of arbitrary_metadata
+                || feature == "multiimage"
                 || feature == "noimage"  // allow metadata only, no pixels
         );
     }
diff -pruN 2.5.10.1+dfsg-1/src/fits.imageio/fitsinput.cpp 2.5.12.0+dfsg-1/src/fits.imageio/fitsinput.cpp
--- 2.5.10.1+dfsg-1/src/fits.imageio/fitsinput.cpp	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/fits.imageio/fitsinput.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -336,6 +336,8 @@ FitsInput::read_fits_header(void)
     m_spec.full_height = m_spec.height;
     m_spec.full_depth  = m_spec.depth;
 
+    m_spec.attribute("oiio:subimages", (int)m_subimages.size());
+
     // if (m_spec.width < 1 || m_spec.height < 1 || m_spec.depth < 1 ||
     //     m_spec.nchannels < 1) {
     //     errorf("Don't know now to read empty (0 pixel) FITS image");
diff -pruN 2.5.10.1+dfsg-1/src/gif.imageio/gifinput.cpp 2.5.12.0+dfsg-1/src/gif.imageio/gifinput.cpp
--- 2.5.10.1+dfsg-1/src/gif.imageio/gifinput.cpp	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/gif.imageio/gifinput.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -41,7 +41,7 @@ public:
     const char* format_name(void) const override { return "gif"; }
     int supports(string_view feature) const override
     {
-        return feature == "ioproxy";
+        return (feature == "ioproxy" || feature == "multiimage");
     }
     bool open(const std::string& name, ImageSpec& newspec) override;
     bool open(const std::string& name, ImageSpec& newspec,
diff -pruN 2.5.10.1+dfsg-1/src/ico.imageio/icoinput.cpp 2.5.12.0+dfsg-1/src/ico.imageio/icoinput.cpp
--- 2.5.10.1+dfsg-1/src/ico.imageio/icoinput.cpp	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/ico.imageio/icoinput.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -27,7 +27,7 @@ public:
     const char* format_name(void) const override { return "ico"; }
     int supports(string_view feature) const override
     {
-        return feature == "ioproxy";
+        return (feature == "ioproxy" || feature == "multiimage");
     }
     bool open(const std::string& name, ImageSpec& newspec) override;
     bool open(const std::string& name, ImageSpec& newspec,
diff -pruN 2.5.10.1+dfsg-1/src/include/OpenImageIO/detail/fmt.h 2.5.12.0+dfsg-1/src/include/OpenImageIO/detail/fmt.h
--- 2.5.10.1+dfsg-1/src/include/OpenImageIO/detail/fmt.h	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/include/OpenImageIO/detail/fmt.h	2024-06-01 19:59:05.000000000 +0000
@@ -23,8 +23,9 @@
 // gcc 11+ compiler bug triggered by the definition of FMT_THROW in fmt 10.1+
 // when FMT_EXCEPTIONS=0, which results in mangling SIMD math. This nugget
 // below works around the problems for hard to understand reasons.
-#if !defined(FMT_THROW) && OIIO_GNUC_VERSION >= 110000
-#    define FMT_THROW(x) OIIO_ASSERT_MSG(0, "fmt exception: %s", (x).what())
+#if !defined(FMT_THROW) && !FMT_EXCEPTIONS && OIIO_GNUC_VERSION >= 110000
+#    define FMT_THROW(x) \
+        OIIO_ASSERT_MSG(0, "fmt exception: %s", (x).what()), std::terminate()
 #endif
 
 // Use the grisu fast floating point formatting for old fmt versions
@@ -47,6 +48,7 @@
 #    define FMT_USE_FLOAT128 0
 #endif
 
+// Suppress certain warnings generated in the fmt headers themselves
 OIIO_PRAGMA_WARNING_PUSH
 #if OIIO_GNUC_VERSION >= 70000
 #    pragma GCC diagnostic ignored "-Wmaybe-uninitialized"
@@ -57,6 +59,9 @@ OIIO_PRAGMA_WARNING_PUSH
 #if OIIO_INTEL_LLVM_COMPILER
 #    pragma GCC diagnostic ignored "-Wtautological-constant-compare"
 #endif
+#if OIIO_CLANG_VERSION >= 180000
+#    pragma clang diagnostic ignored "-Wdeprecated-declarations"
+#endif
 
 #include <OpenImageIO/detail/fmt/format.h>
 #include <OpenImageIO/detail/fmt/ostream.h>
diff -pruN 2.5.10.1+dfsg-1/src/include/OpenImageIO/fmath.h 2.5.12.0+dfsg-1/src/include/OpenImageIO/fmath.h
--- 2.5.10.1+dfsg-1/src/include/OpenImageIO/fmath.h	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/include/OpenImageIO/fmath.h	2024-06-01 19:59:05.000000000 +0000
@@ -2054,7 +2054,7 @@ template<typename T>
 OIIO_FORCEINLINE OIIO_HOSTDEVICE T fast_exp2 (const T& xval) {
     using namespace simd;
     typedef typename T::vint_t intN;
-#if OIIO_SIMD_SSE
+#if OIIO_SIMD_SSE || OIIO_SIMD_NEON
     // See float specialization for explanations
     T x = clamp (xval, T(-126.0f), T(126.0f));
     intN m (x); x -= T(m);
diff -pruN 2.5.10.1+dfsg-1/src/include/OpenImageIO/imagebuf.h 2.5.12.0+dfsg-1/src/include/OpenImageIO/imagebuf.h
--- 2.5.10.1+dfsg-1/src/include/OpenImageIO/imagebuf.h	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/include/OpenImageIO/imagebuf.h	2024-06-01 19:59:05.000000000 +0000
@@ -890,9 +890,16 @@ public:
     /// contained only one image.
     int subimage() const;
 
-    /// Return the number of subimages in the file this ImageBuf refers to.
-    /// This will always be 1 for an ImageBuf that was not constructed as a
-    /// direct reference to a file.
+    /// Return the number of subimages in the file this ImageBuf refers to, if
+    /// it can be determined efficiently. This will always be 1 for an
+    /// ImageBuf that was not constructed as a direct reference to a file, or
+    /// for an ImageBuf that refers to a file type that is not capable of
+    /// containing multiple subimages.
+    ///
+    /// Note that a return value of 0 indicates that the number of subimages
+    /// cannot easily be known without reading the entire image file to
+    /// discover the total. To compute this yourself, you would need check
+    /// every subimage successively until you get an error.
     int nsubimages() const;
 
     /// Return the index of the miplevel with a file's subimage that the
diff -pruN 2.5.10.1+dfsg-1/src/include/OpenImageIO/imageio.h 2.5.12.0+dfsg-1/src/include/OpenImageIO/imageio.h
--- 2.5.10.1+dfsg-1/src/include/OpenImageIO/imageio.h	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/include/OpenImageIO/imageio.h	2024-06-01 19:59:05.000000000 +0000
@@ -1003,6 +1003,11 @@ public:
     ///       Does this format reader support retrieving a reduced
     ///       resolution copy of the image via the `thumbnail()` method?
     ///
+    ///  - `"multiimage"` :
+    ///       Does this format support multiple subimages within a file?
+    ///       (Note: this doesn't necessarily mean that the particular
+    ///       file this ImageInput is reading has multiple subimages.)
+    ///
     ///  - `"noimage"` :
     ///        Does this format allow 0x0 sized images, i.e. an image file
     ///        with metadata only and no pixels?
diff -pruN 2.5.10.1+dfsg-1/src/include/OpenImageIO/simd.h 2.5.12.0+dfsg-1/src/include/OpenImageIO/simd.h
--- 2.5.10.1+dfsg-1/src/include/OpenImageIO/simd.h	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/include/OpenImageIO/simd.h	2024-06-01 19:59:05.000000000 +0000
@@ -5716,7 +5716,7 @@ OIIO_FORCEINLINE vint8 bitcast_to_int (c
 #if OIIO_SIMD_AVX
     return _mm256_castps_si256 (x.simd());
 #else
-    return *(vint8 *)&x;
+    return vint8(bitcast_to_int(x.lo()), bitcast_to_int(x.hi()));
 #endif
 }
 
@@ -7763,9 +7763,9 @@ OIIO_FORCEINLINE vfloat4 andnot (const v
 #if OIIO_SIMD_SSE
     return _mm_andnot_ps (a.simd(), b.simd());
 #else
-    const int *ai = (const int *)&a;
-    const int *bi = (const int *)&b;
-    return bitcast_to_float (vint4(~(ai[0]) & bi[0],
+    vint4 ai = bitcast_to_int(a);
+    vint4 bi = bitcast_to_int(b);
+    return bitcast_to_float(vint4(~(ai[0]) & bi[0],
                                   ~(ai[1]) & bi[1],
                                   ~(ai[2]) & bi[2],
                                   ~(ai[3]) & bi[3]));
@@ -9200,7 +9200,7 @@ OIIO_FORCEINLINE vint8 bitcast_to_int (c
 #if OIIO_SIMD_AVX
     return _mm256_castps_si256 (x.simd());
 #else
-    return *(vint8 *)&x;
+    return vint8(bitcast_to_int(x.lo()), bitcast_to_int(x.hi()));
 #endif
 }
 
@@ -9209,7 +9209,7 @@ OIIO_FORCEINLINE vfloat8 bitcast_to_floa
 #if OIIO_SIMD_AVX
     return _mm256_castsi256_ps (x.simd());
 #else
-    return *(vfloat8 *)&x;
+    return vfloat8(bitcast_to_float(x.lo()), bitcast_to_float(x.hi()));
 #endif
 }
 
@@ -9438,9 +9438,9 @@ OIIO_FORCEINLINE vfloat8 andnot (const v
 #if OIIO_SIMD_AVX
     return _mm256_andnot_ps (a.simd(), b.simd());
 #else
-    const int *ai = (const int *)&a;
-    const int *bi = (const int *)&b;
-    return bitcast_to_float (vint8(~(ai[0]) & bi[0],
+    vint8 ai = bitcast_to_int(a);
+    vint8 bi = bitcast_to_int(b);
+    return bitcast_to_float(vint8(~(ai[0]) & bi[0],
                                   ~(ai[1]) & bi[1],
                                   ~(ai[2]) & bi[2],
                                   ~(ai[3]) & bi[3],
@@ -10073,7 +10073,7 @@ OIIO_FORCEINLINE vint16 bitcast_to_int (
 #if OIIO_SIMD_AVX >= 512
     return _mm512_castps_si512 (x.simd());
 #else
-    return *(vint16 *)&x;
+    return vint16(bitcast_to_int(x.lo()), bitcast_to_int(x.hi()));
 #endif
 }
 
@@ -10082,7 +10082,7 @@ OIIO_FORCEINLINE vfloat16 bitcast_to_flo
 #if OIIO_SIMD_AVX >= 512
     return _mm512_castsi512_ps (x.simd());
 #else
-    return *(vfloat16 *)&x;
+    return vfloat16(bitcast_to_float(x.lo()), bitcast_to_float(x.hi()));
 #endif
 }
 
diff -pruN 2.5.10.1+dfsg-1/src/include/OpenImageIO/strutil.h 2.5.12.0+dfsg-1/src/include/OpenImageIO/strutil.h
--- 2.5.10.1+dfsg-1/src/include/OpenImageIO/strutil.h	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/include/OpenImageIO/strutil.h	2024-06-01 19:59:05.000000000 +0000
@@ -1155,6 +1155,19 @@ OIIO_UTIL_API size_t
 edit_distance(string_view a, string_view b,
               EditDistMetric metric = EditDistMetric::Levenshtein);
 
+
+/// Evaluate a string as a boolean value using the following heuristic:
+///   - If the string is a valid numeric value (represents an integer or
+///     floating point value), return true if it's non-zero, false if it's
+///     zero.
+///   - If the string is one of "false", "no", or "off", or if it contains
+///     only whitespace, return false.
+///   - All other non-empty strings return true.
+/// The comparisons are case-insensitive and ignore leading and trailing
+/// whitespace.
+OIIO_UTIL_API bool
+eval_as_bool(string_view value);
+
 }  // namespace Strutil
 
 
diff -pruN 2.5.10.1+dfsg-1/src/libOpenImageIO/imagebuf.cpp 2.5.12.0+dfsg-1/src/libOpenImageIO/imagebuf.cpp
--- 2.5.10.1+dfsg-1/src/libOpenImageIO/imagebuf.cpp	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/libOpenImageIO/imagebuf.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -1054,6 +1054,9 @@ ImageBufImpl::init_spec(string_view file
         m_blackpixel.resize(
             round_to_multiple(m_xstride, OIIO_SIMD_MAX_SIZE_BYTES));
         // ^^^ NB make it big enough for SIMD
+        m_nsubimages = input->supports("multiimage")
+                           ? m_spec.get_int_attribute("oiio:subimages")
+                           : 1;
 
         // Go ahead and read any thumbnail that exists. Is that bad?
         if (m_spec["thumbnail_width"].get<int>()
@@ -1415,8 +1418,23 @@ ImageBuf::write(ImageOutput* out, Progre
             int chunk = clamp(round_to_multiple(int(budget / slsize), 64), 1,
                               1024);
             std::unique_ptr<char[]> tmp(new char[chunk * slsize]);
+
+            // Special handling for flipped vertical scanline order. Right now, OpenEXR
+            // is the only format that allows it, so we special case it by name. For
+            // just one format, trying to be more general just seems even more awkward.
+            const bool isDecreasingY = !strcmp(out->format_name(), "openexr")
+                                       && outspec.get_string_attribute(
+                                              "openexr:lineOrder")
+                                              == "decreasingY";
+            const int numChunks  = outspec.height > 0
+                                       ? 1 + ((outspec.height - 1) / chunk)
+                                       : 0;
+            const int yLoopStart = isDecreasingY ? (numChunks - 1) * chunk : 0;
+            const int yDelta     = isDecreasingY ? -chunk : chunk;
+            const int yLoopEnd   = yLoopStart + numChunks * yDelta;
+
             for (int z = 0; z < outspec.depth; ++z) {
-                for (int y = 0; y < outspec.height && ok; y += chunk) {
+                for (int y = yLoopStart; y != yLoopEnd && ok; y += yDelta) {
                     int yend = std::min(y + outspec.y + chunk,
                                         outspec.y + outspec.height);
                     ok &= get_pixels(ROI(outspec.x, outspec.x + outspec.width,
@@ -1427,10 +1445,12 @@ ImageBuf::write(ImageOutput* out, Progre
                                                z + outspec.z, bufformat,
                                                &tmp[0]);
                     if (progress_callback
-                        && progress_callback(progress_callback_data,
-                                             (float)(z * outspec.height + y)
-                                                 / (outspec.height
-                                                    * outspec.depth)))
+                        && progress_callback(
+                            progress_callback_data,
+                            (float)(z * outspec.height
+                                    + (isDecreasingY ? (outspec.height - 1 - y)
+                                                     : y))
+                                / (outspec.height * outspec.depth)))
                         return ok;
                 }
             }
diff -pruN 2.5.10.1+dfsg-1/src/libOpenImageIO/imagebufalgo_draw.cpp 2.5.12.0+dfsg-1/src/libOpenImageIO/imagebufalgo_draw.cpp
--- 2.5.10.1+dfsg-1/src/libOpenImageIO/imagebufalgo_draw.cpp	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/libOpenImageIO/imagebufalgo_draw.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -883,7 +883,7 @@ static FT_Library ft_library = NULL;
 static bool ft_broken        = false;
 
 static const char* default_font_name[] = { "DroidSans", "cour", "Courier New",
-                                           "FreeMono", nullptr };
+                                           "FreeMono" };
 
 
 
diff -pruN 2.5.10.1+dfsg-1/src/libOpenImageIO/imageioplugin.cpp 2.5.12.0+dfsg-1/src/libOpenImageIO/imageioplugin.cpp
--- 2.5.10.1+dfsg-1/src/libOpenImageIO/imageioplugin.cpp	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/libOpenImageIO/imageioplugin.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -461,12 +461,6 @@ pvt::catalog_all_plugins(std::string sea
 
     std::unique_lock<std::recursive_mutex> lock(imageio_mutex);
     append_if_env_exists(searchpath, "OIIO_LIBRARY_PATH", true);
-#ifdef __APPLE__
-    append_if_env_exists(searchpath, "DYLD_LIBRARY_PATH");
-#endif
-#if defined(__linux__) || defined(__FreeBSD__)
-    append_if_env_exists(searchpath, "LD_LIBRARY_PATH");
-#endif
 
     size_t patlen = pattern.length();
     std::vector<std::string> dirs;
diff -pruN 2.5.10.1+dfsg-1/src/libOpenImageIO/imageoutput.cpp 2.5.12.0+dfsg-1/src/libOpenImageIO/imageoutput.cpp
--- 2.5.10.1+dfsg-1/src/libOpenImageIO/imageoutput.cpp	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/libOpenImageIO/imageoutput.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -518,17 +518,34 @@ ImageOutput::write_image(TypeDesc format
         int rps   = m_spec.get_int_attribute("tiff:RowsPerStrip", 64);
         int chunk = std::max(1, (1 << 26) / int(m_spec.scanline_bytes(true)));
         chunk     = round_to_multiple(chunk, rps);
+
+        // Special handling for flipped vertical scanline order. Right now, OpenEXR
+        // is the only format that allows it, so we special case it by name. For
+        // just one format, trying to be more general just seems even more awkward.
+        const bool isDecreasingY = !strcmp(format_name(), "openexr")
+                                   && m_spec.get_string_attribute(
+                                          "openexr:lineOrder")
+                                          == "decreasingY";
+        const int numChunks  = m_spec.height > 0
+                                   ? 1 + ((m_spec.height - 1) / chunk)
+                                   : 0;
+        const int yLoopStart = isDecreasingY ? (numChunks - 1) * chunk : 0;
+        const int yDelta     = isDecreasingY ? -chunk : chunk;
+        const int yLoopEnd   = yLoopStart + numChunks * yDelta;
+
         for (int z = 0; z < m_spec.depth; ++z)
-            for (int y = 0; y < m_spec.height && ok; y += chunk) {
+            for (int y = yLoopStart; y != yLoopEnd && ok; y += yDelta) {
                 int yend      = std::min(y + m_spec.y + chunk,
                                          m_spec.y + m_spec.height);
                 const char* d = (const char*)data + z * zstride + y * ystride;
                 ok &= write_scanlines(y + m_spec.y, yend, z + m_spec.z, format,
                                       d, xstride, ystride);
                 if (progress_callback
-                    && progress_callback(progress_callback_data,
-                                         (float)(z * m_spec.height + y)
-                                             / (m_spec.height * m_spec.depth)))
+                    && progress_callback(
+                        progress_callback_data,
+                        (float)(z * m_spec.height
+                                + (isDecreasingY ? (m_spec.height - 1 - y) : y))
+                            / (m_spec.height * m_spec.depth)))
                     return ok;
             }
     }
diff -pruN 2.5.10.1+dfsg-1/src/libtexture/imagecache_pvt.h 2.5.12.0+dfsg-1/src/libtexture/imagecache_pvt.h
--- 2.5.10.1+dfsg-1/src/libtexture/imagecache_pvt.h	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/libtexture/imagecache_pvt.h	2024-06-01 19:59:05.000000000 +0000
@@ -368,11 +368,16 @@ private:
     bool m_broken;                 ///< has errors; can't be used properly
     bool m_allow_release = true;   ///< Allow the file to release()?
     std::string m_broken_message;  ///< Error message for why it's broken
+#if __cpp_lib_atomic_shared_ptr >= 201711L /* C++20 has atomic<shared_pr> */
+    // Open ImageInput, NULL if closed
+    std::atomic<std::shared_ptr<ImageInput>> m_input;
+#else
     std::shared_ptr<ImageInput> m_input;  ///< Open ImageInput, NULL if closed
         // Note that m_input, the shared pointer itself, is NOT safe to
         // access directly. ALWAYS retrieve its value with get_imageinput
         // (it's thread-safe to use that result) and set its value with
         // set_imageinput -- those are guaranteed thread-safe.
+#endif
     std::vector<SubimageInfo> m_subimages;  ///< Info on each subimage
     TexFormat m_texformat;                  ///< Which texture format
     TextureOpt::Wrap m_swrap;               ///< Default wrap modes
diff -pruN 2.5.10.1+dfsg-1/src/libutil/plugin.cpp 2.5.12.0+dfsg-1/src/libutil/plugin.cpp
--- 2.5.10.1+dfsg-1/src/libutil/plugin.cpp	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/libutil/plugin.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -2,11 +2,18 @@
 // SPDX-License-Identifier: Apache-2.0
 // https://github.com/AcademySoftwareFoundation/OpenImageIO
 
+#include <OpenImageIO/platform.h>
+
+OIIO_PRAGMA_WARNING_PUSH
+OIIO_CLANG_PRAGMA(clang diagnostic ignored "-Wdeprecated-declarations")
+// Force include of locale header with deprecated warnings turned off to
+// combat clang18 vs unicode deprecation warnings.
+#include <locale>
+OIIO_PRAGMA_WARNING_POP
+
 #include <cstdlib>
 #include <string>
 
-#include <OpenImageIO/platform.h>
-
 #ifdef _WIN32
 #    include <windows.h>
 #else
diff -pruN 2.5.10.1+dfsg-1/src/libutil/strutil.cpp 2.5.12.0+dfsg-1/src/libutil/strutil.cpp
--- 2.5.10.1+dfsg-1/src/libutil/strutil.cpp	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/libutil/strutil.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -3,15 +3,24 @@
 // https://github.com/AcademySoftwareFoundation/OpenImageIO
 
 
-#include <cmath>
+#include <OpenImageIO/platform.h>
+
+// Special dance to disable warnings in the included files related to
+// the deprecation of unicode conversion functions.
+OIIO_PRAGMA_WARNING_PUSH
+OIIO_CLANG_PRAGMA(clang diagnostic ignored "-Wdeprecated-declarations")
 #include <codecvt>
+#include <locale>
+OIIO_PRAGMA_WARNING_POP
+
+#include <algorithm>
+#include <cmath>
 #include <cstdarg>
 #include <cstdint>
 #include <cstdlib>
 #include <ctime>
 #include <iostream>
 #include <limits>
-#include <locale>
 #include <mutex>
 #include <numeric>
 #include <sstream>
@@ -25,7 +34,6 @@
 #include <boost/algorithm/string/find.hpp>
 
 #include <OpenImageIO/dassert.h>
-#include <OpenImageIO/platform.h>
 #include <OpenImageIO/string_view.h>
 #include <OpenImageIO/strutil.h>
 #include <OpenImageIO/thread.h>
@@ -1853,4 +1861,30 @@ Strutil::edit_distance(string_view a, st
     return levenshtein_distance(a, b);
 }
 
+
+
+/// Interpret a string as a boolean value using the following heuristic:
+///   - If the string is a valid numeric value (represents an integer or
+///     floating point value), return true if it's non-zero, false if it's
+///     zero.
+///   - If the string is one of "false", "no", or "off", or if it contains
+///     only whitespace, return false.
+///   - All other non-empty strings return true.
+/// The comparisons are case-insensitive and ignore leading and trailing
+/// whitespace.
+bool
+Strutil::eval_as_bool(string_view value)
+{
+    Strutil::trim_whitespace(value);
+    if (Strutil::string_is_int(value)) {
+        return Strutil::stoi(value) != 0;
+    } else if (Strutil::string_is_float(value)) {
+        return Strutil::stof(value) != 0.0f;
+    } else {
+        return !(value.empty() || Strutil::iequals(value, "false")
+                 || Strutil::iequals(value, "no")
+                 || Strutil::iequals(value, "off"));
+    }
+}
+
 OIIO_NAMESPACE_END
diff -pruN 2.5.10.1+dfsg-1/src/libutil/strutil_test.cpp 2.5.12.0+dfsg-1/src/libutil/strutil_test.cpp
--- 2.5.10.1+dfsg-1/src/libutil/strutil_test.cpp	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/libutil/strutil_test.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -1673,6 +1673,53 @@ test_base64_encode()
 
 
 
+void
+test_eval_as_bool()
+{
+    using namespace Strutil;
+    print("testing eval_as_bool()\n");
+
+    // Test cases for integer values
+    OIIO_CHECK_EQUAL(eval_as_bool("0"), false);
+    OIIO_CHECK_EQUAL(eval_as_bool("1"), true);
+    OIIO_CHECK_EQUAL(eval_as_bool("-1"), true);
+    OIIO_CHECK_EQUAL(eval_as_bool("10"), true);
+    OIIO_CHECK_EQUAL(eval_as_bool("-10"), true);
+
+    // Test cases for floating-point values
+    OIIO_CHECK_EQUAL(eval_as_bool("0.0"), false);
+    OIIO_CHECK_EQUAL(eval_as_bool("1.0"), true);
+    OIIO_CHECK_EQUAL(eval_as_bool("-1.0"), true);
+    OIIO_CHECK_EQUAL(eval_as_bool("10.5"), true);
+    OIIO_CHECK_EQUAL(eval_as_bool("-10.5"), true);
+
+    // Test cases for string values
+    OIIO_CHECK_EQUAL(eval_as_bool(""), false);
+    OIIO_CHECK_EQUAL(eval_as_bool("false"), false);
+    OIIO_CHECK_EQUAL(eval_as_bool("FALSE"), false);
+    OIIO_CHECK_EQUAL(eval_as_bool("no"), false);
+    OIIO_CHECK_EQUAL(eval_as_bool("NO"), false);
+    OIIO_CHECK_EQUAL(eval_as_bool("off"), false);
+    OIIO_CHECK_EQUAL(eval_as_bool("OFF"), false);
+
+    OIIO_CHECK_EQUAL(eval_as_bool("true"), true);
+    OIIO_CHECK_EQUAL(eval_as_bool("TRUE"), true);
+    OIIO_CHECK_EQUAL(eval_as_bool("yes"), true);
+    OIIO_CHECK_EQUAL(eval_as_bool("YES"), true);
+    OIIO_CHECK_EQUAL(eval_as_bool("on"), true);
+    OIIO_CHECK_EQUAL(eval_as_bool("ON"), true);
+    OIIO_CHECK_EQUAL(eval_as_bool("OpenImageIO"), true);
+
+    // Test whitespace, case insensitivity, other tricky cases
+    OIIO_CHECK_EQUAL(eval_as_bool("   "), false);
+    OIIO_CHECK_EQUAL(eval_as_bool("\t \n"), false);
+    OIIO_CHECK_EQUAL(eval_as_bool(" faLsE"), false);
+    OIIO_CHECK_EQUAL(eval_as_bool("\tOFf"), false);
+    OIIO_CHECK_EQUAL(eval_as_bool("off OpenImageIO"), true);
+}
+
+
+
 int
 main(int /*argc*/, char* /*argv*/[])
 {
@@ -1708,6 +1755,7 @@ main(int /*argc*/, char* /*argv*/[])
     test_datetime();
     test_edit_distance();
     test_base64_encode();
+    test_eval_as_bool();
 
     Strutil::debug("debug message\n");
 
diff -pruN 2.5.10.1+dfsg-1/src/oiiotool/expressions.cpp 2.5.12.0+dfsg-1/src/oiiotool/expressions.cpp
--- 2.5.10.1+dfsg-1/src/oiiotool/expressions.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/oiiotool/expressions.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -0,0 +1,547 @@
+// Copyright Contributors to the OpenImageIO project.
+// SPDX-License-Identifier: BSD-3-Clause and Apache-2.0
+// https://github.com/AcademySoftwareFoundation/OpenImageIO
+
+
+#include <algorithm>
+#include <numeric>
+#include <sstream>
+#include <string>
+
+#include "oiiotool.h"
+
+#include <OpenImageIO/filesystem.h>
+#include <OpenImageIO/imagebufalgo.h>
+
+
+using namespace OIIO;
+using namespace OiioTool;
+
+
+
+void
+Oiiotool::express_error(const string_view expr, const string_view s,
+                        string_view explanation)
+{
+    int offset = expr.rfind(s) + 1;
+    errorfmt("expression", "{} at char {} of '{}'", explanation, offset, expr);
+}
+
+
+
+// If str starts with what looks like a function call "name(" (allowing for
+// whitespace before the paren), eat those chars from str and return true.
+// Otherwise return false and leave str unchanged.
+inline bool
+parse_function_start_if(string_view& str, string_view name)
+{
+    string_view s = str;
+    if (Strutil::parse_identifier_if(s, name) && Strutil::parse_char(s, '(')) {
+        str = s;
+        return true;
+    }
+    return false;
+}
+
+
+
+bool
+Oiiotool::express_parse_atom(const string_view expr, string_view& s,
+                             std::string& result)
+{
+    // print(" Entering express_parse_atom, s='{}'\n", s);
+
+    string_view orig = s;
+    float floatval;
+
+    Strutil::skip_whitespace(s);
+
+    // handle + - ! prefixes
+    bool negative = false;
+    bool invert   = false;
+    while (s.size()) {
+        if (Strutil::parse_char(s, '-')) {
+            negative = !negative;
+        } else if (Strutil::parse_char(s, '+')) {
+            // no op
+        } else if (Strutil::parse_char(s, '!')) {
+            invert = !invert;
+        } else {
+            break;
+        }
+    }
+
+    if (Strutil::parse_char(s, '(')) {
+        // handle parentheses
+        if (express_parse_summands(expr, s, result)) {
+            if (!Strutil::parse_char(s, ')')) {
+                express_error(expr, s, "missing `)'");
+                result = orig;
+                return false;
+            }
+        } else {
+            result = orig;
+            return false;
+        }
+
+    } else if (parse_function_start_if(s, "getattribute")) {
+        // "{getattribute(name)}" retrieves global attribute `name`
+        bool ok = true;
+        Strutil::skip_whitespace(s);
+        string_view name;
+        if (s.size() && (s.front() == '\"' || s.front() == '\''))
+            ok = Strutil::parse_string(s, name);
+        else {
+            name = Strutil::parse_until(s, ")");
+        }
+        if (name.size()) {
+            std::string rs;
+            int ri;
+            float rf;
+            if (OIIO::getattribute(name, rs))
+                result = rs;
+            else if (OIIO::getattribute(name, ri))
+                result = Strutil::to_string(ri);
+            else if (OIIO::getattribute(name, rf))
+                result = Strutil::to_string(rf);
+            else
+                ok = false;
+        }
+        return Strutil::parse_char(s, ')') && ok;
+    } else if (parse_function_start_if(s, "var")) {
+        // "{var(name)}" retrieves user variable `name`
+        bool ok = true;
+        Strutil::skip_whitespace(s);
+        string_view name;
+        if (s.size() && (s.front() == '\"' || s.front() == '\''))
+            ok = Strutil::parse_string(s, name);
+        else {
+            name = Strutil::parse_until(s, ")");
+        }
+        if (name.size()) {
+            result = uservars[name];
+        }
+        return Strutil::parse_char(s, ')') && ok;
+    } else if (parse_function_start_if(s, "eq")) {
+        std::string left, right;
+        bool ok = express_parse_atom(s, s, left) && Strutil::parse_char(s, ',');
+        ok &= express_parse_atom(s, s, right) && Strutil::parse_char(s, ')');
+        result = left == right ? "1" : "0";
+        // Strutil::print("eq: left='{}', right='{}' ok={} result={}\n", left,
+        //                right, ok, result);
+        if (!ok)
+            return false;
+    } else if (parse_function_start_if(s, "neq")) {
+        std::string left, right;
+        bool ok = express_parse_atom(s, s, left) && Strutil::parse_char(s, ',');
+        ok &= express_parse_atom(s, s, right) && Strutil::parse_char(s, ')');
+        result = left != right ? "1" : "0";
+        // Strutil::print("neq: left='{}', right='{}' ok={} result={}\n", left,
+        //                right, ok, result);
+        if (!ok)
+            return false;
+    } else if (parse_function_start_if(s, "not")) {
+        std::string val;
+        bool ok = express_parse_summands(s, s, val)
+                  && Strutil::parse_char(s, ')');
+        result = Strutil::eval_as_bool(val) ? "0" : "1";
+        if (!ok)
+            return false;
+
+    } else if (Strutil::starts_with(s, "TOP")
+               || Strutil::starts_with(s, "IMG[")) {
+        // metadata substitution
+        ImageRecRef img;
+        if (Strutil::parse_prefix(s, "TOP")) {
+            img = curimg;
+        } else if (Strutil::parse_prefix(s, "IMG[")) {
+            int index = -1;
+            if (Strutil::parse_int(s, index) && Strutil::parse_char(s, ']')
+                && index >= 0 && index <= (int)image_stack.size()) {
+                if (index == 0)
+                    img = curimg;
+                else
+                    img = image_stack[image_stack.size() - index];
+            } else {
+                string_view name = Strutil::parse_until(s, "]");
+                auto found       = image_labels.find(name);
+                if (found != image_labels.end())
+                    img = found->second;
+                else
+                    img = ImageRecRef(new ImageRec(name, imagecache));
+                Strutil::parse_char(s, ']');
+            }
+        }
+        if (!img.get()) {
+            express_error(expr, s, "not a valid image");
+            result = orig;
+            return false;
+        }
+        bool using_bracket = false;
+        if (Strutil::parse_char(s, '[')) {
+            using_bracket = true;
+        } else if (!Strutil::parse_char(s, '.')) {
+            express_error(expr, s, "expected `.` or `[`");
+            result = orig;
+            return false;
+        }
+        string_view metadata;
+        char quote             = s.size() ? s.front() : ' ';
+        bool metadata_in_quote = quote == '\"' || quote == '\'';
+        if (metadata_in_quote)
+            Strutil::parse_string(s, metadata);
+        else
+            metadata = Strutil::parse_identifier(s, ":");
+        if (using_bracket) {
+            if (!Strutil::parse_char(s, ']')) {
+                express_error(expr, s, "expected `]`");
+                result = orig;
+                return false;
+            }
+        }
+        if (metadata.size()) {
+            read(img);
+            ParamValue tmpparam;
+            if (metadata == "nativeformat") {
+                result = img->nativespec(0, 0)->format.c_str();
+            } else if (auto p = img->spec(0, 0)->find_attribute(metadata,
+                                                                tmpparam)) {
+                std::string val = ImageSpec::metadata_val(*p);
+                if (p->type().basetype == TypeDesc::STRING) {
+                    // metadata_val returns strings double quoted, strip
+                    val.erase(0, 1);
+                    val.erase(val.size() - 1, 1);
+                }
+                result = val;
+            } else if (metadata == "filename")
+                result = img->name();
+            else if (metadata == "file_extension")
+                result = Filesystem::extension(img->name());
+            else if (metadata == "file_noextension") {
+                std::string filename = img->name();
+                std::string ext      = Filesystem::extension(img->name());
+                result = filename.substr(0, filename.size() - ext.size());
+            } else if (metadata == "MINCOLOR") {
+                auto pixstat = ImageBufAlgo::computePixelStats((*img)(0, 0));
+                std::stringstream out;
+                for (size_t i = 0; i < pixstat.min.size(); ++i)
+                    out << (i ? "," : "") << pixstat.min[i];
+                result = out.str();
+            } else if (metadata == "MAXCOLOR") {
+                auto pixstat = ImageBufAlgo::computePixelStats((*img)(0, 0));
+                std::stringstream out;
+                for (size_t i = 0; i < pixstat.max.size(); ++i)
+                    out << (i ? "," : "") << pixstat.max[i];
+                result = out.str();
+            } else if (metadata == "AVGCOLOR") {
+                auto pixstat = ImageBufAlgo::computePixelStats((*img)(0, 0));
+                std::stringstream out;
+                for (size_t i = 0; i < pixstat.avg.size(); ++i)
+                    out << (i ? "," : "") << pixstat.avg[i];
+                result = out.str();
+            } else if (metadata == "NONFINITE_COUNT") {
+                auto pixstat    = ImageBufAlgo::computePixelStats((*img)(0, 0));
+                imagesize_t sum = std::accumulate(pixstat.nancount.begin(),
+                                                  pixstat.nancount.end(), 0)
+                                  + std::accumulate(pixstat.infcount.begin(),
+                                                    pixstat.infcount.end(), 0);
+                result = Strutil::to_string(sum);
+            } else if (metadata == "META" || metadata == "METANATIVE") {
+                std::stringstream out;
+                print_info_options opt;
+                opt.verbose   = true;
+                opt.subimages = true;
+                opt.native    = (metadata == "METANATIVE");
+                std::string error;
+                OiioTool::print_info(out, *this, img.get(), opt, error);
+                result = out.str();
+                if (result.size() && result.back() == '\n')
+                    result.pop_back();
+            } else if (metadata == "METABRIEF"
+                       || metadata == "METANATIVEBRIEF") {
+                std::stringstream out;
+                print_info_options opt;
+                opt.verbose   = false;
+                opt.subimages = false;
+                opt.native    = (metadata == "METANATIVEBRIEF");
+                std::string error;
+                OiioTool::print_info(out, *this, img.get(), opt, error);
+                result = out.str();
+                if (result.size() && result.back() == '\n')
+                    result.pop_back();
+            } else if (metadata == "STATS") {
+                std::stringstream out;
+                // OiioTool::print_stats(out, *this, (*img)());
+
+                std::string err;
+                if (!pvt::print_stats(out, "", (*img)(), (*img)().nativespec(),
+                                      ROI(), err))
+                    errorfmt("stats", "unable to compute: {}", err);
+
+                result = out.str();
+                if (result.size() && result.back() == '\n')
+                    result.pop_back();
+            } else if (using_bracket) {
+                // For the TOP[meta] syntax, if the metadata doesn't exist,
+                // return the empty string, and do not make an error.
+                result = "";
+            } else {
+                express_error(expr, s,
+                              Strutil::fmt::format("unknown attribute name '{}'",
+                                                   metadata));
+                result = orig;
+                return false;
+            }
+        }
+    } else if (Strutil::parse_float(s, floatval)) {
+        result = Strutil::fmt::format("{:g}", floatval);
+    } else if (Strutil::parse_char(s, '\"', true, false)
+               || Strutil::parse_char(s, '\'', true, false)) {
+        string_view r;
+        Strutil::parse_string(s, r);
+        result = r;
+    }
+    // Test some special identifiers
+    else if (Strutil::parse_identifier_if(s, "FRAME_NUMBER")) {
+        result = Strutil::to_string(frame_number);
+    } else if (Strutil::parse_identifier_if(s, "FRAME_NUMBER_PAD")) {
+        std::string fmt = frame_padding == 0
+                              ? std::string("{}")
+                              : Strutil::fmt::format("\"{{:0{}d}}\"",
+                                                     frame_padding);
+        result          = Strutil::fmt::format(fmt, frame_number);
+    } else if (Strutil::parse_identifier_if(s, "NIMAGES")) {
+        result = Strutil::to_string(image_stack_depth());
+    } else {
+        string_view id = Strutil::parse_identifier(s, false);
+        if (id.size() && uservars.contains(id)) {
+            result = uservars[id];
+            Strutil::parse_identifier(s, true);  // eat the id
+        } else {
+            express_error(expr, s, "syntax error");
+            result = orig;
+            return false;
+        }
+    }
+
+    if (negative)
+        result = "-" + result;
+    if (invert)
+        result = Strutil::eval_as_bool(result) ? "0" : "1";
+
+    // print(" Exiting express_parse_atom, result='{}'\n", result);
+
+    return true;
+}
+
+
+
+bool
+Oiiotool::express_parse_factors(const string_view expr, string_view& s,
+                                std::string& result)
+{
+    // print(" Entering express_parse_factrors, s='{}'\n", s);
+
+    string_view orig = s;
+    std::string atom;
+    float lval, rval;
+
+    // parse the first factor
+    if (!express_parse_atom(expr, s, atom)) {
+        result = orig;
+        return false;
+    }
+
+    if (atom.size() >= 2 && atom.front() == '\"' && atom.back() == '\"') {
+        // Double quoted is string, return it
+        result = atom;
+    } else if (Strutil::string_is<float>(atom)) {
+        // lval is a number
+        lval = Strutil::from_string<float>(atom);
+        while (s.size()) {
+            enum class Ops { mul, div, idiv, imod };
+            Ops op;
+            if (Strutil::parse_char(s, '*'))
+                op = Ops::mul;
+            else if (Strutil::parse_prefix(s, "//"))
+                op = Ops::idiv;
+            else if (Strutil::parse_char(s, '/'))
+                op = Ops::div;
+            else if (Strutil::parse_char(s, '%'))
+                op = Ops::imod;
+            else {
+                // no more factors
+                break;
+            }
+
+            // parse the next factor
+            if (!express_parse_atom(expr, s, atom)) {
+                result = orig;
+                return false;
+            }
+
+            if (!Strutil::string_is<float>(atom)) {
+                express_error(
+                    expr, s,
+                    Strutil::fmt::format("expected number but got '{}'", atom));
+                result = orig;
+                return false;
+            }
+
+            // rval is a number, so we can math
+            rval = Strutil::from_string<float>(atom);
+            if (op == Ops::mul)
+                lval *= rval;
+            else if (op == Ops::div)
+                lval /= rval;
+            else if (op == Ops::idiv) {
+                int ilval(lval), irval(rval);
+                lval = float(rval ? ilval / irval : 0);
+            } else if (op == Ops::imod) {
+                int ilval(lval), irval(rval);
+                lval = float(rval ? ilval % irval : 0);
+            }
+        }
+
+        result = Strutil::fmt::format("{:g}", lval);
+
+    } else {
+        // atom is not a number, so we're done
+        result = atom;
+    }
+
+    // print(" Exiting express_parse_factors, result='{}'\n", result);
+
+    return true;
+}
+
+
+
+bool
+Oiiotool::express_parse_summands(const string_view expr, string_view& s,
+                                 std::string& result)
+{
+    // print(" Entering express_parse_summands, s='{}'\n", s);
+
+    string_view orig = s;
+    std::string atom;
+
+    // parse the first summand
+    if (!express_parse_factors(expr, s, atom)) {
+        result = orig;
+        return false;
+    }
+
+    if (atom.size() >= 2 && atom.front() == '\"' && atom.back() == '\"') {
+        // Double quoted is string, strip it
+        result = atom.substr(1, atom.size() - 2);
+    } else if (Strutil::string_is<float>(atom)) {
+        // lval is a number
+        float lval = Strutil::from_string<float>(atom);
+        while (s.size()) {
+            Strutil::skip_whitespace(s);
+            string_view op = Strutil::parse_while(s, "+-<=>!&|");
+            if (op == "") {
+                // no more summands
+                break;
+            }
+
+            // parse the next summand
+            if (!express_parse_factors(expr, s, atom)) {
+                result = orig;
+                return false;
+            }
+
+            if (!Strutil::string_is<float>(atom)) {
+                express_error(expr, s,
+                              Strutil::fmt::format("'{}' is not a number",
+                                                   atom));
+                result = orig;
+                return false;
+            }
+
+            // rval is also a number, we can math
+            float rval = Strutil::from_string<float>(atom);
+            if (op == "+") {
+                lval += rval;
+            } else if (op == "-") {
+                lval -= rval;
+            } else if (op == "<") {
+                lval = (lval < rval) ? 1 : 0;
+            } else if (op == ">") {
+                lval = (lval > rval) ? 1 : 0;
+            } else if (op == "<=") {
+                lval = (lval <= rval) ? 1 : 0;
+            } else if (op == ">=") {
+                lval = (lval >= rval) ? 1 : 0;
+            } else if (op == "==") {
+                lval = (lval == rval) ? 1 : 0;
+            } else if (op == "!=") {
+                lval = (lval != rval) ? 1 : 0;
+            } else if (op == "<=>") {
+                lval = (lval < rval) ? -1 : (lval > rval ? 1 : 0);
+            } else if (op == "&&" || op == "&") {
+                lval = (lval != 0.0f && rval != 0.0f) ? 1 : 0;
+            } else if (op == "||" || op == "|") {
+                lval = (lval != 0.0f || rval != 0.0f) ? 1 : 0;
+            }
+        }
+
+        result = Strutil::fmt::format("{:g}", lval);
+
+    } else {
+        // atom is not a number, so we're done
+        result = atom;
+    }
+
+    // print(" Exiting express_parse_summands, result='{}'\n", result);
+
+    return true;
+}
+
+
+
+// Expression evaluation and substitution for a single expression
+std::string
+Oiiotool::express_impl(string_view s)
+{
+    std::string result;
+    string_view orig = s;
+    if (!express_parse_summands(orig, s, result)) {
+        result = orig;
+    }
+    return result;
+}
+
+
+
+// Perform expression evaluation and substitution on a string
+string_view
+Oiiotool::express(string_view str)
+{
+    if (!eval_enable)
+        return str;  // Expression evaluation disabled
+
+    string_view s = str;
+    // eg. s="ab{cde}fg"
+    size_t openbrace = s.find('{');
+    if (openbrace == s.npos)
+        return str;  // No open brace found -- no expression substitution
+
+    string_view prefix = s.substr(0, openbrace);
+    s.remove_prefix(openbrace);
+    // eg. s="{cde}fg", prefix="ab"
+    string_view expr = Strutil::parse_nested(s);
+    if (expr.empty())
+        return str;  // No corresponding close brace found -- give up
+    // eg. prefix="ab", expr="{cde}", s="fg", prefix="ab"
+    OIIO_ASSERT(expr.front() == '{' && expr.back() == '}');
+    expr.remove_prefix(1);
+    expr.remove_suffix(1);
+    // eg. expr="cde"
+    ustring result = ustring::fmtformat("{}{}{}", prefix, express_impl(expr),
+                                        express(s));
+    if (debug)
+        print("Expanding expression \"{}\" -> \"{}\"\n", str, result);
+    return result;
+}
diff -pruN 2.5.10.1+dfsg-1/src/oiiotool/oiiotool.cpp 2.5.12.0+dfsg-1/src/oiiotool/oiiotool.cpp
--- 2.5.10.1+dfsg-1/src/oiiotool/oiiotool.cpp	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/oiiotool/oiiotool.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -1094,23 +1094,6 @@ set_dataformat(Oiiotool& ot, cspan<const
 
 
 
-static bool
-eval_as_bool(string_view value)
-{
-    Strutil::trim_whitespace(value);
-    if (Strutil::string_is_int(value)) {
-        return Strutil::stoi(value) != 0;
-    } else if (Strutil::string_is_float(value)) {
-        return Strutil::stof(value) != 0.0f;
-    } else {
-        return !(value.empty() || Strutil::iequals(value, "false")
-                 || Strutil::iequals(value, "no")
-                 || Strutil::iequals(value, "off"));
-    }
-}
-
-
-
 // --if
 static void
 control_if(Oiiotool& ot, cspan<const char*> argv)
@@ -1121,7 +1104,7 @@ control_if(Oiiotool& ot, cspan<const cha
     if (ot.running()) {
         // string_view command = ot.express(argv[0]);
         string_view value = ot.express(argv[1]);
-        cond              = eval_as_bool(value);
+        cond              = Strutil::eval_as_bool(value);
         // Strutil::print("while: val='{}' cond={}\n", value, cond);
     } else {
         // If not running in the outer scope, don't even evaluate the
@@ -1184,7 +1167,7 @@ control_while(Oiiotool& ot, cspan<const
     if (ot.running()) {
         // string_view command = ot.express(argv[0]);
         string_view value = ot.express(argv[1]);
-        cond              = eval_as_bool(value);
+        cond              = Strutil::eval_as_bool(value);
         // Strutil::print("while: val='{}' cond={}\n", value, cond);
     } else {
         // If not running in the outer scope, don't even evaluate the
@@ -1722,536 +1705,6 @@ unit_test_adjust_geometry(Oiiotool& ot)
 
 
 
-void
-Oiiotool::express_error(const string_view expr, const string_view s,
-                        string_view explanation)
-{
-    int offset = expr.rfind(s) + 1;
-    errorfmt("expression", "{} at char {} of '{}'", explanation, offset, expr);
-}
-
-
-
-// If str starts with what looks like a function call "name(" (allowing for
-// whitespace before the paren), eat those chars from str and return true.
-// Otherwise return false and leave str unchanged.
-inline bool
-parse_function_start_if(string_view& str, string_view name)
-{
-    string_view s = str;
-    if (Strutil::parse_identifier_if(s, name) && Strutil::parse_char(s, '(')) {
-        str = s;
-        return true;
-    }
-    return false;
-}
-
-
-
-bool
-Oiiotool::express_parse_atom(const string_view expr, string_view& s,
-                             std::string& result)
-{
-    // std::cout << " Entering express_parse_atom, s='" << s << "'\n";
-
-    string_view orig = s;
-    float floatval;
-
-    Strutil::skip_whitespace(s);
-
-    // handle + - ! prefixes
-    bool negative = false;
-    bool invert   = false;
-    while (s.size()) {
-        if (Strutil::parse_char(s, '-')) {
-            negative = !negative;
-        } else if (Strutil::parse_char(s, '+')) {
-            // no op
-        } else if (Strutil::parse_char(s, '!')) {
-            invert = !invert;
-        } else {
-            break;
-        }
-    }
-
-    if (Strutil::parse_char(s, '(')) {
-        // handle parentheses
-        if (express_parse_summands(expr, s, result)) {
-            if (!Strutil::parse_char(s, ')')) {
-                express_error(expr, s, "missing `)'");
-                result = orig;
-                return false;
-            }
-        } else {
-            result = orig;
-            return false;
-        }
-
-    } else if (parse_function_start_if(s, "getattribute")) {
-        // "{getattribute(name)}" retrieves global attribute `name`
-        bool ok = true;
-        Strutil::skip_whitespace(s);
-        string_view name;
-        if (s.size() && (s.front() == '\"' || s.front() == '\''))
-            ok = Strutil::parse_string(s, name);
-        else {
-            name = Strutil::parse_until(s, ")");
-        }
-        if (name.size()) {
-            std::string rs;
-            int ri;
-            float rf;
-            if (OIIO::getattribute(name, rs))
-                result = rs;
-            else if (OIIO::getattribute(name, ri))
-                result = Strutil::to_string(ri);
-            else if (OIIO::getattribute(name, rf))
-                result = Strutil::to_string(rf);
-            else
-                ok = false;
-        }
-        return Strutil::parse_char(s, ')') && ok;
-    } else if (parse_function_start_if(s, "var")) {
-        // "{var(name)}" retrieves user variable `name`
-        bool ok = true;
-        Strutil::skip_whitespace(s);
-        string_view name;
-        if (s.size() && (s.front() == '\"' || s.front() == '\''))
-            ok = Strutil::parse_string(s, name);
-        else {
-            name = Strutil::parse_until(s, ")");
-        }
-        if (name.size()) {
-            result = uservars[name];
-        }
-        return Strutil::parse_char(s, ')') && ok;
-    } else if (parse_function_start_if(s, "eq")) {
-        std::string left, right;
-        bool ok = express_parse_atom(s, s, left) && Strutil::parse_char(s, ',');
-        ok &= express_parse_atom(s, s, right) && Strutil::parse_char(s, ')');
-        result = left == right ? "1" : "0";
-        // Strutil::print("eq: left='{}', right='{}' ok={} result={}\n", left,
-        //                right, ok, result);
-        if (!ok)
-            return false;
-    } else if (parse_function_start_if(s, "neq")) {
-        std::string left, right;
-        bool ok = express_parse_atom(s, s, left) && Strutil::parse_char(s, ',');
-        ok &= express_parse_atom(s, s, right) && Strutil::parse_char(s, ')');
-        result = left != right ? "1" : "0";
-        // Strutil::print("neq: left='{}', right='{}' ok={} result={}\n", left,
-        //                right, ok, result);
-        if (!ok)
-            return false;
-    } else if (parse_function_start_if(s, "not")) {
-        std::string val;
-        bool ok = express_parse_summands(s, s, val)
-                  && Strutil::parse_char(s, ')');
-        result = eval_as_bool(val) ? "0" : "1";
-        if (!ok)
-            return false;
-
-    } else if (Strutil::starts_with(s, "TOP")
-               || Strutil::starts_with(s, "IMG[")) {
-        // metadata substitution
-        ImageRecRef img;
-        if (Strutil::parse_prefix(s, "TOP")) {
-            img = curimg;
-        } else if (Strutil::parse_prefix(s, "IMG[")) {
-            int index = -1;
-            if (Strutil::parse_int(s, index) && Strutil::parse_char(s, ']')
-                && index >= 0 && index <= (int)image_stack.size()) {
-                if (index == 0)
-                    img = curimg;
-                else
-                    img = image_stack[image_stack.size() - index];
-            } else {
-                string_view name = Strutil::parse_until(s, "]");
-                auto found       = image_labels.find(name);
-                if (found != image_labels.end())
-                    img = found->second;
-                else
-                    img = ImageRecRef(new ImageRec(name, imagecache));
-                Strutil::parse_char(s, ']');
-            }
-        }
-        if (!img.get()) {
-            express_error(expr, s, "not a valid image");
-            result = orig;
-            return false;
-        }
-        bool using_bracket = false;
-        if (Strutil::parse_char(s, '[')) {
-            using_bracket = true;
-        } else if (!Strutil::parse_char(s, '.')) {
-            express_error(expr, s, "expected `.` or `[`");
-            result = orig;
-            return false;
-        }
-        string_view metadata;
-        char quote             = s.size() ? s.front() : ' ';
-        bool metadata_in_quote = quote == '\"' || quote == '\'';
-        if (metadata_in_quote)
-            Strutil::parse_string(s, metadata);
-        else
-            metadata = Strutil::parse_identifier(s, ":");
-        if (using_bracket) {
-            if (!Strutil::parse_char(s, ']')) {
-                express_error(expr, s, "expected `]`");
-                result = orig;
-                return false;
-            }
-        }
-        if (metadata.size()) {
-            read(img);
-            ParamValue tmpparam;
-            if (metadata == "nativeformat") {
-                result = img->nativespec(0, 0)->format.c_str();
-            } else if (auto p = img->spec(0, 0)->find_attribute(metadata,
-                                                                tmpparam)) {
-                std::string val = ImageSpec::metadata_val(*p);
-                if (p->type().basetype == TypeDesc::STRING) {
-                    // metadata_val returns strings double quoted, strip
-                    val.erase(0, 1);
-                    val.erase(val.size() - 1, 1);
-                }
-                result = val;
-            } else if (metadata == "filename")
-                result = img->name();
-            else if (metadata == "file_extension")
-                result = Filesystem::extension(img->name());
-            else if (metadata == "file_noextension") {
-                std::string filename = img->name();
-                std::string ext      = Filesystem::extension(img->name());
-                result = filename.substr(0, filename.size() - ext.size());
-            } else if (metadata == "MINCOLOR") {
-                auto pixstat = ImageBufAlgo::computePixelStats((*img)(0, 0));
-                std::stringstream out;
-                for (size_t i = 0; i < pixstat.min.size(); ++i)
-                    out << (i ? "," : "") << pixstat.min[i];
-                result = out.str();
-            } else if (metadata == "MAXCOLOR") {
-                auto pixstat = ImageBufAlgo::computePixelStats((*img)(0, 0));
-                std::stringstream out;
-                for (size_t i = 0; i < pixstat.max.size(); ++i)
-                    out << (i ? "," : "") << pixstat.max[i];
-                result = out.str();
-            } else if (metadata == "AVGCOLOR") {
-                auto pixstat = ImageBufAlgo::computePixelStats((*img)(0, 0));
-                std::stringstream out;
-                for (size_t i = 0; i < pixstat.avg.size(); ++i)
-                    out << (i ? "," : "") << pixstat.avg[i];
-                result = out.str();
-            } else if (metadata == "NONFINITE_COUNT") {
-                auto pixstat    = ImageBufAlgo::computePixelStats((*img)(0, 0));
-                imagesize_t sum = std::accumulate(pixstat.nancount.begin(),
-                                                  pixstat.nancount.end(), 0)
-                                  + std::accumulate(pixstat.infcount.begin(),
-                                                    pixstat.infcount.end(), 0);
-                result = Strutil::to_string(sum);
-            } else if (metadata == "META" || metadata == "METANATIVE") {
-                std::stringstream out;
-                print_info_options opt;
-                opt.verbose   = true;
-                opt.subimages = true;
-                opt.native    = (metadata == "METANATIVE");
-                std::string error;
-                OiioTool::print_info(out, *this, img.get(), opt, error);
-                result = out.str();
-                if (result.size() && result.back() == '\n')
-                    result.pop_back();
-            } else if (metadata == "METABRIEF"
-                       || metadata == "METANATIVEBRIEF") {
-                std::stringstream out;
-                print_info_options opt;
-                opt.verbose   = false;
-                opt.subimages = false;
-                opt.native    = (metadata == "METANATIVEBRIEF");
-                std::string error;
-                OiioTool::print_info(out, *this, img.get(), opt, error);
-                result = out.str();
-                if (result.size() && result.back() == '\n')
-                    result.pop_back();
-            } else if (metadata == "STATS") {
-                std::stringstream out;
-                // OiioTool::print_stats(out, *this, (*img)());
-
-                std::string err;
-                if (!pvt::print_stats(out, "", (*img)(), (*img)().nativespec(),
-                                      ROI(), err))
-                    errorfmt("stats", "unable to compute: {}", err);
-
-                result = out.str();
-                if (result.size() && result.back() == '\n')
-                    result.pop_back();
-            } else if (using_bracket) {
-                // For the TOP[meta] syntax, if the metadata doesn't exist,
-                // return the empty string, and do not make an error.
-                result = "";
-            } else {
-                express_error(expr, s,
-                              Strutil::fmt::format("unknown attribute name '{}'",
-                                                   metadata));
-                result = orig;
-                return false;
-            }
-        }
-    } else if (Strutil::parse_float(s, floatval)) {
-        result = Strutil::fmt::format("{:g}", floatval);
-    } else if (Strutil::parse_char(s, '\"', true, false)
-               || Strutil::parse_char(s, '\'', true, false)) {
-        string_view r;
-        Strutil::parse_string(s, r);
-        result = r;
-    }
-    // Test some special identifiers
-    else if (Strutil::parse_identifier_if(s, "FRAME_NUMBER")) {
-        result = Strutil::to_string(frame_number);
-    } else if (Strutil::parse_identifier_if(s, "FRAME_NUMBER_PAD")) {
-        std::string fmt = frame_padding == 0
-                              ? std::string("{}")
-                              : Strutil::fmt::format("\"{{:0{}d}}\"",
-                                                     frame_padding);
-        result          = Strutil::fmt::format(fmt, frame_number);
-    } else if (Strutil::parse_identifier_if(s, "NIMAGES")) {
-        result = Strutil::to_string(image_stack_depth());
-    } else {
-        string_view id = Strutil::parse_identifier(s, false);
-        if (id.size() && uservars.contains(id)) {
-            result = uservars[id];
-            Strutil::parse_identifier(s, true);  // eat the id
-        } else {
-            express_error(expr, s, "syntax error");
-            result = orig;
-            return false;
-        }
-    }
-
-    if (negative)
-        result = "-" + result;
-    if (invert)
-        result = eval_as_bool(result) ? "0" : "1";
-
-    // std::cout << " Exiting express_parse_atom, result='" << result << "'\n";
-
-    return true;
-}
-
-
-
-bool
-Oiiotool::express_parse_factors(const string_view expr, string_view& s,
-                                std::string& result)
-{
-    // std::cout << " Entering express_parse_factors, s='" << s << "'\n";
-
-    string_view orig = s;
-    std::string atom;
-    float lval, rval;
-
-    // parse the first factor
-    if (!express_parse_atom(expr, s, atom)) {
-        result = orig;
-        return false;
-    }
-
-    if (atom.size() >= 2 && atom.front() == '\"' && atom.back() == '\"') {
-        // Double quoted is string, return it
-        result = atom;
-    } else if (Strutil::string_is<float>(atom)) {
-        // lval is a number
-        lval = Strutil::from_string<float>(atom);
-        while (s.size()) {
-            enum class Ops { mul, div, idiv, imod };
-            Ops op;
-            if (Strutil::parse_char(s, '*'))
-                op = Ops::mul;
-            else if (Strutil::parse_prefix(s, "//"))
-                op = Ops::idiv;
-            else if (Strutil::parse_char(s, '/'))
-                op = Ops::div;
-            else if (Strutil::parse_char(s, '%'))
-                op = Ops::imod;
-            else {
-                // no more factors
-                break;
-            }
-
-            // parse the next factor
-            if (!express_parse_atom(expr, s, atom)) {
-                result = orig;
-                return false;
-            }
-
-            if (!Strutil::string_is<float>(atom)) {
-                express_error(
-                    expr, s,
-                    Strutil::fmt::format("expected number but got '{}'", atom));
-                result = orig;
-                return false;
-            }
-
-            // rval is a number, so we can math
-            rval = Strutil::from_string<float>(atom);
-            if (op == Ops::mul)
-                lval *= rval;
-            else if (op == Ops::div)
-                lval /= rval;
-            else if (op == Ops::idiv) {
-                int ilval(lval), irval(rval);
-                lval = float(rval ? ilval / irval : 0);
-            } else if (op == Ops::imod) {
-                int ilval(lval), irval(rval);
-                lval = float(rval ? ilval % irval : 0);
-            }
-        }
-
-        result = Strutil::fmt::format("{:g}", lval);
-
-    } else {
-        // atom is not a number, so we're done
-        result = atom;
-    }
-
-    // std::cout << " Exiting express_parse_factors, result='" << result << "'\n";
-
-    return true;
-}
-
-
-
-bool
-Oiiotool::express_parse_summands(const string_view expr, string_view& s,
-                                 std::string& result)
-{
-    // std::cout << " Entering express_parse_summands, s='" << s << "'\n";
-
-    string_view orig = s;
-    std::string atom;
-
-    // parse the first summand
-    if (!express_parse_factors(expr, s, atom)) {
-        result = orig;
-        return false;
-    }
-
-    if (atom.size() >= 2 && atom.front() == '\"' && atom.back() == '\"') {
-        // Double quoted is string, strip it
-        result = atom.substr(1, atom.size() - 2);
-    } else if (Strutil::string_is<float>(atom)) {
-        // lval is a number
-        float lval = Strutil::from_string<float>(atom);
-        while (s.size()) {
-            Strutil::skip_whitespace(s);
-            string_view op = Strutil::parse_while(s, "+-<=>!&|");
-            if (op == "") {
-                // no more summands
-                break;
-            }
-
-            // parse the next summand
-            if (!express_parse_factors(expr, s, atom)) {
-                result = orig;
-                return false;
-            }
-
-            if (!Strutil::string_is<float>(atom)) {
-                express_error(expr, s,
-                              Strutil::fmt::format("'{}' is not a number",
-                                                   atom));
-                result = orig;
-                return false;
-            }
-
-            // rval is also a number, we can math
-            float rval = Strutil::from_string<float>(atom);
-            if (op == "+") {
-                lval += rval;
-            } else if (op == "-") {
-                lval -= rval;
-            } else if (op == "<") {
-                lval = (lval < rval) ? 1 : 0;
-            } else if (op == ">") {
-                lval = (lval > rval) ? 1 : 0;
-            } else if (op == "<=") {
-                lval = (lval <= rval) ? 1 : 0;
-            } else if (op == ">=") {
-                lval = (lval >= rval) ? 1 : 0;
-            } else if (op == "==") {
-                lval = (lval == rval) ? 1 : 0;
-            } else if (op == "!=") {
-                lval = (lval != rval) ? 1 : 0;
-            } else if (op == "<=>") {
-                lval = (lval < rval) ? -1 : (lval > rval ? 1 : 0);
-            } else if (op == "&&" || op == "&") {
-                lval = (lval != 0.0f && rval != 0.0f) ? 1 : 0;
-            } else if (op == "||" || op == "|") {
-                lval = (lval != 0.0f || rval != 0.0f) ? 1 : 0;
-            }
-        }
-
-        result = Strutil::fmt::format("{:g}", lval);
-
-    } else {
-        // atom is not a number, so we're done
-        result = atom;
-    }
-
-    // std::cout << " Exiting express_parse_summands, result='" << result << "'\n";
-
-    return true;
-}
-
-
-
-// Expression evaluation and substitution for a single expression
-std::string
-Oiiotool::express_impl(string_view s)
-{
-    std::string result;
-    string_view orig = s;
-    if (!express_parse_summands(orig, s, result)) {
-        result = orig;
-    }
-    return result;
-}
-
-
-
-// Perform expression evaluation and substitution on a string
-string_view
-Oiiotool::express(string_view str)
-{
-    if (!eval_enable)
-        return str;  // Expression evaluation disabled
-
-    string_view s = str;
-    // eg. s="ab{cde}fg"
-    size_t openbrace = s.find('{');
-    if (openbrace == s.npos)
-        return str;  // No open brace found -- no expression substitution
-
-    string_view prefix = s.substr(0, openbrace);
-    s.remove_prefix(openbrace);
-    // eg. s="{cde}fg", prefix="ab"
-    string_view expr = Strutil::parse_nested(s);
-    if (expr.empty())
-        return str;  // No corresponding close brace found -- give up
-    // eg. prefix="ab", expr="{cde}", s="fg", prefix="ab"
-    OIIO_ASSERT(expr.front() == '{' && expr.back() == '}');
-    expr.remove_prefix(1);
-    expr.remove_suffix(1);
-    // eg. expr="cde"
-    ustring result = ustring::fmtformat("{}{}{}", prefix, express_impl(expr),
-                                        express(s));
-    if (debug)
-        std::cout << "Expanding expression \"" << str << "\" -> \"" << result
-                  << "\"\n";
-    return result;
-}
-
-
-
 // --iconfig
 static void
 set_input_attribute(Oiiotool& ot, cspan<const char*> argv)
diff -pruN 2.5.10.1+dfsg-1/src/openexr.imageio/exr_pvt.h 2.5.12.0+dfsg-1/src/openexr.imageio/exr_pvt.h
--- 2.5.10.1+dfsg-1/src/openexr.imageio/exr_pvt.h	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/openexr.imageio/exr_pvt.h	2024-06-01 19:59:05.000000000 +0000
@@ -123,8 +123,9 @@ public:
     {
         return (feature == "arbitrary_metadata"
                 || feature == "exif"  // Because of arbitrary_metadata
+                || feature == "ioproxy"
                 || feature == "iptc"  // Because of arbitrary_metadata
-                || feature == "ioproxy");
+                || feature == "multiimage");
     }
     bool valid_file(Filesystem::IOProxy* ioproxy) const override;
     bool open(const std::string& name, ImageSpec& newspec,
diff -pruN 2.5.10.1+dfsg-1/src/openexr.imageio/exrinput_c.cpp 2.5.12.0+dfsg-1/src/openexr.imageio/exrinput_c.cpp
--- 2.5.10.1+dfsg-1/src/openexr.imageio/exrinput_c.cpp	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/openexr.imageio/exrinput_c.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -105,8 +105,9 @@ public:
     {
         return (feature == "arbitrary_metadata"
                 || feature == "exif"  // Because of arbitrary_metadata
+                || feature == "ioproxy"
                 || feature == "iptc"  // Because of arbitrary_metadata
-                || feature == "ioproxy");
+                || feature == "multiimage");
     }
     bool valid_file(const std::string& filename) const override;
     bool open(const std::string& name, ImageSpec& newspec,
diff -pruN 2.5.10.1+dfsg-1/src/openexr.imageio/exroutput.cpp 2.5.12.0+dfsg-1/src/openexr.imageio/exroutput.cpp
--- 2.5.10.1+dfsg-1/src/openexr.imageio/exroutput.cpp	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/openexr.imageio/exroutput.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -402,7 +402,6 @@ OpenEXROutput::open(const std::string& n
                 m_io = new Filesystem::IOFile(name, Filesystem::IOProxy::Write);
                 m_local_io.reset(m_io);
             }
-            OIIO_ASSERT(m_io);
             if (m_io->mode() != Filesystem::IOProxy::Write) {
                 // If the proxy couldn't be opened in write mode, try to
                 // return an error.
@@ -582,13 +581,20 @@ OpenEXROutput::open(const std::string& n
 
     // Create an ImfMultiPartOutputFile
     try {
-        // m_output_stream.reset (new OpenEXROutputStream (name.c_str())();
-        // m_output_multipart.reset (new Imf::MultiPartOutputFile (*m_output_stream,
-        //                                          &m_headers[0], subimages)();
-        // FIXME: Oops, looks like OpenEXR 2.0 currently lacks a
-        // MultiPartOutputFile ctr that takes an OStream, so we can't
-        // do this quite yet.
-        m_output_multipart.reset(new Imf::MultiPartOutputFile(name.c_str(),
+        if (!m_io) {
+            m_io = new Filesystem::IOFile(name, Filesystem::IOProxy::Write);
+            m_local_io.reset(m_io);
+        }
+        if (m_io->mode() != Filesystem::IOProxy::Write) {
+            // If the proxy couldn't be opened in write mode, try to
+            // return an error.
+            std::string e = m_io->error();
+            errorfmt("Could not open \"{}\" ({})", name,
+                     e.size() ? e : std::string("unknown error"));
+            return false;
+        }
+        m_output_stream.reset(new OpenEXROutputStream(name.c_str(), m_io));
+        m_output_multipart.reset(new Imf::MultiPartOutputFile(*m_output_stream,
                                                               &m_headers[0],
                                                               subimages));
     } catch (const std::exception& e) {
@@ -1484,21 +1490,33 @@ OpenEXROutput::write_scanlines(int ybegi
                               * 1024;  // Allocate 16 MB, or 1 scanline
     int chunk = std::max(1, int(limit / scanlinebytes));
 
-    bool ok = true;
-    for (; ok && ybegin < yend; ybegin += chunk) {
-        int y1         = std::min(ybegin + chunk, yend);
-        int nscanlines = y1 - ybegin;
-        const void* d  = to_native_rectangle(m_spec.x, m_spec.x + m_spec.width,
-                                             ybegin, y1, z, z + 1, format, data,
-                                             xstride, ystride, zstride,
-                                             m_scratch);
+    bool ok                  = true;
+    const bool isDecreasingY = m_spec.get_string_attribute("openexr:lineOrder")
+                               == "decreasingY";
+    const int nAvailableScanLines = yend - ybegin;
+    const int numChunks           = nAvailableScanLines > 0
+                                        ? 1 + ((nAvailableScanLines - 1) / chunk)
+                                        : 0;
+    const int yLoopStart = isDecreasingY ? ybegin + (numChunks - 1) * chunk
+                                         : ybegin;
+    const int yDelta     = isDecreasingY ? -chunk : chunk;
+    const int yLoopEnd   = yLoopStart + numChunks * yDelta;
+    for (int y = yLoopStart; ok && y != yLoopEnd; y += yDelta) {
+        int y1         = std::min(y + chunk, yend);
+        int nscanlines = y1 - y;
+
+        const void* dataStart = (const char*)data + (y - ybegin) * ystride;
+        const void* d = to_native_rectangle(m_spec.x, m_spec.x + m_spec.width,
+                                            y, y1, z, z + 1, format, dataStart,
+                                            xstride, ystride, zstride,
+                                            m_scratch);
 
         // Compute where OpenEXR needs to think the full buffers starts.
         // OpenImageIO requires that 'data' points to where client stored
         // the bytes to be written, but OpenEXR's frameBuffer.insert() wants
         // where the address of the "virtual framebuffer" for the whole
         // image.
-        char* buf = (char*)d - m_spec.x * pixel_bytes - ybegin * scanlinebytes;
+        char* buf = (char*)d - m_spec.x * pixel_bytes - y * scanlinebytes;
         try {
             Imf::FrameBuffer frameBuffer;
             size_t chanoffset = 0;
@@ -1526,8 +1544,6 @@ OpenEXROutput::write_scanlines(int ybegi
             errorf("Failed OpenEXR write: unknown exception");
             return false;
         }
-
-        data = (const char*)data + ystride * nscanlines;
     }
 
     // If we allocated more than 1M, free the memory.  It's not wasteful,
diff -pruN 2.5.10.1+dfsg-1/src/openvdb.imageio/openvdbinput.cpp 2.5.12.0+dfsg-1/src/openvdb.imageio/openvdbinput.cpp
--- 2.5.10.1+dfsg-1/src/openvdb.imageio/openvdbinput.cpp	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/openvdb.imageio/openvdbinput.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -70,7 +70,7 @@ public:
     const char* format_name(void) const override { return "openvdb"; }
     int supports(string_view feature) const override
     {
-        return (feature == "arbitrary_metadata");
+        return (feature == "arbitrary_metadata" || feature == "multiimage");
     }
     bool valid_file(const std::string& filename) const override;
     bool open(const std::string& name, ImageSpec& newspec) override;
@@ -535,6 +535,9 @@ OpenVDBInput::open(const std::string& fi
     m_name       = filename;
     m_nsubimages = (int)m_layers.size();
 
+    for (auto& lr : m_layers)
+        lr.spec.attribute("oiio:subimages", m_nsubimages);
+
     bool ok = seek_subimage(0, 0);
     newspec = ImageInput::spec();
     return ok;
diff -pruN 2.5.10.1+dfsg-1/src/pnm.imageio/pnminput.cpp 2.5.12.0+dfsg-1/src/pnm.imageio/pnminput.cpp
--- 2.5.10.1+dfsg-1/src/pnm.imageio/pnminput.cpp	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/pnm.imageio/pnminput.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: Apache-2.0
 // https://github.com/AcademySoftwareFoundation/OpenImageIO
 
+#include <cstdio>
 #include <cstdlib>
 #include <fstream>
 #include <string>
@@ -12,6 +13,8 @@
 
 OIIO_PLUGIN_NAMESPACE_BEGIN
 
+#define DBG if (0)
+
 //
 // Documentation on the PNM formats can be found at:
 // http://netpbm.sourceforge.net/doc/pbm.html  (B&W)
@@ -48,6 +51,7 @@ private:
     string_view m_remaining;
     string_view m_after_header;
     int m_y_next;
+    bool m_pfm_flip;
 
     void init()
     {
@@ -188,6 +192,7 @@ unpack_floats(const unsigned char* read,
 bool
 PNMInput::read_file_scanline(void* data, int y)
 {
+    DBG std::cerr << "PNMInput::read_file_scanline(" << y << ")\n";
     if (y < m_y_next) {
         // If being asked to backtrack to an earlier scanline, reset all the
         // way to the beginning, right after the header.
@@ -202,9 +207,11 @@ PNMInput::read_file_scanline(void* data,
     for (; good && m_y_next <= y; ++m_y_next) {
         // PFM files are bottom-to-top, so we need to seek to the right spot
         if (m_pnm_type == PF || m_pnm_type == Pf) {
-            int file_scanline = m_spec.height - 1 - (y - m_spec.y);
-            auto offset       = file_scanline * m_spec.scanline_bytes();
-            m_remaining       = m_after_header.substr(offset);
+            if (m_pfm_flip) {
+                int file_scanline = m_spec.height - 1 - (y - m_spec.y);
+                auto offset       = file_scanline * m_spec.scanline_bytes();
+                m_remaining       = m_after_header.substr(offset);
+            }
         }
 
         if ((m_pnm_type >= P4 && m_pnm_type <= P6) || m_pnm_type == PF
@@ -219,6 +226,7 @@ PNMInput::read_file_scanline(void* data,
             if (size_t(numbytes) > m_remaining.size())
                 return false;
             buf.assign(m_remaining.begin(), m_remaining.begin() + numbytes);
+
             m_remaining.remove_prefix(numbytes);
         }
 
@@ -327,6 +335,7 @@ PNMInput::read_file_header()
         m_spec = ImageSpec(width, height, m_pnm_type == PF ? 3 : 1,
                            TypeDesc::FLOAT);
         m_spec.attribute("pnm:bigendian", m_scaling_factor < 0 ? 0 : 1);
+        m_spec.attribute("pnm:binary", 1);
     }
     m_spec.attribute("oiio:ColorSpace", "Rec709");
     return true;
@@ -339,7 +348,15 @@ PNMInput::open(const std::string& name,
                const ImageSpec& config)
 {
     ioproxy_retrieve_from_config(config);
-    return open(name, newspec);
+
+    if (!open(name, newspec)) {
+        errorfmt("Could not parse spec for file \"%s\"", name);
+        return false;
+    }
+
+    m_pfm_flip = config.get_int_attribute("pnm:pfmflip", 1);
+
+    return true;
 }
 
 
diff -pruN 2.5.10.1+dfsg-1/src/pnm.imageio/pnmoutput.cpp 2.5.12.0+dfsg-1/src/pnm.imageio/pnmoutput.cpp
--- 2.5.10.1+dfsg-1/src/pnm.imageio/pnmoutput.cpp	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/pnm.imageio/pnmoutput.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: Apache-2.0
 // https://github.com/AcademySoftwareFoundation/OpenImageIO
 
+#include <cstdio>
 #include <fstream>
 
 #include <OpenImageIO/filesystem.h>
@@ -9,6 +10,7 @@
 
 OIIO_PLUGIN_NAMESPACE_BEGIN
 
+#define DBG if (0)
 
 class PNMOutput final : public ImageOutput {
 public:
@@ -24,13 +26,19 @@ public:
     bool close() override;
     bool write_scanline(int y, int z, TypeDesc format, const void* data,
                         stride_t xstride) override;
+    bool write_scanlines(int ybegin, int yend, int z, TypeDesc format,
+                         const void* data, stride_t xstride = AutoStride,
+                         stride_t ystride = AutoStride) override;
     bool write_tile(int x, int y, int z, TypeDesc format, const void* data,
                     stride_t xstride, stride_t ystride,
                     stride_t zstride) override;
 
 private:
     std::string m_filename;  // Stash the filename
-    unsigned int m_max_val, m_pnm_type;
+    unsigned int m_max_val;
+    unsigned int m_pnm_type;
+    std::string m_pfn_type;
+
     unsigned int m_dither;
     std::vector<unsigned char> m_scratch;
     std::vector<unsigned char> m_tilebuffer;
@@ -39,6 +47,7 @@ private:
 
     bool write_ascii_binary(const unsigned char* data, const stride_t stride);
     bool write_raw_binary(const unsigned char* data, const stride_t stride);
+    bool write_float(const void* data, TypeDesc format, const stride_t stride);
 
     template<class T>
     bool write_ascii(const T* data, const stride_t stride,
@@ -58,8 +67,8 @@ pnm_output_imageio_create()
     return new PNMOutput;
 }
 
-OIIO_EXPORT const char* pnm_output_extensions[] = { "ppm", "pgm", "pbm", "pnm",
-                                                    nullptr };
+OIIO_EXPORT const char* pnm_output_extensions[] = { "ppm", "pgm", "pbm",
+                                                    "pnm", "pfm", nullptr };
 
 OIIO_PLUGIN_EXPORTS_END
 
@@ -95,12 +104,19 @@ bool
 PNMOutput::write_ascii(const T* data, const stride_t stride,
                        unsigned int max_val)
 {
-    int nc = m_spec.nchannels;
+    DBG std::cerr << "PNMOutput::write_ascii()\n";
+    int nc   = m_spec.nchannels;
+    bool big = m_spec.get_int_attribute("pnm:bigendian", 0) == 1;
+    DBG std::cerr << "bigendian: " << big << "\n";
+    stride_t m_stride = stride / sizeof(T);
+
     for (int x = 0; x < m_spec.width; x++) {
-        unsigned int pixel = x * stride;
+        unsigned int pixel = x * m_stride;
         for (int c = 0; c < nc; c++) {
             unsigned int val = data[pixel + c];
             val              = val * max_val / std::numeric_limits<T>::max();
+            if (big)
+                swap_endian(&val, 1);
             if (!iowritefmt("{}\n", val))
                 return false;
         }
@@ -114,17 +130,22 @@ template<class T>
 bool
 PNMOutput::write_raw(const T* data, const stride_t stride, unsigned int max_val)
 {
-    int nc = m_spec.nchannels;
+    //DBG std::cerr << "PNMOutput::write_raw()\n";
+    int nc            = m_spec.nchannels;
+    bool big          = m_spec.get_int_attribute("pnm:bigendian", 0) == 1;
+    stride_t m_stride = stride / sizeof(T);
+
     for (int x = 0; x < m_spec.width; x++) {
-        unsigned int pixel = x * stride;
+        unsigned int pixel = x * m_stride;
         for (int c = 0; c < nc; c++) {
             unsigned int val = data[pixel + c];
             val              = val * max_val / std::numeric_limits<T>::max();
             if (sizeof(T) == 2) {
                 // Writing a 16bit ppm file
-                // I'll adopt the practice of Netpbm and write the MSB first
-                uint8_t byte[2] = { static_cast<uint8_t>(val >> 8),
-                                    static_cast<uint8_t>(val & 0xff) };
+                uint8_t byte[2] = { big ? static_cast<uint8_t>(val & 0xff)
+                                        : static_cast<uint8_t>(val >> 8),
+                                    big ? static_cast<uint8_t>(val >> 8)
+                                        : static_cast<uint8_t>(val & 0xff) };
                 if (!iowrite(&byte, 2))
                     return false;
             } else {
@@ -141,6 +162,62 @@ PNMOutput::write_raw(const T* data, cons
 
 
 bool
+PNMOutput::write_float(const void* data, TypeDesc format, const stride_t stride)
+{
+    int nc   = m_spec.nchannels;
+    bool big = m_spec.get_int_attribute("pnm:bigendian", 0) == 1;
+    stride_t m_stride;
+
+    switch (format.basetype) {
+    case TypeDesc::HALF:
+        m_stride = stride / sizeof(half);
+        for (int x = 0; x < m_spec.width; x++) {
+            unsigned int pixel = x * m_stride;
+            for (int c = 0; c < nc; c++) {
+                half* d   = (half*)data;
+                float val = static_cast<float>(d[pixel + c]);
+                if (big)
+                    swap_endian(&val, 1);
+                if (!iowrite(&val, sizeof(val)))
+                    return false;
+            }
+        }
+        break;
+    case TypeDesc::FLOAT:
+        m_stride = stride / sizeof(float);
+        for (int x = 0; x < m_spec.width; x++) {
+            unsigned int pixel = x * m_stride;
+            for (int c = 0; c < nc; c++) {
+                float* d  = (float*)data;
+                float val = d[pixel + c];
+                if (big)
+                    swap_endian(&val, 1);
+                if (!iowrite(&val, sizeof(val)))
+                    return false;
+            }
+        }
+        break;
+    case TypeDesc::DOUBLE:
+        m_stride = stride / sizeof(double);
+        for (int x = 0; x < m_spec.width; x++) {
+            unsigned int pixel = x * m_stride;
+            for (int c = 0; c < nc; c++) {
+                double* d = (double*)data;
+                float val = static_cast<float>(d[pixel + c]);
+                if (big)
+                    swap_endian(&val, 1);
+                if (!iowrite(&val, sizeof(val)))
+                    return false;
+            }
+        }
+        break;
+    }
+    return true;
+}
+
+
+
+bool
 PNMOutput::open(const std::string& name, const ImageSpec& userspec,
                 OpenMode mode)
 {
@@ -148,33 +225,90 @@ PNMOutput::open(const std::string& name,
                     uint64_t(OpenChecks::Disallow2Channel)))
         return false;
 
-    m_spec.set_format(TypeDesc::UINT8);  // Force 8 bit output
-    int bits_per_sample = m_spec.get_int_attribute("oiio:BitsPerSample", 8);
-    m_dither            = (m_spec.format == TypeDesc::UINT8)
-                              ? m_spec.get_int_attribute("oiio:dither", 0)
-                              : 0;
-
-    if (bits_per_sample == 1)
-        m_pnm_type = 4;
-    else if (m_spec.nchannels == 1)
-        m_pnm_type = 5;
-    else
-        m_pnm_type = 6;
-    if (!m_spec.get_int_attribute("pnm:binary", 1))
-        m_pnm_type -= 3;
+    DBG std::cerr << "Bit depth: " << m_spec.format << "\n";
+
+    m_pnm_type = 0;
+    m_pfn_type = "";
+
+    int bits_per_sample = 0;
+    if (m_spec.find_attribute("oiio:BitsPerSample")) {
+        bits_per_sample = m_spec.get_int_attribute("oiio:BitsPerSample", 8);
+    }
+
+    bool p_binary = m_spec.get_int_attribute("pnm:binary", 1);
+    DBG std::cerr << "p_binary: " << p_binary << "\n";
+
+    if (bits_per_sample == 1) {
+        // black and white
+        m_pnm_type = p_binary ? 4 : 1;
+    } else if (bits_per_sample == 8 || bits_per_sample == 16) {
+        // 8 or 16 bit
+        m_pnm_type = (m_spec.nchannels == 1) ? (p_binary ? 5 : 2)
+                                             : (p_binary ? 6 : 3);
+    } else if (bits_per_sample == 32) {
+        // 32 bit float
+        m_pfn_type = (m_spec.nchannels == 1) ? "f" : "F";
+    } else if (bits_per_sample == 0) {
+        switch (m_spec.format.basetype) {
+        case TypeDesc::UINT8:
+        case TypeDesc::UINT16:
+            m_pnm_type = (m_spec.nchannels == 1) ? (p_binary ? 5 : 2)
+                                                 : (p_binary ? 6 : 3);
+            break;
+        case TypeDesc::HALF:
+        case TypeDesc::FLOAT:
+        case TypeDesc::DOUBLE:
+            m_pfn_type = (m_spec.nchannels == 1) ? "f" : "F";
+            break;
+        default:
+            errorfmt("PNM does not support {}\n", m_spec.format.c_str());
+            return false;
+        }
+    } else {
+        errorfmt("PNM does not support {}\n", m_spec.format.c_str());
+        return false;
+    }
+
+    m_dither = (m_spec.format == TypeDesc::UINT8)
+                   ? m_spec.get_int_attribute("oiio:dither", 0)
+                   : 0;
 
     ioproxy_retrieve_from_config(m_spec);
     if (!ioproxy_use_or_open(name))
         return false;
 
-    m_max_val = (1 << bits_per_sample) - 1;
     // Write header
     bool ok = true;
-    ok &= iowritefmt("P{}\n", m_pnm_type);
+    if (bits_per_sample != 0) {
+        // user specified bits per sample
+        if (m_pfn_type == "") {
+            ok &= iowritefmt("P{}\n", m_pnm_type);
+            m_max_val = (bits_per_sample == 16) ? 65535 : 255;
+        } else {
+            ok &= iowritefmt("P{}\n", m_pfn_type);
+        }
+    } else {
+        // no bits per sample specified
+        if (m_pfn_type == "") {
+            m_max_val = (m_spec.format == TypeDesc::UINT16) ? 65535 : 255;
+            ok &= iowritefmt("P{}\n", m_pnm_type);
+        } else {
+            ok &= iowritefmt("P{}\n", m_pfn_type);
+        }
+    }
+
     ok &= iowritefmt("{} {}\n", m_spec.width, m_spec.height);
-    if (m_pnm_type != 1 && m_pnm_type != 4)  // only non-monochrome
-        ok &= iowritefmt("{}\n", m_max_val);
 
+
+    if (m_pnm_type != 1 && m_pnm_type != 4) {  // only non-monochrome
+        if (m_pfn_type == "")
+            ok &= iowritefmt("{}\n", m_max_val);
+        else {
+            bool big = m_spec.get_int_attribute("pnm:bigendian", 0) == 1;
+            std::string scale = big ? "1.0000" : "-1.0000";
+            ok &= iowritefmt("{}\n", scale);
+        }
+    }
     // If user asked for tiles -- which this format doesn't support, emulate
     // it by buffering the whole image.
     if (m_spec.tile_width && m_spec.tile_height)
@@ -195,8 +329,8 @@ PNMOutput::close()
     if (m_spec.tile_width) {
         // Handle tile emulation -- output the buffered pixels
         OIIO_DASSERT(m_tilebuffer.size());
-        ok &= write_scanlines(m_spec.y, m_spec.y + m_spec.height, 0,
-                              m_spec.format, &m_tilebuffer[0]);
+        ok &= ImageOutput::write_scanlines(m_spec.y, m_spec.y + m_spec.height,
+                                           0, m_spec.format, &m_tilebuffer[0]);
         m_tilebuffer.shrink_to_fit();
     }
 
@@ -210,6 +344,7 @@ bool
 PNMOutput::write_scanline(int y, int z, TypeDesc format, const void* data,
                           stride_t xstride)
 {
+    //DBG std::cerr << "PNMOutput::write_scanline()\n";
     if (!ioproxy_opened())
         return false;
     if (z)
@@ -218,24 +353,32 @@ PNMOutput::write_scanline(int y, int z,
     m_spec.auto_stride(xstride, format, spec().nchannels);
     const void* origdata = data;
     data = to_native_scanline(format, data, xstride, m_scratch, m_dither, y, z);
-    if (data != origdata)  // a conversion happened...
-        xstride = spec().nchannels;
+    if (data != origdata) {  // a conversion happened...
+        xstride = m_spec.pixel_bytes(true);
+    }
 
     switch (m_pnm_type) {
+    case 0:
+        if (m_pfn_type != "") {
+            return write_float(data, m_spec.format, xstride);
+        } else
+            return false;
     case 1: return write_ascii_binary((unsigned char*)data, xstride);
     case 2:
     case 3:
-        if (m_max_val > std::numeric_limits<unsigned char>::max())
+        if (m_max_val > std::numeric_limits<unsigned char>::max()) {
             return write_ascii((unsigned short*)data, xstride, m_max_val);
-        else
+        } else {
             return write_ascii((unsigned char*)data, xstride, m_max_val);
+        }
     case 4: return write_raw_binary((unsigned char*)data, xstride);
     case 5:
     case 6:
-        if (m_max_val > std::numeric_limits<unsigned char>::max())
+        if (m_max_val > std::numeric_limits<unsigned char>::max()) {
             return write_raw((unsigned short*)data, xstride, m_max_val);
-        else
+        } else {
             return write_raw((unsigned char*)data, xstride, m_max_val);
+        }
     default: return false;
     }
 
@@ -243,6 +386,40 @@ PNMOutput::write_scanline(int y, int z,
 }
 
 
+
+bool
+PNMOutput::write_scanlines(int ybegin, int yend, int z, TypeDesc format,
+                           const void* data, stride_t xstride, stride_t ystride)
+{
+    DBG std::cerr << "PNMOutput::write_scanlines()\n";
+
+    if (m_spec.get_int_attribute("pnm:pfmflip", 1) == 1
+        && format == TypeDesc::FLOAT) {
+        DBG std::cerr << "Flipping PFM vertically\n";
+
+        // Default implementation: write each scanline individually
+        stride_t native_pixel_bytes = (stride_t)m_spec.pixel_bytes(true);
+        if (format == TypeDesc::UNKNOWN && xstride == AutoStride)
+            xstride = native_pixel_bytes;
+        stride_t zstride = AutoStride;
+        m_spec.auto_stride(xstride, ystride, zstride, format, m_spec.nchannels,
+                           m_spec.width, yend - ybegin);
+
+        // start at the last scanline
+        data    = (char*)data + (yend - ybegin - 1) * ystride;
+        bool ok = true;
+        for (int y = ybegin; ok && y < yend; ++y) {
+            ok &= write_scanline(y, z, format, data, xstride);
+            data = (char*)data - ystride;
+        }
+        return ok;
+    }
+
+    return ImageOutput::write_scanlines(ybegin, yend, z, format, data, xstride,
+                                        ystride);
+}
+
+
 
 bool
 PNMOutput::write_tile(int x, int y, int z, TypeDesc format, const void* data,
diff -pruN 2.5.10.1+dfsg-1/src/psd.imageio/psdinput.cpp 2.5.12.0+dfsg-1/src/psd.imageio/psdinput.cpp
--- 2.5.10.1+dfsg-1/src/psd.imageio/psdinput.cpp	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/psd.imageio/psdinput.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -14,6 +14,7 @@
 #include <map>
 #include <memory>
 #include <vector>
+#include <zlib.h>
 
 #include <OpenImageIO/fmath.h>
 #include <OpenImageIO/imagebuf.h>
@@ -128,6 +129,15 @@ private:
         uint64_t data_length;
         int64_t data_pos;
         uint16_t compression;
+
+        uint32_t width;
+        uint32_t height;
+
+        // This data is only relevant for the compression
+        // codecs zip and zipprediction as we need to preallocate
+        // the memory this vector is already decompressed and byteswapped
+        std::vector<char> decompressed_data;
+
         std::vector<uint32_t> rle_lengths;
         std::vector<int64_t> row_pos;
     };
@@ -276,6 +286,9 @@ private:
     //Global Additional Layer Info
     bool load_global_additional();
 
+    //Layers for 16- and 32-bit documents
+    bool load_layers_16_32(uint64_t length);
+
     //Image Data Section
     bool load_image_data();
 
@@ -285,8 +298,7 @@ private:
     void fill_channel_names(ImageSpec& spec, bool transparency);
 
     //Read a row of channel data
-    bool read_channel_row(const ChannelInfo& channel_info, uint32_t row,
-                          char* data);
+    bool read_channel_row(ChannelInfo& channel_info, uint32_t row, char* data);
 
     // Interleave channels (RRRGGGBBB -> RGBRGBRGB) while copying from
     // channel_buffers[0..nchans-1] to dst.
@@ -414,8 +426,17 @@ private:
 
     int read_pascal_string(std::string& s, uint16_t mod_padding);
 
+    // Swap a planar bytespan representing the bytes of a float vector to its
+    // interleaved byte order. This is per scanline
+    void float_planar_to_interleaved(span<char> data, size_t width,
+                                     size_t height);
+
+    // All the compression modes known to photoshop
     bool decompress_packbits(const char* src, char* dst, uint32_t packed_length,
                              uint32_t unpacked_length);
+    bool decompress_zip(span<char> src, span<char> dest);
+    bool decompress_zip_prediction(span<char> src, span<char> dest,
+                                   const uint32_t width, const uint32_t height);
 
     // These are AdditionalInfo entries that, for PSBs, have an 8-byte length
     static const char* additional_info_psb[];
@@ -524,6 +545,17 @@ OIIO_PLUGIN_EXPORTS_END
 
 
 
+/// Byteswap a span of values.  This should work for any of short, unsigned
+/// short, int, unsigned int, float, long long, pointers. It's just calling
+/// byteswap on each element.
+template<typename T>
+inline OIIO_HOSTDEVICE void
+byteswap_span(span<T> vals)
+{
+    swap_endian(vals.data(), int(vals.size()));
+}
+
+
 PSDInput::PSDInput() { init(); }
 
 
@@ -1419,6 +1451,11 @@ PSDInput::load_layers()
     if (!ok)
         return false;
 
+    // There is 3 cases where this could be empty:
+    // - 16-bit files store this data in the Lr16 tagged block
+    // - 32-bit files store this data in the Lr32 tagged block
+    // - Single layer files may optimize this section away and instead
+    //   store the data on the merged image data section
     if (!layer_info.length)
         return true;
 
@@ -1589,10 +1626,13 @@ PSDInput::load_layer_channel(Layer& laye
         width  = layer.width;
         height = layer.height;
     }
+    channel_info.width  = width;
+    channel_info.height = height;
 
     channel_info.data_pos = iotell();
     channel_info.row_pos.resize(height);
     channel_info.row_length = (width * m_header.depth + 7) / 8;
+
     switch (channel_info.compression) {
     case Compression_Raw:
         if (height) {
@@ -1602,6 +1642,9 @@ PSDInput::load_layer_channel(Layer& laye
                                           + channel_info.row_length;
         }
         channel_info.data_length = channel_info.row_length * height;
+
+        if (!ioseek(channel_info.data_length, SEEK_CUR))
+            return false;
         break;
     case Compression_RLE:
         // RLE lengths are stored before the channel data
@@ -1619,19 +1662,52 @@ PSDInput::load_layer_channel(Layer& laye
                 channel_info.row_pos[i] = channel_info.row_pos[i - 1]
                                           + channel_info.rle_lengths[i - 1];
         }
+
+        if (!ioseek(channel_info.data_length, SEEK_CUR))
+            return false;
         break;
-    // These two aren't currently supported. They would likely
-    // require large changes in the code as they probably don't
-    // support random access like the other modes. I doubt these are
-    // used much and I haven't found any test images.
-    case Compression_ZIP:
-    case Compression_ZIP_Predict:
+    case Compression_ZIP: {
+        // We subtract the compression marker from the data length
+        channel_info.data_length -= 2;
+
+        // Unlike with raw and rle compression we cannot access each scanline
+        // randomly so we parse the data up-front and store it
+        std::vector<char> compressed_data(channel_info.data_length);
+        channel_info.decompressed_data = std::vector<char>(
+            width * height * (m_header.depth / 8));
+
+        if (!ioseek(channel_info.data_pos))
+            return false;
+        if (!ioread(compressed_data.data(), channel_info.data_length))
+            return false;
+
+        decompress_zip(compressed_data, channel_info.decompressed_data);
+    } break;
+    case Compression_ZIP_Predict: {
+        // We subtract the compression marker from the data length
+        channel_info.data_length -= 2;
+
+        // Unlike with raw and rle compression we cannot access each scanline
+        // randomly so we parse the data up-front and store it
+        std::vector<char> compressed_data(channel_info.data_length);
+        channel_info.decompressed_data = std::vector<char>(
+            width * height * (m_header.depth / 8));
+
+        if (!ioseek(channel_info.data_pos))
+            return false;
+        if (!ioread(compressed_data.data(), channel_info.data_length))
+            return false;
+
+        decompress_zip_prediction(compressed_data,
+                                  channel_info.decompressed_data, width,
+                                  height);
+    } break;
     default:
         errorfmt("[Layer Channel] unsupported compression {}",
                  channel_info.compression);
         return false;
     }
-    return ioseek(channel_info.data_length, SEEK_CUR);
+    return true;
 }
 
 
@@ -1663,7 +1739,10 @@ PSDInput::load_global_mask_info()
     uint32_t length;
 
     // This section should be at least 17 bytes, but some files lack
-    // global mask info and additional layer info, not covered in the spec
+    // global mask info and additional layer info, not covered in the spec.
+    // More modern photoshop files appear to omit this section entirely.
+    // We leave this code here though in case we want to deal with older photoshop files
+    // although it is not currently used anywhere else
     if (remaining < 17) {
         return ioseek(m_layer_mask_info.end);
     }
@@ -1726,11 +1805,20 @@ PSDInput::load_global_additional()
         // Long story short these are aligned to 4 bytes but that is not
         // included in the stored length and the specs do not mention it.
 
-        // round up to multiple of 4
-        length = (length + 3) & ~3;
-        remaining -= length;
-        // skip it for now
-        ok &= ioseek(length, SEEK_CUR);
+        // Load 16 and 32-bit layer data
+        if (std::memcmp(key, "Lr16", 4) == 0
+            || std::memcmp(key, "Lr32", 4) == 0) {
+            uint64_t begin_offset = iotell();
+            ok &= load_layers_16_32(length);
+            uint64_t size = iotell() - begin_offset;
+            remaining -= size;
+        } else {
+            // round up to multiple of 4
+            length = (length + 3) & ~3;
+            remaining -= length;
+            // skip it for now
+            ok &= ioseek(length, SEEK_CUR);
+        }
     }
     // finished with the layer and mask information section, seek to the end
     ok &= ioseek(m_layer_mask_info.end);
@@ -1738,6 +1826,53 @@ PSDInput::load_global_additional()
 }
 
 
+bool
+PSDInput::load_layers_16_32(uint64_t length)
+{
+    // Notice that, bar the reading of the length marker, reading this section is identical to
+    // the normal layer info section
+    bool ok = true;
+
+    if (length == 0)
+        return false;
+
+    LayerMaskInfo::LayerInfo& layer_info = m_layer_mask_info.layer_info;
+    // The layer info length must have been 0 in the actual layer info section
+    OIIO_ASSERT(layer_info.length == 0);
+    layer_info.length = length;
+
+    uint64_t begin = iotell();
+
+    // We read the layer info as we would usually since the section is exactly the same
+    ok &= read_bige<int16_t>(layer_info.layer_count);
+    if (layer_info.layer_count < 0) {
+        m_image_data.transparency = true;
+        layer_info.layer_count    = -layer_info.layer_count;
+    }
+    m_layers.resize(layer_info.layer_count);
+    for (int16_t layer_nbr = 0; layer_nbr < layer_info.layer_count;
+         ++layer_nbr) {
+        Layer& layer = m_layers[layer_nbr];
+        if (!load_layer(layer))
+            return false;
+    }
+    for (int16_t layer_nbr = 0; layer_nbr < layer_info.layer_count;
+         ++layer_nbr) {
+        Layer& layer = m_layers[layer_nbr];
+        if (!load_layer_channels(layer))
+            return false;
+    }
+
+    // This section, like the other tagged blocks are padded to 4 bytes
+    uint64_t length_read = iotell() - begin;
+    int64_t remaining    = (((length_read + 3) / 4) * 4) - length_read;
+    OIIO_ASSERT(remaining >= 0);
+    OIIO_ASSERT(remaining < 4);
+    ioseek(remaining, SEEK_CUR);
+
+    return ok;
+}
+
 
 bool
 PSDInput::load_image_data()
@@ -1892,8 +2027,7 @@ PSDInput::fill_channel_names(ImageSpec&
 
 
 bool
-PSDInput::read_channel_row(const ChannelInfo& channel_info, uint32_t row,
-                           char* data)
+PSDInput::read_channel_row(ChannelInfo& channel_info, uint32_t row, char* data)
 {
     if (row >= channel_info.row_pos.size()) {
         errorfmt("Reading channel row out of range ({}, should be < {})", row,
@@ -1901,39 +2035,53 @@ PSDInput::read_channel_row(const Channel
         return false;
     }
 
-    if (!ioseek(channel_info.row_pos[row]))
-        return false;
     switch (channel_info.compression) {
     case Compression_Raw:
-        if (!ioread(data, channel_info.row_length))
+        if (!ioseek(channel_info.row_pos[row]))
             return false;
-        break;
-    case Compression_RLE: {
-        uint32_t rle_length = channel_info.rle_lengths[row];
-        char* rle_buffer;
-        OIIO_ALLOCATE_STACK_OR_HEAP(rle_buffer, char, rle_length);
-        if (!ioread(rle_buffer, rle_length)
-            || !decompress_packbits(rle_buffer, data, rle_length,
-                                    channel_info.row_length))
+        if (!ioread(data, channel_info.row_length))
             return false;
-        break;
-    }
-    }
 
-    if (!bigendian()) {
-        switch (m_header.depth) {
-        case 16: swap_endian((uint16_t*)data, m_spec.width); break;
-        case 32:
-            swap_endian((uint32_t*)data, m_spec.width);
-            // if (row == 131)
-            //     printf ("%x %x %x %x\n",
-            //             ((uint32_t*)data)[0], ((uint32_t*)data)[1],
-            //             ((uint32_t*)data)[2], ((uint32_t*)data)[3]);
-            // convert_type<float,uint32_t> ((float *)&data[0],
-            //                               (uint32_t*)&data[1], m_spec.width);
+        if (!bigendian()) {
+            switch (m_header.depth) {
+            case 16: swap_endian((uint16_t*)data, channel_info.width); break;
+            case 32: swap_endian((uint32_t*)data, channel_info.width); break;
+            }
             break;
+        case Compression_RLE: {
+            if (!ioseek(channel_info.row_pos[row]))
+                return false;
+            uint32_t rle_length = channel_info.rle_lengths[row];
+            char* rle_buffer;
+            OIIO_ALLOCATE_STACK_OR_HEAP(rle_buffer, char, rle_length);
+            if (!ioread(rle_buffer, rle_length)
+                || !decompress_packbits(rle_buffer, data, rle_length,
+                                        channel_info.row_length))
+                return false;
+        } break;
+        case Compression_ZIP: {
+            OIIO_ASSERT(channel_info.decompressed_data.size()
+                        == static_cast<uint64_t>(channel_info.width)
+                               * channel_info.height * (m_header.depth / 8));
+            // We simply copy over the row into destination
+            uint64_t row_index = static_cast<uint64_t>(row) * channel_info.width
+                                 * (m_header.depth / 8);
+            std::memcpy(data, channel_info.decompressed_data.data() + row_index,
+                        channel_info.row_length);
+        } break;
+        case Compression_ZIP_Predict: {
+            OIIO_ASSERT(channel_info.decompressed_data.size()
+                        == static_cast<uint64_t>(channel_info.width)
+                               * channel_info.height * (m_header.depth / 8));
+            // We simply copy over the row into destination
+            uint64_t row_index = static_cast<uint64_t>(row) * channel_info.width
+                                 * (m_header.depth / 8);
+            std::memcpy(data, channel_info.decompressed_data.data() + row_index,
+                        channel_info.row_length);
+        } break;
         }
     }
+
     return true;
 }
 
@@ -2050,6 +2198,31 @@ PSDInput::read_pascal_string(std::string
 
 
 
+void
+PSDInput::float_planar_to_interleaved(span<char> data, size_t width,
+                                      size_t height)
+{
+    std::vector<char> buffer(data.size());
+
+    // Shuffle from planar 1111... 2222... 3333... 4444... byte order to 1234 1234 1234 1234...
+    for (uint64_t y = 0; y < height; ++y) {
+        for (uint64_t x = 0; x < width; ++x) {
+            uint64_t rowIndex = y * width * sizeof(float);
+
+            buffer[rowIndex + x * sizeof(float) + 0] = data[rowIndex + x];
+            buffer[rowIndex + x * sizeof(float) + 1]
+                = data[rowIndex + width + x];
+            buffer[rowIndex + x * sizeof(float) + 2]
+                = data[rowIndex + width * 2 + x];
+            buffer[rowIndex + x * sizeof(float) + 3]
+                = data[rowIndex + width * 3 + x];
+        }
+    }
+    std::memcpy(data.data(), buffer.data(), buffer.size());
+}
+
+
+
 bool
 PSDInput::decompress_packbits(const char* src, char* dst,
                               uint32_t packed_length, uint32_t unpacked_length)
@@ -2098,11 +2271,124 @@ PSDInput::decompress_packbits(const char
             dst += length;
         }
     }
+
+    if (!bigendian()) {
+        switch (m_header.depth) {
+        case 16: swap_endian((uint16_t*)dst, m_spec.width); break;
+        case 32: swap_endian((uint32_t*)dst, m_spec.width); break;
+        }
+    }
+
+    return true;
+}
+
+
+
+bool
+PSDInput::decompress_zip(span<char> src, span<char> dest)
+{
+    z_stream stream {};
+    stream.zfree     = Z_NULL;
+    stream.opaque    = Z_NULL;
+    stream.avail_in  = src.size();
+    stream.next_in   = (Bytef*)src.data();
+    stream.avail_out = dest.size();
+    stream.next_out  = (Bytef*)dest.data();
+
+    if (inflateInit(&stream) != Z_OK) {
+        errorfmt(
+            "zip compression inflate init failed with: src_size={}, dst_size={}",
+            src.size(), dest.size());
+        return false;
+    }
+
+    if (inflate(&stream, Z_FINISH) != Z_STREAM_END) {
+        errorfmt(
+            "unable to decode zip compressed data: src_size={}, dst_size={}",
+            src.size(), dest.size());
+        return false;
+    }
+
+    if (inflateEnd(&stream) != Z_OK) {
+        errorfmt(
+            "zip compression inflate cleanup failed with: src_size={}, dst_size={}",
+            src.size(), dest.size());
+        return false;
+    }
+
     return true;
 }
 
 
 
+bool
+PSDInput::decompress_zip_prediction(span<char> src, span<char> dest,
+                                    const uint32_t width, const uint32_t height)
+{
+    OIIO_ASSERT(width * height * (m_header.depth / 8) == dest.size());
+    bool ok = true;
+    // Decompress into dest first and then apply the prediction decoding
+    // on dest
+    ok &= decompress_zip(src, dest);
+
+    switch (m_header.depth) {
+    case 8:
+        for (uint64_t y = 0; y < height; ++y) {
+            // Index x beginning at one since we look behind to calculate
+            // the offset
+            for (uint64_t x = 1; x < width; ++x) {
+                dest[y * width + x] += dest[y * width + x - 1];
+            };
+        };
+        break;
+    case 16: {
+        // 16-bit data requires endian swapping at this point already for the
+        // prediction decoding to work correctly
+        span<uint16_t> destView(reinterpret_cast<uint16_t*>(dest.data()),
+                                dest.size() / 2);
+        if (!bigendian())
+            byteswap_span(destView);
+
+        for (uint64_t y = 0; y < height; ++y) {
+            // Index x beginning at one since we look behind to calculate
+            // the offset
+            for (uint64_t x = 1; x < width; ++x) {
+                destView[y * width + x] += destView[y * width + x - 1];
+            };
+        };
+    } break;
+    case 32: {
+        // 32-bit files actually have the float bytes stored in planar fashion on disk
+        // which are then prediction encoded. Thus we first decode the bytes itself
+        uint64_t index = 0;
+        for (uint64_t y = 0; y < height; ++y) {
+            ++index;
+            for (uint64_t x = 1; x < (width * sizeof(float)); ++x) {
+                uint8_t value = dest[index] + dest[index - 1];
+                dest[index]   = value;
+                ++index;
+            }
+        }
+
+        // We now shuffle the byte order back into place from planar to interleaved
+        float_planar_to_interleaved(dest, width, height);
+
+        // Finally we byteswap if necessary
+        if (!bigendian())
+            byteswap_span(
+                span<uint32_t>(reinterpret_cast<uint32_t*>(dest.data()),
+                               dest.size() / 4));
+    } break;
+    default:
+        errorfmt("Unknown bitdepth: {} encountered", m_header.depth);
+        return false;
+    }
+
+    return ok;
+};
+
+
+
 bool
 PSDInput::is_additional_info_psb(const char* key)
 {
diff -pruN 2.5.10.1+dfsg-1/src/python/py_imagecache.cpp 2.5.12.0+dfsg-1/src/python/py_imagecache.cpp
--- 2.5.10.1+dfsg-1/src/python/py_imagecache.cpp	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/python/py_imagecache.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -117,7 +117,11 @@ declare_imagecache(py::module& m)
         .def("resolve_filename",
              [](ImageCacheWrap& ic, const std::string& filename) {
                  py::gil_scoped_release gil;
+#if PY_MAJOR_VERSION >= 3
+                 return ic.m_cache->resolve_filename(filename);
+#else
                  return PY_STR(ic.m_cache->resolve_filename(filename));
+#endif
              })
         // .def("get_image_info", &ImageCacheWrap::get_image_info)
         .def(
@@ -147,14 +151,22 @@ declare_imagecache(py::module& m)
         .def(
             "geterror",
             [](ImageCacheWrap& self, bool clear) {
+#if PY_MAJOR_VERSION >= 3
+                return self.m_cache->geterror(clear);
+#else
                 return PY_STR(self.m_cache->geterror(clear));
+#endif
             },
             "clear"_a = true)
         .def(
             "getstats",
             [](ImageCacheWrap& ic, int level) {
                 py::gil_scoped_release gil;
+#if PY_MAJOR_VERSION >= 3
+                return ic.m_cache->getstats(level);
+#else
                 return PY_STR(ic.m_cache->getstats(level));
+#endif
             },
             "level"_a = 1)
         .def(
diff -pruN 2.5.10.1+dfsg-1/src/tiff.imageio/tiffinput.cpp 2.5.12.0+dfsg-1/src/tiff.imageio/tiffinput.cpp
--- 2.5.10.1+dfsg-1/src/tiff.imageio/tiffinput.cpp	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/src/tiff.imageio/tiffinput.cpp	2024-06-01 19:59:05.000000000 +0000
@@ -103,7 +103,8 @@ public:
     bool valid_file(Filesystem::IOProxy* ioproxy) const override;
     int supports(string_view feature) const override
     {
-        return (feature == "exif" || feature == "iptc" || feature == "ioproxy");
+        return (feature == "exif" || feature == "iptc" || feature == "ioproxy"
+                || feature == "multiimage");
         // N.B. No support for arbitrary metadata.
     }
     bool open(const std::string& name, ImageSpec& newspec) override;
diff -pruN 2.5.10.1+dfsg-1/testsuite/dds/ref/out.txt 2.5.12.0+dfsg-1/testsuite/dds/ref/out.txt
--- 2.5.10.1+dfsg-1/testsuite/dds/ref/out.txt	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/testsuite/dds/ref/out.txt	2024-06-01 19:59:05.000000000 +0000
@@ -178,6 +178,67 @@ Reading ../oiio-images/dds/dds_rgb5a1.dd
     channel list: R, G, B, A
     textureformat: "Plain Texture"
     oiio:BitsPerSample: 16
+Reading ../oiio-images/dds/dds_dxgi_bc1_srgb.dds
+../oiio-images/dds/dds_dxgi_bc1_srgb.dds :   16 x    8, 4 channel, uint8 dds
+    SHA-1: 02BFD2FEE553D00AEFEEEE22BB5119724D588F6A
+    channel list: R, G, B, A
+    compression: "DXT1"
+    textureformat: "Plain Texture"
+    oiio:ColorSpace: "sRGB"
+Reading ../oiio-images/dds/dds_dxgi_bc2_srgb.dds
+../oiio-images/dds/dds_dxgi_bc2_srgb.dds :   16 x    8, 4 channel, uint8 dds
+    SHA-1: D99494018941ADCA11EAE469D8C6E598DA37A8BF
+    channel list: R, G, B, A
+    compression: "DXT3"
+    textureformat: "Plain Texture"
+    oiio:ColorSpace: "sRGB"
+Reading ../oiio-images/dds/dds_dxgi_bc3_srgb.dds
+../oiio-images/dds/dds_dxgi_bc3_srgb.dds :   16 x    8, 4 channel, uint8 dds
+    SHA-1: 75F9FCD1920A00966F2FE13DF40F4FB0A6CD8DED
+    channel list: R, G, B, A
+    compression: "DXT5"
+    textureformat: "Plain Texture"
+    oiio:ColorSpace: "sRGB"
+Reading ../oiio-images/dds/dds_dxgi_bc7_srgb.dds
+../oiio-images/dds/dds_dxgi_bc7_srgb.dds :   16 x    8, 4 channel, uint8 dds
+    SHA-1: 91DBAC0E5ED54D5BBEECA4C48AB704FA9F7FE317
+    channel list: R, G, B, A
+    compression: "BC7"
+    textureformat: "Plain Texture"
+    oiio:ColorSpace: "sRGB"
+Reading ../oiio-images/dds/dds_dxgi_rgba8_srgb.dds
+../oiio-images/dds/dds_dxgi_rgba8_srgb.dds :   16 x    8, 4 channel, uint8 dds
+    SHA-1: 61986C7E2D4F402B4A268AE5187AAFAF1647C0E6
+    channel list: R, G, B, A
+    textureformat: "Plain Texture"
+    oiio:BitsPerSample: 32
+    oiio:ColorSpace: "sRGB"
+Reading ../oiio-images/dds/dds_dxgi_bgra8_srgb.dds
+../oiio-images/dds/dds_dxgi_bgra8_srgb.dds :   16 x    8, 4 channel, uint8 dds
+    SHA-1: 61986C7E2D4F402B4A268AE5187AAFAF1647C0E6
+    channel list: R, G, B, A
+    textureformat: "Plain Texture"
+    oiio:BitsPerSample: 32
+    oiio:ColorSpace: "sRGB"
+Reading ../oiio-images/dds/dds_dxgi_bgrx8_srgb.dds
+../oiio-images/dds/dds_dxgi_bgrx8_srgb.dds :   16 x    8, 3 channel, uint8 dds
+    SHA-1: 6BF57CCCCF14021926285CE97D25AEC150324476
+    channel list: R, G, B
+    textureformat: "Plain Texture"
+    oiio:BitsPerSample: 32
+    oiio:ColorSpace: "sRGB"
+Reading ../oiio-images/dds/dds_dxgi_rgb10a2.dds
+../oiio-images/dds/dds_dxgi_rgb10a2.dds :   16 x    8, 4 channel, uint8 dds
+    SHA-1: F38B31F89991752DAB792DC9FF29F7F7DE0E7911
+    channel list: R, G, B, A
+    textureformat: "Plain Texture"
+    oiio:BitsPerSample: 32
+Reading ../oiio-images/dds/dds_dxgi_r16.dds
+../oiio-images/dds/dds_dxgi_r16.dds :   16 x    8, 1 channel, uint8 dds
+    SHA-1: 016B31C71C2BFEAB9E1CCE1649EC22EE27D97D3F
+    channel list: Y
+    textureformat: "Plain Texture"
+    oiio:BitsPerSample: 16
 Reading ../oiio-images/dds/broken/dds_bc3_just_header.dds
 ../oiio-images/dds/broken/dds_bc3_just_header.dds :   24 x   20, 4 channel, uint8 dds
     SHA-1: 7070E1838A7C0595287731B65FB8062C365E7BED
diff -pruN 2.5.10.1+dfsg-1/testsuite/dds/run.py 2.5.12.0+dfsg-1/testsuite/dds/run.py
--- 2.5.10.1+dfsg-1/testsuite/dds/run.py	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/testsuite/dds/run.py	2024-06-01 19:59:05.000000000 +0000
@@ -36,6 +36,16 @@ files = [
     "dds_rgb10a2.dds",
     "dds_rgb332.dds",
     "dds_rgb5a1.dds",
+    "dds_dxgi_bc1_srgb.dds",
+    "dds_dxgi_bc2_srgb.dds",
+    "dds_dxgi_bc3_srgb.dds",
+    "dds_dxgi_bc7_srgb.dds",
+    "dds_dxgi_rgba8_srgb.dds",
+    "dds_dxgi_bgra8_srgb.dds",
+    "dds_dxgi_bgrx8_srgb.dds",
+    "dds_dxgi_rgb10a2.dds",
+    "dds_dxgi_r16.dds",
+
     # In some CI matrix cases a PtexReader
     # also attempts to read this, and outputs
     # a "PtexReader error: read failed (EOF)"
diff -pruN 2.5.10.1+dfsg-1/testsuite/dpx/ref/out.txt 2.5.12.0+dfsg-1/testsuite/dpx/ref/out.txt
--- 2.5.10.1+dfsg-1/testsuite/dpx/ref/out.txt	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/testsuite/dpx/ref/out.txt	2024-06-01 19:59:05.000000000 +0000
@@ -36,6 +36,7 @@ Reading ../oiio-images/dpx_nuke_10bits_r
     dpx:XScannedSize: 0
     dpx:YScannedSize: 0
     oiio:BitsPerSample: 10
+    oiio:subimages: 1
     smpte:TimeCode: 00:00:00:00
 Comparing "../oiio-images/dpx_nuke_10bits_rgb.dpx" and "dpx_nuke_10bits_rgb.dpx"
 PASS
@@ -77,6 +78,7 @@ Reading ../oiio-images/dpx_nuke_16bits_r
     dpx:XScannedSize: 0
     dpx:YScannedSize: 0
     oiio:BitsPerSample: 10
+    oiio:subimages: 1
     smpte:TimeCode: 00:00:00:00
 Comparing "../oiio-images/dpx_nuke_16bits_rgba.dpx" and "dpx_nuke_16bits_rgba.dpx"
 PASS
@@ -100,6 +102,7 @@ stereo.dpx           :   80 x   60, 3 ch
     dpx:Transfer: "Undefined"
     dpx:Version: "V2.0"
     oiio:BitsPerSample: 10
+    oiio:subimages: 2
     Stats Min: 0 0 0 (of 1023)
     Stats Max: 1023 1023 1023 (of 1023)
     Stats Avg: 18.64 18.64 18.64 (of 1023)
@@ -124,6 +127,7 @@ stereo.dpx           :   80 x   60, 3 ch
     dpx:Transfer: "Undefined"
     dpx:Version: "V2.0"
     oiio:BitsPerSample: 10
+    oiio:subimages: 2
     Stats Min: 0 0 0 (of 1023)
     Stats Max: 1023 1023 1023 (of 1023)
     Stats Avg: 24.44 24.44 24.44 (of 1023)
@@ -151,5 +155,6 @@ grey.dpx             :  512 x  512, 1 ch
     dpx:Transfer: "Undefined"
     dpx:Version: "V2.0"
     oiio:BitsPerSample: 10
+    oiio:subimages: 1
 Comparing "grey.dpx" and "ref/grey.tif"
 PASS
diff -pruN 2.5.10.1+dfsg-1/testsuite/fits/ref/out.txt 2.5.12.0+dfsg-1/testsuite/fits/ref/out.txt
--- 2.5.10.1+dfsg-1/testsuite/fits/ref/out.txt	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/testsuite/fits/ref/out.txt	2024-06-01 19:59:05.000000000 +0000
@@ -17,6 +17,7 @@ Simple 8-bit ramp pattern for testing of
     Extend: "T"
     Object: "Ramp 8-bit"
     Origin: "ESO"
+    oiio:subimages: 1
 Comparing "../fits-images/pg93/tst0001.fits" and "tst0001.fits"
 PASS
 Reading ../fits-images/pg93/tst0003.fits
@@ -40,6 +41,7 @@ Simple 32-bit ramp pattern for testing o
     Extend: "T"
     Object: "Ramp 32-bit"
     Origin: "ESO"
+    oiio:subimages: 1
 Comparing "../fits-images/pg93/tst0003.fits" and "tst0003.fits"
 PASS
 Reading ../fits-images/pg93/tst0005.fits
@@ -59,6 +61,7 @@ Simple 32-bit FP sine wave pattern for t
     Extend: "T"
     Object: "Wave 32-bit FP"
     Origin: "ESO"
+    oiio:subimages: 1
 Comparing "../fits-images/pg93/tst0005.fits" and "tst0005.fits"
 PASS
 Reading ../fits-images/pg93/tst0006.fits
@@ -78,6 +81,7 @@ Simple 64-bit FP sine wave pattern for t
     Extend: "T"
     Object: "Wave 64-bit fp"
     Origin: "ESO"
+    oiio:subimages: 1
 Comparing "../fits-images/pg93/tst0006.fits" and "tst0006.fits"
 PASS
 Reading ../fits-images/pg93/tst0007.fits
@@ -134,6 +138,7 @@ So best of luck with the decoding"
     DateTime: "1992:08:20 00:00:00"
     Object: "IEEE 32-bit test"
     Origin: "ESO"
+    oiio:subimages: 1
 Comparing "../fits-images/pg93/tst0007.fits" and "tst0007.fits"
 PASS
 Reading ../fits-images/pg93/tst0008.fits
@@ -189,6 +194,7 @@ So best of luck with the decoding"
     DateTime: "1992:08:20 00:00:00"
     Object: "IEEE 64-bit test"
     Origin: "ESO"
+    oiio:subimages: 1
 Comparing "../fits-images/pg93/tst0008.fits" and "tst0008.fits"
 PASS
 Reading ../fits-images/pg93/tst0013.fits
@@ -246,6 +252,7 @@ ESO DET NCORRS = 'Double '"
     Time-sid: 36564
     Tm-end: 70121
     Tm-start: 69932
+    oiio:subimages: 1
 Comparing "../fits-images/pg93/tst0013.fits" and "tst0013.fits"
 PASS
 Reading ../fits-images/ftt4b/file001.fits
@@ -256,6 +263,7 @@ Reading ../fits-images/ftt4b/file001.fit
     Extend: "T"
     Object: "SNG - CAT."
     Origin: "ESO"
+    oiio:subimages: 1
 Comparing "../fits-images/ftt4b/file001.fits" and "file001.fits"
 PASS
 Reading ../fits-images/ftt4b/file002.fits
@@ -266,6 +274,7 @@ Reading ../fits-images/ftt4b/file002.fit
     Extend: "T"
     Object: "PGSNC - SN.CAT."
     Origin: "ESO"
+    oiio:subimages: 1
 Comparing "../fits-images/ftt4b/file002.fits" and "file002.fits"
 PASS
 Reading ../fits-images/ftt4b/file003.fits
@@ -479,6 +488,7 @@ AIPS   CLEAN NITER= 12000 PRODUCT=1"
     Observer: "LISZ"
     Obsra: 252.167
     Origin: "AIPSNRAO node CVAX       15JUL84"
+    oiio:subimages: 1
 Comparing "../fits-images/ftt4b/file003.fits" and "file003.fits"
 PASS
 Reading ../fits-images/ftt4b/file009.fits
@@ -561,6 +571,7 @@ VLACV ANT   N=22 X=  1021.275 Y= -2683.7
     Pzero4: 0
     Pzero5: 0
     Telescop: "VLA"
+    oiio:subimages: 1
 Comparing "../fits-images/ftt4b/file009.fits" and "file009.fits"
 PASS
 Reading ../fits-images/ftt4b/file012.fits
@@ -698,5 +709,6 @@ AIPS   CLEAN NITER= 12000 PRODUCT=1"
     Observer: "LAIN"
     Origin: "AIPS"
     Tables: 1
+    oiio:subimages: 1
 Comparing "../fits-images/ftt4b/file012.fits" and "file012.fits"
 PASS
diff -pruN 2.5.10.1+dfsg-1/testsuite/heif/ref/out-libheif1.12-orient.txt 2.5.12.0+dfsg-1/testsuite/heif/ref/out-libheif1.12-orient.txt
--- 2.5.10.1+dfsg-1/testsuite/heif/ref/out-libheif1.12-orient.txt	1970-01-01 00:00:00.000000000 +0000
+++ 2.5.12.0+dfsg-1/testsuite/heif/ref/out-libheif1.12-orient.txt	2024-06-01 19:59:05.000000000 +0000
@@ -0,0 +1,147 @@
+Reading ref/IMG_7702_small.heic
+ref/IMG_7702_small.heic :  512 x  300, 3 channel, uint8 heif
+    SHA-1: 337C2EC7F5C2316F2FD31F04067BDC59AB7027AE
+    channel list: R, G, B
+    DateTime: "2019:01:21 16:10:54"
+    ExposureTime: 0.030303
+    FNumber: 1.8
+    Make: "Apple"
+    Model: "iPhone 7"
+    Orientation: 1 (normal)
+    ResolutionUnit: 2 (inches)
+    Software: "12.1.2"
+    XResolution: 72
+    YResolution: 72
+    Exif:ApertureValue: 1.69599 (f/1.8)
+    Exif:BrightnessValue: 3.99501
+    Exif:ColorSpace: 65535
+    Exif:DateTimeDigitized: "2019:01:21 16:10:54"
+    Exif:DateTimeOriginal: "2019:01:21 16:10:54"
+    Exif:ExifVersion: "0221"
+    Exif:ExposureBiasValue: 0
+    Exif:ExposureMode: 0 (auto)
+    Exif:ExposureProgram: 2 (normal program)
+    Exif:Flash: 24 (no flash, auto flash)
+    Exif:FlashPixVersion: "0100"
+    Exif:FocalLength: 3.99 (3.99 mm)
+    Exif:FocalLengthIn35mmFilm: 28
+    Exif:LensMake: "Apple"
+    Exif:LensModel: "iPhone 7 back camera 3.99mm f/1.8"
+    Exif:LensSpecification: 3.99, 3.99, 1.8, 1.8
+    Exif:MeteringMode: 5 (pattern)
+    Exif:PhotographicSensitivity: 20
+    Exif:PixelXDimension: 4032
+    Exif:PixelYDimension: 3024
+    Exif:SceneCaptureType: 0 (standard)
+    Exif:SensingMethod: 2 (1-chip color area)
+    Exif:ShutterSpeedValue: 5.03599 (1/32 s)
+    Exif:SubsecTimeDigitized: "006"
+    Exif:SubsecTimeOriginal: "006"
+    Exif:WhiteBalance: 0 (auto)
+    oiio:ColorSpace: "sRGB"
+Reading ../oiio-images/heif/greyhounds-looking-for-a-table.heic
+../oiio-images/heif/greyhounds-looking-for-a-table.heic : 3024 x 4032, 3 channel, uint8 heif
+    SHA-1: 8211F56BBABDC7615CCAF67CBF49741D1A292D2E
+    channel list: R, G, B
+    DateTime: "2023:09:28 09:44:03"
+    ExposureTime: 0.0135135
+    FNumber: 2.4
+    Make: "Apple"
+    Model: "iPhone 12 Pro"
+    Orientation: 1 (normal)
+    ResolutionUnit: 2 (inches)
+    Software: "16.7"
+    XResolution: 72
+    YResolution: 72
+    Exif:ApertureValue: 2.52607 (f/2.4)
+    Exif:BrightnessValue: 2.7506
+    Exif:ColorSpace: 65535
+    Exif:DateTimeDigitized: "2023:09:28 09:44:03"
+    Exif:DateTimeOriginal: "2023:09:28 09:44:03"
+    Exif:DigitalZoomRatio: 1.3057
+    Exif:ExifVersion: "0232"
+    Exif:ExposureBiasValue: 0
+    Exif:ExposureMode: 0 (auto)
+    Exif:ExposureProgram: 2 (normal program)
+    Exif:Flash: 16 (no flash, flash suppression)
+    Exif:FocalLength: 1.54 (1.54 mm)
+    Exif:FocalLengthIn35mmFilm: 17
+    Exif:LensMake: "Apple"
+    Exif:LensModel: "iPhone 12 Pro back triple camera 1.54mm f/2.4"
+    Exif:LensSpecification: 1.54, 6, 1.6, 2.4
+    Exif:MeteringMode: 5 (pattern)
+    Exif:OffsetTime: "+02:00"
+    Exif:OffsetTimeDigitized: "+02:00"
+    Exif:OffsetTimeOriginal: "+02:00"
+    Exif:PhotographicSensitivity: 320
+    Exif:PixelXDimension: 4032
+    Exif:PixelYDimension: 3024
+    Exif:SensingMethod: 2 (1-chip color area)
+    Exif:ShutterSpeedValue: 6.20983 (1/74 s)
+    Exif:SubsecTimeDigitized: "886"
+    Exif:SubsecTimeOriginal: "886"
+    Exif:WhiteBalance: 0 (auto)
+    GPS:Altitude: 3.24105 (3.24105 m)
+    GPS:AltitudeRef: 0 (above sea level)
+    GPS:DateStamp: "2023:09:28"
+    GPS:DestBearing: 90.2729
+    GPS:DestBearingRef: "T" (true north)
+    GPS:HPositioningError: 5.1893
+    GPS:ImgDirection: 90.2729
+    GPS:ImgDirectionRef: "T" (true north)
+    GPS:Latitude: 41, 50, 58.43
+    GPS:LatitudeRef: "N"
+    GPS:Longitude: 3, 7, 31.98
+    GPS:LongitudeRef: "E"
+    GPS:Speed: 0.171966
+    GPS:SpeedRef: "K" (km/hour)
+    oiio:ColorSpace: "sRGB"
+    oiio:OriginalOrientation: 8
+Reading ../oiio-images/heif/sewing-threads.heic
+../oiio-images/heif/sewing-threads.heic : 4000 x 3000, 3 channel, uint8 heif
+    SHA-1: 6A061BFE2F0BAC4CC94F5D9D5A6E674634149813
+    channel list: R, G, B
+    DateTime: "2023:12:12 18:39:16"
+    ExposureTime: 0.04
+    FNumber: 1.8
+    Make: "samsung"
+    Model: "SM-A326B"
+    Orientation: 1 (normal)
+    ResolutionUnit: 2 (inches)
+    Software: "A326BXXS8CWK2"
+    XResolution: 72
+    YResolution: 72
+    Exif:ApertureValue: 1.69 (f/1.8)
+    Exif:BrightnessValue: 1.19
+    Exif:ColorSpace: 1
+    Exif:DateTimeDigitized: "2023:12:12 18:39:16"
+    Exif:DateTimeOriginal: "2023:12:12 18:39:16"
+    Exif:DigitalZoomRatio: 1
+    Exif:ExifVersion: "0220"
+    Exif:ExposureBiasValue: 0
+    Exif:ExposureMode: 0 (auto)
+    Exif:ExposureProgram: 2 (normal program)
+    Exif:Flash: 0 (no flash)
+    Exif:FocalLength: 4.6 (4.6 mm)
+    Exif:FocalLengthIn35mmFilm: 25
+    Exif:MaxApertureValue: 1.69 (f/1.8)
+    Exif:MeteringMode: 2 (center-weighted average)
+    Exif:OffsetTime: "+01:00"
+    Exif:OffsetTimeOriginal: "+01:00"
+    Exif:PhotographicSensitivity: 500
+    Exif:PixelXDimension: 4000
+    Exif:PixelYDimension: 3000
+    Exif:SceneCaptureType: 0 (standard)
+    Exif:ShutterSpeedValue: 0.04 (1/1 s)
+    Exif:SubsecTime: "576"
+    Exif:SubsecTimeDigitized: "576"
+    Exif:SubsecTimeOriginal: "576"
+    Exif:WhiteBalance: 0 (auto)
+    Exif:YCbCrPositioning: 1
+    GPS:Altitude: 292 (292 m)
+    GPS:AltitudeRef: 0 (above sea level)
+    GPS:Latitude: 41, 43, 33.821
+    GPS:LatitudeRef: "N"
+    GPS:Longitude: 1, 49, 34.0187
+    GPS:LongitudeRef: "E"
+    oiio:ColorSpace: "sRGB"
diff -pruN 2.5.10.1+dfsg-1/testsuite/oiiotool-color/run.py 2.5.12.0+dfsg-1/testsuite/oiiotool-color/run.py
--- 2.5.10.1+dfsg-1/testsuite/oiiotool-color/run.py	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/testsuite/oiiotool-color/run.py	2024-06-01 19:59:05.000000000 +0000
@@ -100,12 +100,12 @@ if float(ociover) >= 2.2 :
 # TODO: should test applying a file transform
 
 # test various behaviors and misbehaviors related to OCIO configs.
-command += oiiotool ("--nostderr --colorconfig missing.ocio -echo 'Nonexistent config'", failureok=True)
+command += oiiotool ("--nostderr --colorconfig missing.ocio -echo \"Nonexistent config\"", failureok=True)
 
 #   What happens when we read an OCIOv2 config? In particular, when building
 #   against OCIOv1, we should at worst have an error message, not crash with
 #   an uncaught exception.
-command += oiiotool ("--nostderr --colorconfig ../common/OpenColorIO/ocio-v2_demo.ocio -echo 'OCIOv2 config Ok'", failureok=True)
+command += oiiotool ("--nostderr --colorconfig ../common/OpenColorIO/ocio-v2_demo.ocio -echo \"OCIOv2 config Ok\"", failureok=True)
 
 
 # To add more tests, just append more lines like the above and also add
diff -pruN 2.5.10.1+dfsg-1/testsuite/openexr-decreasingy/ref/out.txt 2.5.12.0+dfsg-1/testsuite/openexr-decreasingy/ref/out.txt
--- 2.5.10.1+dfsg-1/testsuite/openexr-decreasingy/ref/out.txt	1970-01-01 00:00:00.000000000 +0000
+++ 2.5.12.0+dfsg-1/testsuite/openexr-decreasingy/ref/out.txt	2024-06-01 19:59:05.000000000 +0000
@@ -0,0 +1,74 @@
+Reading ref/decreasingY-resize.exr
+ref/decreasingY-resize.exr : 4080 x 3072, 3 channel, half openexr
+    SHA-1: 34A9F9879CD89E718ABCEE718A779035F6F78666
+    channel list: R, G, B
+    compression: "zip"
+    DateTime: "2013:04:16 10:20:35"
+    Orientation: 1 (normal)
+    PixelAspectRatio: 1
+    ResolutionUnit: "in"
+    screenWindowCenter: 0, 0
+    screenWindowWidth: 1
+    Software: "OpenImageIO 2.6.2.0dev : oiiotool ../common/tahoe-tiny.tif --resize 4080x3072 -o ref/decreasingY-resize.exr"
+    XResolution: 72
+    YResolution: 72
+    Exif:ImageHistory: "oiiotool ../common/tahoe-tiny.tif --resize 4080x3072 -o ref/decreasingY-resize.exr"
+    oiio:ColorSpace: "Linear"
+    oiio:subimages: 1
+Reading ref/decreasingY-copy.exr
+ref/decreasingY-copy.exr : 4080 x 3072, 3 channel, half openexr
+    SHA-1: 34A9F9879CD89E718ABCEE718A779035F6F78666
+    channel list: R, G, B
+    compression: "zip"
+    DateTime: "2013:04:16 10:20:35"
+    Orientation: 1 (normal)
+    PixelAspectRatio: 1
+    ResolutionUnit: "in"
+    screenWindowCenter: 0, 0
+    screenWindowWidth: 1
+    Software: "OpenImageIO 2.6.2.0dev : oiiotool ref/decreasingY-resize.exr -o ref/decreasingY-copy.exr"
+    XResolution: 72
+    YResolution: 72
+    Exif:ImageHistory: "oiiotool ../common/tahoe-tiny.tif --resize 4080x3072 -o ref/decreasingY-resize.exr
+oiiotool ref/decreasingY-resize.exr -o ref/decreasingY-copy.exr"
+    oiio:ColorSpace: "Linear"
+    oiio:subimages: 1
+Reading decreasingY-resize.exr
+decreasingY-resize.exr : 4080 x 3072, 3 channel, half openexr
+    SHA-1: 34A9F9879CD89E718ABCEE718A779035F6F78666
+    channel list: R, G, B
+    compression: "zip"
+    DateTime: "2013:04:16 10:20:35"
+    Orientation: 1 (normal)
+    PixelAspectRatio: 1
+    ResolutionUnit: "in"
+    screenWindowCenter: 0, 0
+    screenWindowWidth: 1
+    Software: "OpenImageIO 2.6.2.0dev : oiiotool ../common/tahoe-tiny.tif --resize 4080x3072 --attrib openexr:lineOrder decreasingY -o decreasingY-resize.exr"
+    XResolution: 72
+    YResolution: 72
+    Exif:ImageHistory: "oiiotool ../common/tahoe-tiny.tif --resize 4080x3072 --attrib openexr:lineOrder decreasingY -o decreasingY-resize.exr"
+    oiio:ColorSpace: "Linear"
+    oiio:subimages: 1
+Reading decreasingY-copy.exr
+decreasingY-copy.exr : 4080 x 3072, 3 channel, half openexr
+    SHA-1: 34A9F9879CD89E718ABCEE718A779035F6F78666
+    channel list: R, G, B
+    compression: "zip"
+    DateTime: "2013:04:16 10:20:35"
+    Orientation: 1 (normal)
+    PixelAspectRatio: 1
+    ResolutionUnit: "in"
+    screenWindowCenter: 0, 0
+    screenWindowWidth: 1
+    Software: "OpenImageIO 2.6.2.0dev : oiiotool ref/decreasingY-resize.exr --attrib openexr:lineOrder decreasingY -o decreasingY-copy.exr"
+    XResolution: 72
+    YResolution: 72
+    Exif:ImageHistory: "oiiotool ../common/tahoe-tiny.tif --resize 4080x3072 -o ref/decreasingY-resize.exr
+oiiotool ref/decreasingY-resize.exr --attrib openexr:lineOrder decreasingY -o decreasingY-copy.exr"
+    oiio:ColorSpace: "Linear"
+    oiio:subimages: 1
+Comparing "decreasingY-resize.exr" and "ref/decreasingY-resize.exr"
+PASS
+Comparing "decreasingY-copy.exr" and "ref/decreasingY-copy.exr"
+PASS
diff -pruN 2.5.10.1+dfsg-1/testsuite/openexr-decreasingy/run.py 2.5.12.0+dfsg-1/testsuite/openexr-decreasingy/run.py
--- 2.5.10.1+dfsg-1/testsuite/openexr-decreasingy/run.py	1970-01-01 00:00:00.000000000 +0000
+++ 2.5.12.0+dfsg-1/testsuite/openexr-decreasingy/run.py	2024-06-01 19:59:05.000000000 +0000
@@ -0,0 +1,41 @@
+#!/usr/bin/env python
+
+# Copyright Contributors to the OpenImageIO project.
+# SPDX-License-Identifier: Apache-2.0
+# https://github.com/AcademySoftwareFoundation/OpenImageIO
+
+import os, sys
+
+####################################################################
+# Verify decreasingY line order generates same image as increasingY (default).
+####################################################################
+
+# Capture error output
+redirect = " >> out.txt 2>&1 "
+
+# Create reference images stored in increasingY order (default)
+# Resizing to a large image size to ensure scanline chunking logic is triggered.
+command += oiiotool("../common/tahoe-tiny.tif --resize 4080x3072 -o ref/decreasingY-resize.exr")
+command += info_command("ref/decreasingY-resize.exr")
+command += oiiotool("ref/decreasingY-resize.exr -o ref/decreasingY-copy.exr")
+command += info_command("ref/decreasingY-copy.exr")
+
+# Create an image in decreasing order via resizing (Tests ImageOutput::write_image() logic)
+command += oiiotool("../common/tahoe-tiny.tif --resize 4080x3072 --attrib openexr:lineOrder decreasingY -o decreasingY-resize.exr")
+command += info_command("decreasingY-resize.exr")
+
+# Create an image in decreasing order via copying a reference image. (Tests ImageBuf::write() logic)
+command += oiiotool("ref/decreasingY-resize.exr --attrib openexr:lineOrder decreasingY -o decreasingY-copy.exr")
+command += info_command("decreasingY-copy.exr")
+
+# Outputs to check against references.
+# This makes sure the images look the same since the line order is a storage detail and should not
+# change how the image actually looks. These comparisons help verify chunk order and scanlines are
+# processed properly.
+outputs = [
+    "decreasingY-resize.exr",
+    "decreasingY-copy.exr",
+]
+
+
+#print "Running this command:\n" + command + "\n"
\ No newline at end of file
diff -pruN 2.5.10.1+dfsg-1/testsuite/pnm/ref/out.txt 2.5.12.0+dfsg-1/testsuite/pnm/ref/out.txt
--- 2.5.10.1+dfsg-1/testsuite/pnm/ref/out.txt	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/testsuite/pnm/ref/out.txt	2024-06-01 19:59:05.000000000 +0000
@@ -54,15 +54,18 @@ Reading ../oiio-images/pnm/test-1.pfm
     channel list: R, G, B
     oiio:ColorSpace: "Rec709"
     pnm:bigendian: 0
+    pnm:binary: 1
 Reading ../oiio-images/pnm/test-2.pfm
 ../oiio-images/pnm/test-2.pfm :  240 x  240, 3 channel, float pnm
     SHA-1: 312B084985EF1B9C20D35A9D7A5DC8E8EAEB25A0
     channel list: R, G, B
     oiio:ColorSpace: "Rec709"
     pnm:bigendian: 0
+    pnm:binary: 1
 Reading ../oiio-images/pnm/test-3.pfm
 ../oiio-images/pnm/test-3.pfm :  240 x  240, 3 channel, float pnm
     SHA-1: 613A9639725F51ADC8B6F8F5A38DB5EFF0B3A628
     channel list: R, G, B
     oiio:ColorSpace: "Rec709"
     pnm:bigendian: 1
+    pnm:binary: 1
diff -pruN 2.5.10.1+dfsg-1/testsuite/psd/ref/out.txt 2.5.12.0+dfsg-1/testsuite/psd/ref/out.txt
--- 2.5.10.1+dfsg-1/testsuite/psd/ref/out.txt	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/testsuite/psd/ref/out.txt	2024-06-01 19:59:05.000000000 +0000
@@ -584,7 +584,7 @@ Reading ../oiio-images/psd_rgb_8.psd
     stRef:originalDocumentID: "E146B3E37A92795EE3EA6577040DE6D5"
 Reading ../oiio-images/psd_rgb_16.psd
 ../oiio-images/psd_rgb_16.psd :  320 x  240, 3 channel, uint16 psd
-    SHA-1: E42334B0F0684E3C3BF9125F2920B07C44C17B11
+    SHA-1: 591F6850EB0B548DF2CE7177661440CB812E5C31
     channel list: R, G, B
     Artist: "Daniel Wyatt"
     DateTime: "2007-01-18T15:49:21"
@@ -655,7 +655,7 @@ Reading ../oiio-images/psd_rgb_16.psd
     stRef:originalDocumentID: "E146B3E37A92795EE3EA6577040DE6D5"
 Reading ../oiio-images/psd_rgb_32.psd
 ../oiio-images/psd_rgb_32.psd :  320 x  240, 3 channel, float psd
-    SHA-1: 63CF8F7B010D24EFD3C41F51C16D8D285FE07313
+    SHA-1: B7F8CE4B4259A92AA13333EA8112C3E37C6BAB39
     channel list: R, G, B
     Artist: "Daniel Wyatt"
     DateTime: "2007-01-18T15:49:21"
@@ -1261,3 +1261,572 @@ oiiotool ERROR: read : Corrupt thumbnail
 failed to open "src/crash-thumb-1626.psd": failed load_resources
 Full command line was:
 > oiiotool --info -v -a --hash src/crash-thumb-1626.psd
+Reading src/Layers_8bit_RGB.psd
+src/Layers_8bit_RGB.psd :   48 x   27, 3 channel, uint8 psd
+    4 subimages: 48x27 [u8,u8,u8], 48x27 [u8,u8,u8,u8], 48x27 [u8,u8,u8,u8], 48x27 [u8,u8,u8,u8]
+ subimage  0:   48 x   27, 3 channel, uint8 psd
+    SHA-1: AF5EF97B5D5B5AFB6578005E416C5F7E636FE9E4
+    channel list: R, G, B
+    DateTime: "2024-03-06T15:22:40+01:00"
+    ICCProfile: 0, 0, 12, 72, 76, 105, 110, 111, 2, 16, 0, 0, 109, 110, 116, 114, ... [3144 x uint8]
+    Orientation: 1 (normal)
+    PixelAspectRatio: 1
+    ResolutionUnit: "in"
+    Software: "Adobe Photoshop 23.3 (Windows)"
+    thumbnail_height: 27
+    thumbnail_nchannels: 3
+    thumbnail_width: 48
+    XResolution: 72
+    YResolution: 72
+    Exif:ColorSpace: 1
+    Exif:PixelXDimension: 48
+    Exif:PixelYDimension: 27
+    exrio:name: "applied_color_corrections; cameraAperture; cameraFNumber; cameraFarClip; cameraFarRange; cameraFocalLength; cameraFov; cameraNearClip; cameraNearRange; cameraProjection; cameraTargetDistance; cameraTransform; channels; compression; cryptomatte/881c23b/conversion; cryptomatte/881c23b/hash; cryptomatte/881c23b/manifest; cryptomatte/881c23b/name; dataWindow; displayWindow; lineOrder; name; pixelAspectRatio; screenWindowCenter; screenWindowWidth; type; vfb2_layers_json; vrayChannelInfo; vrayInfo/camera; vrayInfo/cameraPerPix; vrayInfo/cameraRayCountID; vrayInfo/cleanupTimeID; vrayInfo/computername; vrayInfo/cpu; vrayInfo/date; vrayInfo/elapsedtime; vrayInfo/engine; vrayInfo/filename; vrayInfo/frame; vrayInfo/frameTimeID; vrayInfo/freeMemCPU; vrayInfo/giPerPix; vrayInfo/giRayCountID; vrayInfo/h; vrayInfo/infinitePrimsID; vrayInfo/kpaths; vrayInfo/lightcacheTimeID; vrayInfo/mbTrisID"
+    exrio:type: "int; float; m44f; chlist; compression; string; box2i; lineOrder; v2f"
+    exrio:value: 0, 0
+    IPTC:DocumentID: "adobe:docid:photoshop:a9aabed2-61e6-1c48-b9c0-22e2e6b3631a"
+    IPTC:InstanceID: "xmp.iid:91e10371-aef4-e042-b01b-18a054353721"
+    IPTC:MetadataDate: "2024-04-01T19:35:40+02:00"
+    IPTC:ModifyDate: "2024-04-01T19:35:40+02:00"
+    IPTC:OriginalDocumentID: "xmp.did:68fcb000-4377-c148-974d-bdd193ca024d"
+    oiio:ColorSpace: "sRGB"
+    photoshop:ColorMode: 3
+    photoshop:ICCProfile: "sRGB IEC61966-2.1"
+    rdf:parseType: "Resource"
+    rdf:resource: "http://doc.exr-io.com/metadata/1.0/attribute"
+    stEvt:action: "saved"
+    stEvt:changed: "/"
+    stEvt:instanceID: "xmp.iid:68fcb000-4377-c148-974d-bdd193ca024d; xmp.iid:91e10371-aef4-e042-b01b-18a054353721"
+    stEvt:softwareAgent: "Adobe Photoshop 23.3 (Windows)"
+    stEvt:when: "2024-04-01T19:35:16+02:00; 2024-04-01T19:35:40+02:00"
+ subimage  1:   48 x   27, 4 channel, uint8 psd
+    SHA-1: 5AF647DD416B325A60135DC52F75AEE5CA748C5A
+    channel list: R, G, B, A
+    DateTime: "2024-03-06T15:22:40+01:00"
+    ICCProfile: 0, 0, 12, 72, 76, 105, 110, 111, 2, 16, 0, 0, 109, 110, 116, 114, ... [3144 x uint8]
+    Orientation: 1 (normal)
+    PixelAspectRatio: 1
+    ResolutionUnit: "in"
+    Software: "Adobe Photoshop 23.3 (Windows)"
+    XResolution: 72
+    YResolution: 72
+    Exif:ColorSpace: 1
+    Exif:PixelXDimension: 48
+    Exif:PixelYDimension: 27
+    exrio:name: "applied_color_corrections; cameraAperture; cameraFNumber; cameraFarClip; cameraFarRange; cameraFocalLength; cameraFov; cameraNearClip; cameraNearRange; cameraProjection; cameraTargetDistance; cameraTransform; channels; compression; cryptomatte/881c23b/conversion; cryptomatte/881c23b/hash; cryptomatte/881c23b/manifest; cryptomatte/881c23b/name; dataWindow; displayWindow; lineOrder; name; pixelAspectRatio; screenWindowCenter; screenWindowWidth; type; vfb2_layers_json; vrayChannelInfo; vrayInfo/camera; vrayInfo/cameraPerPix; vrayInfo/cameraRayCountID; vrayInfo/cleanupTimeID; vrayInfo/computername; vrayInfo/cpu; vrayInfo/date; vrayInfo/elapsedtime; vrayInfo/engine; vrayInfo/filename; vrayInfo/frame; vrayInfo/frameTimeID; vrayInfo/freeMemCPU; vrayInfo/giPerPix; vrayInfo/giRayCountID; vrayInfo/h; vrayInfo/infinitePrimsID; vrayInfo/kpaths; vrayInfo/lightcacheTimeID; vrayInfo/mbTrisID"
+    exrio:type: "int; float; m44f; chlist; compression; string; box2i; lineOrder; v2f"
+    exrio:value: 0, 0
+    ICCProfile:attributes: "Reflective, Glossy, Positive, Color"
+    ICCProfile:cmm_type: 1281977967
+    ICCProfile:color_space: "RGB"
+    ICCProfile:copyright: "Copyright (c) 1998 Hewlett-Packard Company"
+    ICCProfile:creation_date: "1998:02:09 06:49:00"
+    ICCProfile:creator_signature: "48502020"
+    ICCProfile:device_class: "Display device profile"
+    ICCProfile:device_manufacturer_description: "IEC http://www.iec.ch"
+    ICCProfile:device_model_description: "IEC 61966-2.1 Default RGB colour space - sRGB"
+    ICCProfile:flags: "Not Embedded, Independent"
+    ICCProfile:manufacturer: "49454320"
+    ICCProfile:model: "73524742"
+    ICCProfile:platform_signature: "Microsoft Corporation"
+    ICCProfile:profile_connection_space: "XYZ"
+    ICCProfile:profile_description: "sRGB IEC61966-2.1"
+    ICCProfile:profile_size: 3144
+    ICCProfile:profile_version: "2.1.0"
+    ICCProfile:rendering_intent: "Media-relative colorimetric"
+    ICCProfile:viewing_conditions_description: "Reference Viewing Condition in IEC61966-2.1"
+    IPTC:DocumentID: "adobe:docid:photoshop:a9aabed2-61e6-1c48-b9c0-22e2e6b3631a"
+    IPTC:InstanceID: "xmp.iid:91e10371-aef4-e042-b01b-18a054353721"
+    IPTC:MetadataDate: "2024-04-01T19:35:40+02:00"
+    IPTC:ModifyDate: "2024-04-01T19:35:40+02:00"
+    IPTC:OriginalDocumentID: "xmp.did:68fcb000-4377-c148-974d-bdd193ca024d"
+    oiio:ColorSpace: "sRGB"
+    oiio:subimagename: "Blue_Lagoon"
+    photoshop:ColorMode: 3
+    photoshop:ICCProfile: "sRGB IEC61966-2.1"
+    rdf:parseType: "Resource"
+    rdf:resource: "http://doc.exr-io.com/metadata/1.0/attribute"
+    stEvt:action: "saved"
+    stEvt:changed: "/"
+    stEvt:instanceID: "xmp.iid:68fcb000-4377-c148-974d-bdd193ca024d; xmp.iid:91e10371-aef4-e042-b01b-18a054353721"
+    stEvt:softwareAgent: "Adobe Photoshop 23.3 (Windows)"
+    stEvt:when: "2024-04-01T19:35:16+02:00; 2024-04-01T19:35:40+02:00"
+ subimage  2:   48 x   27, 4 channel, uint8 psd
+    SHA-1: C303E1C0CD86E2F3411D8337B29F52D8214DA091
+    channel list: R, G, B, A
+    DateTime: "2024-03-06T15:22:40+01:00"
+    ICCProfile: 0, 0, 12, 72, 76, 105, 110, 111, 2, 16, 0, 0, 109, 110, 116, 114, ... [3144 x uint8]
+    Orientation: 1 (normal)
+    PixelAspectRatio: 1
+    ResolutionUnit: "in"
+    Software: "Adobe Photoshop 23.3 (Windows)"
+    XResolution: 72
+    YResolution: 72
+    Exif:ColorSpace: 1
+    Exif:PixelXDimension: 48
+    Exif:PixelYDimension: 27
+    exrio:name: "applied_color_corrections; cameraAperture; cameraFNumber; cameraFarClip; cameraFarRange; cameraFocalLength; cameraFov; cameraNearClip; cameraNearRange; cameraProjection; cameraTargetDistance; cameraTransform; channels; compression; cryptomatte/881c23b/conversion; cryptomatte/881c23b/hash; cryptomatte/881c23b/manifest; cryptomatte/881c23b/name; dataWindow; displayWindow; lineOrder; name; pixelAspectRatio; screenWindowCenter; screenWindowWidth; type; vfb2_layers_json; vrayChannelInfo; vrayInfo/camera; vrayInfo/cameraPerPix; vrayInfo/cameraRayCountID; vrayInfo/cleanupTimeID; vrayInfo/computername; vrayInfo/cpu; vrayInfo/date; vrayInfo/elapsedtime; vrayInfo/engine; vrayInfo/filename; vrayInfo/frame; vrayInfo/frameTimeID; vrayInfo/freeMemCPU; vrayInfo/giPerPix; vrayInfo/giRayCountID; vrayInfo/h; vrayInfo/infinitePrimsID; vrayInfo/kpaths; vrayInfo/lightcacheTimeID; vrayInfo/mbTrisID"
+    exrio:type: "int; float; m44f; chlist; compression; string; box2i; lineOrder; v2f"
+    exrio:value: 0, 0
+    ICCProfile:attributes: "Reflective, Glossy, Positive, Color"
+    ICCProfile:cmm_type: 1281977967
+    ICCProfile:color_space: "RGB"
+    ICCProfile:copyright: "Copyright (c) 1998 Hewlett-Packard Company"
+    ICCProfile:creation_date: "1998:02:09 06:49:00"
+    ICCProfile:creator_signature: "48502020"
+    ICCProfile:device_class: "Display device profile"
+    ICCProfile:device_manufacturer_description: "IEC http://www.iec.ch"
+    ICCProfile:device_model_description: "IEC 61966-2.1 Default RGB colour space - sRGB"
+    ICCProfile:flags: "Not Embedded, Independent"
+    ICCProfile:manufacturer: "49454320"
+    ICCProfile:model: "73524742"
+    ICCProfile:platform_signature: "Microsoft Corporation"
+    ICCProfile:profile_connection_space: "XYZ"
+    ICCProfile:profile_description: "sRGB IEC61966-2.1"
+    ICCProfile:profile_size: 3144
+    ICCProfile:profile_version: "2.1.0"
+    ICCProfile:rendering_intent: "Media-relative colorimetric"
+    ICCProfile:viewing_conditions_description: "Reference Viewing Condition in IEC61966-2.1"
+    IPTC:DocumentID: "adobe:docid:photoshop:a9aabed2-61e6-1c48-b9c0-22e2e6b3631a"
+    IPTC:InstanceID: "xmp.iid:91e10371-aef4-e042-b01b-18a054353721"
+    IPTC:MetadataDate: "2024-04-01T19:35:40+02:00"
+    IPTC:ModifyDate: "2024-04-01T19:35:40+02:00"
+    IPTC:OriginalDocumentID: "xmp.did:68fcb000-4377-c148-974d-bdd193ca024d"
+    oiio:ColorSpace: "sRGB"
+    oiio:subimagename: "Layer"
+    photoshop:ColorMode: 3
+    photoshop:ICCProfile: "sRGB IEC61966-2.1"
+    rdf:parseType: "Resource"
+    rdf:resource: "http://doc.exr-io.com/metadata/1.0/attribute"
+    stEvt:action: "saved"
+    stEvt:changed: "/"
+    stEvt:instanceID: "xmp.iid:68fcb000-4377-c148-974d-bdd193ca024d; xmp.iid:91e10371-aef4-e042-b01b-18a054353721"
+    stEvt:softwareAgent: "Adobe Photoshop 23.3 (Windows)"
+    stEvt:when: "2024-04-01T19:35:16+02:00; 2024-04-01T19:35:40+02:00"
+ subimage  3:   48 x   27, 4 channel, uint8 psd
+    SHA-1: 79CF5E0C494DA95DF6EAADDC2CA0DD4D0CF4286C
+    channel list: R, G, B, A
+    DateTime: "2024-03-06T15:22:40+01:00"
+    ICCProfile: 0, 0, 12, 72, 76, 105, 110, 111, 2, 16, 0, 0, 109, 110, 116, 114, ... [3144 x uint8]
+    Orientation: 1 (normal)
+    PixelAspectRatio: 1
+    ResolutionUnit: "in"
+    Software: "Adobe Photoshop 23.3 (Windows)"
+    XResolution: 72
+    YResolution: 72
+    Exif:ColorSpace: 1
+    Exif:PixelXDimension: 48
+    Exif:PixelYDimension: 27
+    exrio:name: "applied_color_corrections; cameraAperture; cameraFNumber; cameraFarClip; cameraFarRange; cameraFocalLength; cameraFov; cameraNearClip; cameraNearRange; cameraProjection; cameraTargetDistance; cameraTransform; channels; compression; cryptomatte/881c23b/conversion; cryptomatte/881c23b/hash; cryptomatte/881c23b/manifest; cryptomatte/881c23b/name; dataWindow; displayWindow; lineOrder; name; pixelAspectRatio; screenWindowCenter; screenWindowWidth; type; vfb2_layers_json; vrayChannelInfo; vrayInfo/camera; vrayInfo/cameraPerPix; vrayInfo/cameraRayCountID; vrayInfo/cleanupTimeID; vrayInfo/computername; vrayInfo/cpu; vrayInfo/date; vrayInfo/elapsedtime; vrayInfo/engine; vrayInfo/filename; vrayInfo/frame; vrayInfo/frameTimeID; vrayInfo/freeMemCPU; vrayInfo/giPerPix; vrayInfo/giRayCountID; vrayInfo/h; vrayInfo/infinitePrimsID; vrayInfo/kpaths; vrayInfo/lightcacheTimeID; vrayInfo/mbTrisID"
+    exrio:type: "int; float; m44f; chlist; compression; string; box2i; lineOrder; v2f"
+    exrio:value: 0, 0
+    ICCProfile:attributes: "Reflective, Glossy, Positive, Color"
+    ICCProfile:cmm_type: 1281977967
+    ICCProfile:color_space: "RGB"
+    ICCProfile:copyright: "Copyright (c) 1998 Hewlett-Packard Company"
+    ICCProfile:creation_date: "1998:02:09 06:49:00"
+    ICCProfile:creator_signature: "48502020"
+    ICCProfile:device_class: "Display device profile"
+    ICCProfile:device_manufacturer_description: "IEC http://www.iec.ch"
+    ICCProfile:device_model_description: "IEC 61966-2.1 Default RGB colour space - sRGB"
+    ICCProfile:flags: "Not Embedded, Independent"
+    ICCProfile:manufacturer: "49454320"
+    ICCProfile:model: "73524742"
+    ICCProfile:platform_signature: "Microsoft Corporation"
+    ICCProfile:profile_connection_space: "XYZ"
+    ICCProfile:profile_description: "sRGB IEC61966-2.1"
+    ICCProfile:profile_size: 3144
+    ICCProfile:profile_version: "2.1.0"
+    ICCProfile:rendering_intent: "Media-relative colorimetric"
+    ICCProfile:viewing_conditions_description: "Reference Viewing Condition in IEC61966-2.1"
+    IPTC:DocumentID: "adobe:docid:photoshop:a9aabed2-61e6-1c48-b9c0-22e2e6b3631a"
+    IPTC:InstanceID: "xmp.iid:91e10371-aef4-e042-b01b-18a054353721"
+    IPTC:MetadataDate: "2024-04-01T19:35:40+02:00"
+    IPTC:ModifyDate: "2024-04-01T19:35:40+02:00"
+    IPTC:OriginalDocumentID: "xmp.did:68fcb000-4377-c148-974d-bdd193ca024d"
+    oiio:ColorSpace: "sRGB"
+    oiio:subimagename: "Layer2"
+    photoshop:ColorMode: 3
+    photoshop:ICCProfile: "sRGB IEC61966-2.1"
+    rdf:parseType: "Resource"
+    rdf:resource: "http://doc.exr-io.com/metadata/1.0/attribute"
+    stEvt:action: "saved"
+    stEvt:changed: "/"
+    stEvt:instanceID: "xmp.iid:68fcb000-4377-c148-974d-bdd193ca024d; xmp.iid:91e10371-aef4-e042-b01b-18a054353721"
+    stEvt:softwareAgent: "Adobe Photoshop 23.3 (Windows)"
+    stEvt:when: "2024-04-01T19:35:16+02:00; 2024-04-01T19:35:40+02:00"
+Reading src/Layers_16bit_RGB.psd
+src/Layers_16bit_RGB.psd :   48 x   27, 3 channel, uint16 psd
+    4 subimages: 48x27 [u16,u16,u16], 48x27 [u16,u16,u16,u16], 48x27 [u16,u16,u16,u16], 48x27 [u16,u16,u16,u16]
+ subimage  0:   48 x   27, 3 channel, uint16 psd
+    SHA-1: 22EAC1FF517BCCEA8EBA31AB240C11518EE42424
+    channel list: R, G, B
+    DateTime: "2024-03-06T15:22:40+01:00"
+    ICCProfile: 0, 0, 12, 72, 76, 105, 110, 111, 2, 16, 0, 0, 109, 110, 116, 114, ... [3144 x uint8]
+    Orientation: 1 (normal)
+    PixelAspectRatio: 1
+    ResolutionUnit: "in"
+    Software: "Adobe Photoshop 23.3 (Windows)"
+    thumbnail_height: 27
+    thumbnail_nchannels: 3
+    thumbnail_width: 48
+    XResolution: 72
+    YResolution: 72
+    Exif:ColorSpace: 1
+    Exif:PixelXDimension: 48
+    Exif:PixelYDimension: 27
+    exrio:name: "applied_color_corrections; cameraAperture; cameraFNumber; cameraFarClip; cameraFarRange; cameraFocalLength; cameraFov; cameraNearClip; cameraNearRange; cameraProjection; cameraTargetDistance; cameraTransform; channels; compression; cryptomatte/881c23b/conversion; cryptomatte/881c23b/hash; cryptomatte/881c23b/manifest; cryptomatte/881c23b/name; dataWindow; displayWindow; lineOrder; name; pixelAspectRatio; screenWindowCenter; screenWindowWidth; type; vfb2_layers_json; vrayChannelInfo; vrayInfo/camera; vrayInfo/cameraPerPix; vrayInfo/cameraRayCountID; vrayInfo/cleanupTimeID; vrayInfo/computername; vrayInfo/cpu; vrayInfo/date; vrayInfo/elapsedtime; vrayInfo/engine; vrayInfo/filename; vrayInfo/frame; vrayInfo/frameTimeID; vrayInfo/freeMemCPU; vrayInfo/giPerPix; vrayInfo/giRayCountID; vrayInfo/h; vrayInfo/infinitePrimsID; vrayInfo/kpaths; vrayInfo/lightcacheTimeID; vrayInfo/mbTrisID"
+    exrio:type: "int; float; m44f; chlist; compression; string; box2i; lineOrder; v2f"
+    exrio:value: 0, 0
+    IPTC:DocumentID: "adobe:docid:photoshop:d0b5fcf6-f464-234f-b5df-47c18ab8b898"
+    IPTC:InstanceID: "xmp.iid:709ebe80-9e41-244a-81bc-8a5e754fe63e"
+    IPTC:MetadataDate: "2024-04-01T19:35:30+02:00"
+    IPTC:ModifyDate: "2024-04-01T19:35:30+02:00"
+    IPTC:OriginalDocumentID: "xmp.did:68fcb000-4377-c148-974d-bdd193ca024d"
+    oiio:ColorSpace: "sRGB"
+    photoshop:ColorMode: 3
+    photoshop:ICCProfile: "sRGB IEC61966-2.1"
+    rdf:parseType: "Resource"
+    rdf:resource: "http://doc.exr-io.com/metadata/1.0/attribute"
+    stEvt:action: "saved"
+    stEvt:changed: "/"
+    stEvt:instanceID: "xmp.iid:68fcb000-4377-c148-974d-bdd193ca024d; xmp.iid:709ebe80-9e41-244a-81bc-8a5e754fe63e"
+    stEvt:softwareAgent: "Adobe Photoshop 23.3 (Windows)"
+    stEvt:when: "2024-04-01T19:35:16+02:00; 2024-04-01T19:35:30+02:00"
+ subimage  1:   48 x   27, 4 channel, uint16 psd
+    SHA-1: 0D572837DF5C07DB70A5C63B355CE285439813A3
+    channel list: R, G, B, A
+    DateTime: "2024-03-06T15:22:40+01:00"
+    ICCProfile: 0, 0, 12, 72, 76, 105, 110, 111, 2, 16, 0, 0, 109, 110, 116, 114, ... [3144 x uint8]
+    Orientation: 1 (normal)
+    PixelAspectRatio: 1
+    ResolutionUnit: "in"
+    Software: "Adobe Photoshop 23.3 (Windows)"
+    XResolution: 72
+    YResolution: 72
+    Exif:ColorSpace: 1
+    Exif:PixelXDimension: 48
+    Exif:PixelYDimension: 27
+    exrio:name: "applied_color_corrections; cameraAperture; cameraFNumber; cameraFarClip; cameraFarRange; cameraFocalLength; cameraFov; cameraNearClip; cameraNearRange; cameraProjection; cameraTargetDistance; cameraTransform; channels; compression; cryptomatte/881c23b/conversion; cryptomatte/881c23b/hash; cryptomatte/881c23b/manifest; cryptomatte/881c23b/name; dataWindow; displayWindow; lineOrder; name; pixelAspectRatio; screenWindowCenter; screenWindowWidth; type; vfb2_layers_json; vrayChannelInfo; vrayInfo/camera; vrayInfo/cameraPerPix; vrayInfo/cameraRayCountID; vrayInfo/cleanupTimeID; vrayInfo/computername; vrayInfo/cpu; vrayInfo/date; vrayInfo/elapsedtime; vrayInfo/engine; vrayInfo/filename; vrayInfo/frame; vrayInfo/frameTimeID; vrayInfo/freeMemCPU; vrayInfo/giPerPix; vrayInfo/giRayCountID; vrayInfo/h; vrayInfo/infinitePrimsID; vrayInfo/kpaths; vrayInfo/lightcacheTimeID; vrayInfo/mbTrisID"
+    exrio:type: "int; float; m44f; chlist; compression; string; box2i; lineOrder; v2f"
+    exrio:value: 0, 0
+    ICCProfile:attributes: "Reflective, Glossy, Positive, Color"
+    ICCProfile:cmm_type: 1281977967
+    ICCProfile:color_space: "RGB"
+    ICCProfile:copyright: "Copyright (c) 1998 Hewlett-Packard Company"
+    ICCProfile:creation_date: "1998:02:09 06:49:00"
+    ICCProfile:creator_signature: "48502020"
+    ICCProfile:device_class: "Display device profile"
+    ICCProfile:device_manufacturer_description: "IEC http://www.iec.ch"
+    ICCProfile:device_model_description: "IEC 61966-2.1 Default RGB colour space - sRGB"
+    ICCProfile:flags: "Not Embedded, Independent"
+    ICCProfile:manufacturer: "49454320"
+    ICCProfile:model: "73524742"
+    ICCProfile:platform_signature: "Microsoft Corporation"
+    ICCProfile:profile_connection_space: "XYZ"
+    ICCProfile:profile_description: "sRGB IEC61966-2.1"
+    ICCProfile:profile_size: 3144
+    ICCProfile:profile_version: "2.1.0"
+    ICCProfile:rendering_intent: "Media-relative colorimetric"
+    ICCProfile:viewing_conditions_description: "Reference Viewing Condition in IEC61966-2.1"
+    IPTC:DocumentID: "adobe:docid:photoshop:d0b5fcf6-f464-234f-b5df-47c18ab8b898"
+    IPTC:InstanceID: "xmp.iid:709ebe80-9e41-244a-81bc-8a5e754fe63e"
+    IPTC:MetadataDate: "2024-04-01T19:35:30+02:00"
+    IPTC:ModifyDate: "2024-04-01T19:35:30+02:00"
+    IPTC:OriginalDocumentID: "xmp.did:68fcb000-4377-c148-974d-bdd193ca024d"
+    oiio:ColorSpace: "sRGB"
+    oiio:subimagename: "Blue_Lagoon"
+    photoshop:ColorMode: 3
+    photoshop:ICCProfile: "sRGB IEC61966-2.1"
+    rdf:parseType: "Resource"
+    rdf:resource: "http://doc.exr-io.com/metadata/1.0/attribute"
+    stEvt:action: "saved"
+    stEvt:changed: "/"
+    stEvt:instanceID: "xmp.iid:68fcb000-4377-c148-974d-bdd193ca024d; xmp.iid:709ebe80-9e41-244a-81bc-8a5e754fe63e"
+    stEvt:softwareAgent: "Adobe Photoshop 23.3 (Windows)"
+    stEvt:when: "2024-04-01T19:35:16+02:00; 2024-04-01T19:35:30+02:00"
+ subimage  2:   48 x   27, 4 channel, uint16 psd
+    SHA-1: 31AB60835F2FB36DEBEE8FF56FB8D08F4A8F126D
+    channel list: R, G, B, A
+    DateTime: "2024-03-06T15:22:40+01:00"
+    ICCProfile: 0, 0, 12, 72, 76, 105, 110, 111, 2, 16, 0, 0, 109, 110, 116, 114, ... [3144 x uint8]
+    Orientation: 1 (normal)
+    PixelAspectRatio: 1
+    ResolutionUnit: "in"
+    Software: "Adobe Photoshop 23.3 (Windows)"
+    XResolution: 72
+    YResolution: 72
+    Exif:ColorSpace: 1
+    Exif:PixelXDimension: 48
+    Exif:PixelYDimension: 27
+    exrio:name: "applied_color_corrections; cameraAperture; cameraFNumber; cameraFarClip; cameraFarRange; cameraFocalLength; cameraFov; cameraNearClip; cameraNearRange; cameraProjection; cameraTargetDistance; cameraTransform; channels; compression; cryptomatte/881c23b/conversion; cryptomatte/881c23b/hash; cryptomatte/881c23b/manifest; cryptomatte/881c23b/name; dataWindow; displayWindow; lineOrder; name; pixelAspectRatio; screenWindowCenter; screenWindowWidth; type; vfb2_layers_json; vrayChannelInfo; vrayInfo/camera; vrayInfo/cameraPerPix; vrayInfo/cameraRayCountID; vrayInfo/cleanupTimeID; vrayInfo/computername; vrayInfo/cpu; vrayInfo/date; vrayInfo/elapsedtime; vrayInfo/engine; vrayInfo/filename; vrayInfo/frame; vrayInfo/frameTimeID; vrayInfo/freeMemCPU; vrayInfo/giPerPix; vrayInfo/giRayCountID; vrayInfo/h; vrayInfo/infinitePrimsID; vrayInfo/kpaths; vrayInfo/lightcacheTimeID; vrayInfo/mbTrisID"
+    exrio:type: "int; float; m44f; chlist; compression; string; box2i; lineOrder; v2f"
+    exrio:value: 0, 0
+    ICCProfile:attributes: "Reflective, Glossy, Positive, Color"
+    ICCProfile:cmm_type: 1281977967
+    ICCProfile:color_space: "RGB"
+    ICCProfile:copyright: "Copyright (c) 1998 Hewlett-Packard Company"
+    ICCProfile:creation_date: "1998:02:09 06:49:00"
+    ICCProfile:creator_signature: "48502020"
+    ICCProfile:device_class: "Display device profile"
+    ICCProfile:device_manufacturer_description: "IEC http://www.iec.ch"
+    ICCProfile:device_model_description: "IEC 61966-2.1 Default RGB colour space - sRGB"
+    ICCProfile:flags: "Not Embedded, Independent"
+    ICCProfile:manufacturer: "49454320"
+    ICCProfile:model: "73524742"
+    ICCProfile:platform_signature: "Microsoft Corporation"
+    ICCProfile:profile_connection_space: "XYZ"
+    ICCProfile:profile_description: "sRGB IEC61966-2.1"
+    ICCProfile:profile_size: 3144
+    ICCProfile:profile_version: "2.1.0"
+    ICCProfile:rendering_intent: "Media-relative colorimetric"
+    ICCProfile:viewing_conditions_description: "Reference Viewing Condition in IEC61966-2.1"
+    IPTC:DocumentID: "adobe:docid:photoshop:d0b5fcf6-f464-234f-b5df-47c18ab8b898"
+    IPTC:InstanceID: "xmp.iid:709ebe80-9e41-244a-81bc-8a5e754fe63e"
+    IPTC:MetadataDate: "2024-04-01T19:35:30+02:00"
+    IPTC:ModifyDate: "2024-04-01T19:35:30+02:00"
+    IPTC:OriginalDocumentID: "xmp.did:68fcb000-4377-c148-974d-bdd193ca024d"
+    oiio:ColorSpace: "sRGB"
+    oiio:subimagename: "Layer"
+    photoshop:ColorMode: 3
+    photoshop:ICCProfile: "sRGB IEC61966-2.1"
+    rdf:parseType: "Resource"
+    rdf:resource: "http://doc.exr-io.com/metadata/1.0/attribute"
+    stEvt:action: "saved"
+    stEvt:changed: "/"
+    stEvt:instanceID: "xmp.iid:68fcb000-4377-c148-974d-bdd193ca024d; xmp.iid:709ebe80-9e41-244a-81bc-8a5e754fe63e"
+    stEvt:softwareAgent: "Adobe Photoshop 23.3 (Windows)"
+    stEvt:when: "2024-04-01T19:35:16+02:00; 2024-04-01T19:35:30+02:00"
+ subimage  3:   48 x   27, 4 channel, uint16 psd
+    SHA-1: 99B76EB713BA5C84D924E0ADDE14650ADAE2D590
+    channel list: R, G, B, A
+    DateTime: "2024-03-06T15:22:40+01:00"
+    ICCProfile: 0, 0, 12, 72, 76, 105, 110, 111, 2, 16, 0, 0, 109, 110, 116, 114, ... [3144 x uint8]
+    Orientation: 1 (normal)
+    PixelAspectRatio: 1
+    ResolutionUnit: "in"
+    Software: "Adobe Photoshop 23.3 (Windows)"
+    XResolution: 72
+    YResolution: 72
+    Exif:ColorSpace: 1
+    Exif:PixelXDimension: 48
+    Exif:PixelYDimension: 27
+    exrio:name: "applied_color_corrections; cameraAperture; cameraFNumber; cameraFarClip; cameraFarRange; cameraFocalLength; cameraFov; cameraNearClip; cameraNearRange; cameraProjection; cameraTargetDistance; cameraTransform; channels; compression; cryptomatte/881c23b/conversion; cryptomatte/881c23b/hash; cryptomatte/881c23b/manifest; cryptomatte/881c23b/name; dataWindow; displayWindow; lineOrder; name; pixelAspectRatio; screenWindowCenter; screenWindowWidth; type; vfb2_layers_json; vrayChannelInfo; vrayInfo/camera; vrayInfo/cameraPerPix; vrayInfo/cameraRayCountID; vrayInfo/cleanupTimeID; vrayInfo/computername; vrayInfo/cpu; vrayInfo/date; vrayInfo/elapsedtime; vrayInfo/engine; vrayInfo/filename; vrayInfo/frame; vrayInfo/frameTimeID; vrayInfo/freeMemCPU; vrayInfo/giPerPix; vrayInfo/giRayCountID; vrayInfo/h; vrayInfo/infinitePrimsID; vrayInfo/kpaths; vrayInfo/lightcacheTimeID; vrayInfo/mbTrisID"
+    exrio:type: "int; float; m44f; chlist; compression; string; box2i; lineOrder; v2f"
+    exrio:value: 0, 0
+    ICCProfile:attributes: "Reflective, Glossy, Positive, Color"
+    ICCProfile:cmm_type: 1281977967
+    ICCProfile:color_space: "RGB"
+    ICCProfile:copyright: "Copyright (c) 1998 Hewlett-Packard Company"
+    ICCProfile:creation_date: "1998:02:09 06:49:00"
+    ICCProfile:creator_signature: "48502020"
+    ICCProfile:device_class: "Display device profile"
+    ICCProfile:device_manufacturer_description: "IEC http://www.iec.ch"
+    ICCProfile:device_model_description: "IEC 61966-2.1 Default RGB colour space - sRGB"
+    ICCProfile:flags: "Not Embedded, Independent"
+    ICCProfile:manufacturer: "49454320"
+    ICCProfile:model: "73524742"
+    ICCProfile:platform_signature: "Microsoft Corporation"
+    ICCProfile:profile_connection_space: "XYZ"
+    ICCProfile:profile_description: "sRGB IEC61966-2.1"
+    ICCProfile:profile_size: 3144
+    ICCProfile:profile_version: "2.1.0"
+    ICCProfile:rendering_intent: "Media-relative colorimetric"
+    ICCProfile:viewing_conditions_description: "Reference Viewing Condition in IEC61966-2.1"
+    IPTC:DocumentID: "adobe:docid:photoshop:d0b5fcf6-f464-234f-b5df-47c18ab8b898"
+    IPTC:InstanceID: "xmp.iid:709ebe80-9e41-244a-81bc-8a5e754fe63e"
+    IPTC:MetadataDate: "2024-04-01T19:35:30+02:00"
+    IPTC:ModifyDate: "2024-04-01T19:35:30+02:00"
+    IPTC:OriginalDocumentID: "xmp.did:68fcb000-4377-c148-974d-bdd193ca024d"
+    oiio:ColorSpace: "sRGB"
+    oiio:subimagename: "Layer2"
+    photoshop:ColorMode: 3
+    photoshop:ICCProfile: "sRGB IEC61966-2.1"
+    rdf:parseType: "Resource"
+    rdf:resource: "http://doc.exr-io.com/metadata/1.0/attribute"
+    stEvt:action: "saved"
+    stEvt:changed: "/"
+    stEvt:instanceID: "xmp.iid:68fcb000-4377-c148-974d-bdd193ca024d; xmp.iid:709ebe80-9e41-244a-81bc-8a5e754fe63e"
+    stEvt:softwareAgent: "Adobe Photoshop 23.3 (Windows)"
+    stEvt:when: "2024-04-01T19:35:16+02:00; 2024-04-01T19:35:30+02:00"
+Reading src/Layers_32bit_RGB.psd
+src/Layers_32bit_RGB.psd :   48 x   27, 3 channel, float psd
+    4 subimages: 48x27 [f,f,f], 48x27 [f,f,f,f], 48x27 [f,f,f,f], 48x27 [f,f,f,f]
+ subimage  0:   48 x   27, 3 channel, float psd
+    SHA-1: 90D05324071E32026D22E44FA9EF027C80D97308
+    channel list: R, G, B
+    DateTime: "2024-03-06T15:22:40+01:00"
+    ICCProfile: 0, 0, 2, 56, 108, 99, 109, 115, 4, 48, 0, 0, 109, 110, 116, 114, ... [568 x uint8]
+    Orientation: 1 (normal)
+    PixelAspectRatio: 1
+    ResolutionUnit: "in"
+    Software: "Adobe Photoshop 23.3 (Windows)"
+    thumbnail_height: 27
+    thumbnail_nchannels: 3
+    thumbnail_width: 48
+    XResolution: 72
+    YResolution: 72
+    Exif:ColorSpace: 65535
+    Exif:PixelXDimension: 48
+    Exif:PixelYDimension: 27
+    exrio:name: "applied_color_corrections; cameraAperture; cameraFNumber; cameraFarClip; cameraFarRange; cameraFocalLength; cameraFov; cameraNearClip; cameraNearRange; cameraProjection; cameraTargetDistance; cameraTransform; channels; compression; cryptomatte/881c23b/conversion; cryptomatte/881c23b/hash; cryptomatte/881c23b/manifest; cryptomatte/881c23b/name; dataWindow; displayWindow; lineOrder; name; pixelAspectRatio; screenWindowCenter; screenWindowWidth; type; vfb2_layers_json; vrayChannelInfo; vrayInfo/camera; vrayInfo/cameraPerPix; vrayInfo/cameraRayCountID; vrayInfo/cleanupTimeID; vrayInfo/computername; vrayInfo/cpu; vrayInfo/date; vrayInfo/elapsedtime; vrayInfo/engine; vrayInfo/filename; vrayInfo/frame; vrayInfo/frameTimeID; vrayInfo/freeMemCPU; vrayInfo/giPerPix; vrayInfo/giRayCountID; vrayInfo/h; vrayInfo/infinitePrimsID; vrayInfo/kpaths; vrayInfo/lightcacheTimeID; vrayInfo/mbTrisID"
+    exrio:type: "int; float; m44f; chlist; compression; string; box2i; lineOrder; v2f"
+    exrio:value: 0, 0
+    IPTC:DocumentID: "adobe:docid:photoshop:c17239f3-0dba-274a-8b00-2c4bfa538ebe"
+    IPTC:InstanceID: "xmp.iid:cbd904c5-53b4-0d4e-9ff8-37ac35429f46"
+    IPTC:MetadataDate: "2024-04-01T19:35:16+02:00"
+    IPTC:ModifyDate: "2024-04-01T19:35:16+02:00"
+    IPTC:OriginalDocumentID: "xmp.did:68fcb000-4377-c148-974d-bdd193ca024d"
+    photoshop:ColorMode: 3
+    photoshop:ICCProfile: "RGB built-in"
+    rdf:parseType: "Resource"
+    rdf:resource: "http://doc.exr-io.com/metadata/1.0/attribute"
+    stEvt:action: "saved"
+    stEvt:changed: "/"
+    stEvt:instanceID: "xmp.iid:68fcb000-4377-c148-974d-bdd193ca024d; xmp.iid:cbd904c5-53b4-0d4e-9ff8-37ac35429f46"
+    stEvt:softwareAgent: "Adobe Photoshop 23.3 (Windows)"
+    stEvt:when: "2024-04-01T19:35:16+02:00"
+ subimage  1:   48 x   27, 4 channel, float psd
+    SHA-1: 00FF9A578E0AF4490EE2ACB6FDCC8EBC5FD119E4
+    channel list: R, G, B, A
+    DateTime: "2024-03-06T15:22:40+01:00"
+    ICCProfile: 0, 0, 2, 56, 108, 99, 109, 115, 4, 48, 0, 0, 109, 110, 116, 114, ... [568 x uint8]
+    Orientation: 1 (normal)
+    PixelAspectRatio: 1
+    ResolutionUnit: "in"
+    Software: "Adobe Photoshop 23.3 (Windows)"
+    XResolution: 72
+    YResolution: 72
+    Exif:ColorSpace: 65535
+    Exif:PixelXDimension: 48
+    Exif:PixelYDimension: 27
+    exrio:name: "applied_color_corrections; cameraAperture; cameraFNumber; cameraFarClip; cameraFarRange; cameraFocalLength; cameraFov; cameraNearClip; cameraNearRange; cameraProjection; cameraTargetDistance; cameraTransform; channels; compression; cryptomatte/881c23b/conversion; cryptomatte/881c23b/hash; cryptomatte/881c23b/manifest; cryptomatte/881c23b/name; dataWindow; displayWindow; lineOrder; name; pixelAspectRatio; screenWindowCenter; screenWindowWidth; type; vfb2_layers_json; vrayChannelInfo; vrayInfo/camera; vrayInfo/cameraPerPix; vrayInfo/cameraRayCountID; vrayInfo/cleanupTimeID; vrayInfo/computername; vrayInfo/cpu; vrayInfo/date; vrayInfo/elapsedtime; vrayInfo/engine; vrayInfo/filename; vrayInfo/frame; vrayInfo/frameTimeID; vrayInfo/freeMemCPU; vrayInfo/giPerPix; vrayInfo/giRayCountID; vrayInfo/h; vrayInfo/infinitePrimsID; vrayInfo/kpaths; vrayInfo/lightcacheTimeID; vrayInfo/mbTrisID"
+    exrio:type: "int; float; m44f; chlist; compression; string; box2i; lineOrder; v2f"
+    exrio:value: 0, 0
+    ICCProfile:attributes: "Reflective, Glossy, Positive, Color"
+    ICCProfile:cmm_type: 1818455411
+    ICCProfile:color_space: "RGB"
+    ICCProfile:copyright: "No copyright, use freely"
+    ICCProfile:creation_date: "2024:04:01 17:31:55"
+    ICCProfile:creator_signature: "6c636d73"
+    ICCProfile:device_class: "Display device profile"
+    ICCProfile:flags: "Not Embedded, Independent"
+    ICCProfile:manufacturer: "0"
+    ICCProfile:model: "0"
+    ICCProfile:platform_signature: "Microsoft Corporation"
+    ICCProfile:profile_connection_space: "XYZ"
+    ICCProfile:profile_description: "RGB built-in"
+    ICCProfile:profile_size: 568
+    ICCProfile:profile_version: "4.3.0"
+    ICCProfile:rendering_intent: "Perceptual"
+    IPTC:DocumentID: "adobe:docid:photoshop:c17239f3-0dba-274a-8b00-2c4bfa538ebe"
+    IPTC:InstanceID: "xmp.iid:cbd904c5-53b4-0d4e-9ff8-37ac35429f46"
+    IPTC:MetadataDate: "2024-04-01T19:35:16+02:00"
+    IPTC:ModifyDate: "2024-04-01T19:35:16+02:00"
+    IPTC:OriginalDocumentID: "xmp.did:68fcb000-4377-c148-974d-bdd193ca024d"
+    oiio:subimagename: "Blue_Lagoon"
+    photoshop:ColorMode: 3
+    photoshop:ICCProfile: "RGB built-in"
+    rdf:parseType: "Resource"
+    rdf:resource: "http://doc.exr-io.com/metadata/1.0/attribute"
+    stEvt:action: "saved"
+    stEvt:changed: "/"
+    stEvt:instanceID: "xmp.iid:68fcb000-4377-c148-974d-bdd193ca024d; xmp.iid:cbd904c5-53b4-0d4e-9ff8-37ac35429f46"
+    stEvt:softwareAgent: "Adobe Photoshop 23.3 (Windows)"
+    stEvt:when: "2024-04-01T19:35:16+02:00"
+ subimage  2:   48 x   27, 4 channel, float psd
+    SHA-1: FD0AEA8F5823B878CFAB53B6E0D85F43A382D5CF
+    channel list: R, G, B, A
+    DateTime: "2024-03-06T15:22:40+01:00"
+    ICCProfile: 0, 0, 2, 56, 108, 99, 109, 115, 4, 48, 0, 0, 109, 110, 116, 114, ... [568 x uint8]
+    Orientation: 1 (normal)
+    PixelAspectRatio: 1
+    ResolutionUnit: "in"
+    Software: "Adobe Photoshop 23.3 (Windows)"
+    XResolution: 72
+    YResolution: 72
+    Exif:ColorSpace: 65535
+    Exif:PixelXDimension: 48
+    Exif:PixelYDimension: 27
+    exrio:name: "applied_color_corrections; cameraAperture; cameraFNumber; cameraFarClip; cameraFarRange; cameraFocalLength; cameraFov; cameraNearClip; cameraNearRange; cameraProjection; cameraTargetDistance; cameraTransform; channels; compression; cryptomatte/881c23b/conversion; cryptomatte/881c23b/hash; cryptomatte/881c23b/manifest; cryptomatte/881c23b/name; dataWindow; displayWindow; lineOrder; name; pixelAspectRatio; screenWindowCenter; screenWindowWidth; type; vfb2_layers_json; vrayChannelInfo; vrayInfo/camera; vrayInfo/cameraPerPix; vrayInfo/cameraRayCountID; vrayInfo/cleanupTimeID; vrayInfo/computername; vrayInfo/cpu; vrayInfo/date; vrayInfo/elapsedtime; vrayInfo/engine; vrayInfo/filename; vrayInfo/frame; vrayInfo/frameTimeID; vrayInfo/freeMemCPU; vrayInfo/giPerPix; vrayInfo/giRayCountID; vrayInfo/h; vrayInfo/infinitePrimsID; vrayInfo/kpaths; vrayInfo/lightcacheTimeID; vrayInfo/mbTrisID"
+    exrio:type: "int; float; m44f; chlist; compression; string; box2i; lineOrder; v2f"
+    exrio:value: 0, 0
+    ICCProfile:attributes: "Reflective, Glossy, Positive, Color"
+    ICCProfile:cmm_type: 1818455411
+    ICCProfile:color_space: "RGB"
+    ICCProfile:copyright: "No copyright, use freely"
+    ICCProfile:creation_date: "2024:04:01 17:31:55"
+    ICCProfile:creator_signature: "6c636d73"
+    ICCProfile:device_class: "Display device profile"
+    ICCProfile:flags: "Not Embedded, Independent"
+    ICCProfile:manufacturer: "0"
+    ICCProfile:model: "0"
+    ICCProfile:platform_signature: "Microsoft Corporation"
+    ICCProfile:profile_connection_space: "XYZ"
+    ICCProfile:profile_description: "RGB built-in"
+    ICCProfile:profile_size: 568
+    ICCProfile:profile_version: "4.3.0"
+    ICCProfile:rendering_intent: "Perceptual"
+    IPTC:DocumentID: "adobe:docid:photoshop:c17239f3-0dba-274a-8b00-2c4bfa538ebe"
+    IPTC:InstanceID: "xmp.iid:cbd904c5-53b4-0d4e-9ff8-37ac35429f46"
+    IPTC:MetadataDate: "2024-04-01T19:35:16+02:00"
+    IPTC:ModifyDate: "2024-04-01T19:35:16+02:00"
+    IPTC:OriginalDocumentID: "xmp.did:68fcb000-4377-c148-974d-bdd193ca024d"
+    oiio:subimagename: "Layer"
+    photoshop:ColorMode: 3
+    photoshop:ICCProfile: "RGB built-in"
+    rdf:parseType: "Resource"
+    rdf:resource: "http://doc.exr-io.com/metadata/1.0/attribute"
+    stEvt:action: "saved"
+    stEvt:changed: "/"
+    stEvt:instanceID: "xmp.iid:68fcb000-4377-c148-974d-bdd193ca024d; xmp.iid:cbd904c5-53b4-0d4e-9ff8-37ac35429f46"
+    stEvt:softwareAgent: "Adobe Photoshop 23.3 (Windows)"
+    stEvt:when: "2024-04-01T19:35:16+02:00"
+ subimage  3:   48 x   27, 4 channel, float psd
+    SHA-1: EA826AA276DDD6E8A4A333EB2FF6F4FAAF1E695F
+    channel list: R, G, B, A
+    DateTime: "2024-03-06T15:22:40+01:00"
+    ICCProfile: 0, 0, 2, 56, 108, 99, 109, 115, 4, 48, 0, 0, 109, 110, 116, 114, ... [568 x uint8]
+    Orientation: 1 (normal)
+    PixelAspectRatio: 1
+    ResolutionUnit: "in"
+    Software: "Adobe Photoshop 23.3 (Windows)"
+    XResolution: 72
+    YResolution: 72
+    Exif:ColorSpace: 65535
+    Exif:PixelXDimension: 48
+    Exif:PixelYDimension: 27
+    exrio:name: "applied_color_corrections; cameraAperture; cameraFNumber; cameraFarClip; cameraFarRange; cameraFocalLength; cameraFov; cameraNearClip; cameraNearRange; cameraProjection; cameraTargetDistance; cameraTransform; channels; compression; cryptomatte/881c23b/conversion; cryptomatte/881c23b/hash; cryptomatte/881c23b/manifest; cryptomatte/881c23b/name; dataWindow; displayWindow; lineOrder; name; pixelAspectRatio; screenWindowCenter; screenWindowWidth; type; vfb2_layers_json; vrayChannelInfo; vrayInfo/camera; vrayInfo/cameraPerPix; vrayInfo/cameraRayCountID; vrayInfo/cleanupTimeID; vrayInfo/computername; vrayInfo/cpu; vrayInfo/date; vrayInfo/elapsedtime; vrayInfo/engine; vrayInfo/filename; vrayInfo/frame; vrayInfo/frameTimeID; vrayInfo/freeMemCPU; vrayInfo/giPerPix; vrayInfo/giRayCountID; vrayInfo/h; vrayInfo/infinitePrimsID; vrayInfo/kpaths; vrayInfo/lightcacheTimeID; vrayInfo/mbTrisID"
+    exrio:type: "int; float; m44f; chlist; compression; string; box2i; lineOrder; v2f"
+    exrio:value: 0, 0
+    ICCProfile:attributes: "Reflective, Glossy, Positive, Color"
+    ICCProfile:cmm_type: 1818455411
+    ICCProfile:color_space: "RGB"
+    ICCProfile:copyright: "No copyright, use freely"
+    ICCProfile:creation_date: "2024:04:01 17:31:55"
+    ICCProfile:creator_signature: "6c636d73"
+    ICCProfile:device_class: "Display device profile"
+    ICCProfile:flags: "Not Embedded, Independent"
+    ICCProfile:manufacturer: "0"
+    ICCProfile:model: "0"
+    ICCProfile:platform_signature: "Microsoft Corporation"
+    ICCProfile:profile_connection_space: "XYZ"
+    ICCProfile:profile_description: "RGB built-in"
+    ICCProfile:profile_size: 568
+    ICCProfile:profile_version: "4.3.0"
+    ICCProfile:rendering_intent: "Perceptual"
+    IPTC:DocumentID: "adobe:docid:photoshop:c17239f3-0dba-274a-8b00-2c4bfa538ebe"
+    IPTC:InstanceID: "xmp.iid:cbd904c5-53b4-0d4e-9ff8-37ac35429f46"
+    IPTC:MetadataDate: "2024-04-01T19:35:16+02:00"
+    IPTC:ModifyDate: "2024-04-01T19:35:16+02:00"
+    IPTC:OriginalDocumentID: "xmp.did:68fcb000-4377-c148-974d-bdd193ca024d"
+    oiio:subimagename: "Layer2"
+    photoshop:ColorMode: 3
+    photoshop:ICCProfile: "RGB built-in"
+    rdf:parseType: "Resource"
+    rdf:resource: "http://doc.exr-io.com/metadata/1.0/attribute"
+    stEvt:action: "saved"
+    stEvt:changed: "/"
+    stEvt:instanceID: "xmp.iid:68fcb000-4377-c148-974d-bdd193ca024d; xmp.iid:cbd904c5-53b4-0d4e-9ff8-37ac35429f46"
+    stEvt:softwareAgent: "Adobe Photoshop 23.3 (Windows)"
+    stEvt:when: "2024-04-01T19:35:16+02:00"
diff -pruN 2.5.10.1+dfsg-1/testsuite/psd/run.py 2.5.12.0+dfsg-1/testsuite/psd/run.py
--- 2.5.10.1+dfsg-1/testsuite/psd/run.py	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/testsuite/psd/run.py	2024-06-01 19:59:05.000000000 +0000
@@ -22,3 +22,8 @@ command += info_command ("src/layer-mask
 command += info_command ("src/crash-psd-exif-1632.psd", failureok = 1)
 # Corrupted thumbnail clobbered memory
 command += info_command ("src/crash-thumb-1626.psd", failureok = 1)
+
+# Test more modern (Photoshop 2023 files) with 16- and 32-bit files containing multiple sublayers
+command += info_command ("src/Layers_8bit_RGB.psd")
+command += info_command ("src/Layers_16bit_RGB.psd")
+command += info_command ("src/Layers_32bit_RGB.psd")
\ No newline at end of file
Binary files 2.5.10.1+dfsg-1/testsuite/psd/src/Layers_16bit_RGB.psd and 2.5.12.0+dfsg-1/testsuite/psd/src/Layers_16bit_RGB.psd differ
Binary files 2.5.10.1+dfsg-1/testsuite/psd/src/Layers_32bit_RGB.psd and 2.5.12.0+dfsg-1/testsuite/psd/src/Layers_32bit_RGB.psd differ
Binary files 2.5.10.1+dfsg-1/testsuite/psd/src/Layers_8bit_RGB.psd and 2.5.12.0+dfsg-1/testsuite/psd/src/Layers_8bit_RGB.psd differ
diff -pruN 2.5.10.1+dfsg-1/testsuite/psd-colormodes/ref/out.txt 2.5.12.0+dfsg-1/testsuite/psd-colormodes/ref/out.txt
--- 2.5.10.1+dfsg-1/testsuite/psd-colormodes/ref/out.txt	2024-04-01 19:07:17.000000000 +0000
+++ 2.5.12.0+dfsg-1/testsuite/psd-colormodes/ref/out.txt	2024-06-01 19:59:05.000000000 +0000
@@ -24,7 +24,7 @@ Comparing "pattern2-16-rgb.psd.tif" and
 PASS
 Comparing "pattern2-8-cmyk.psd.tif" and "ref/pattern2-cmyk.tif"
 PASS
-Comparing "pattern2-16-cmyk.psd.tif" and "ref/pattern2-cmyk.tif"
+Comparing "pattern2-16-cmyk.psd.tif" and "ref/pattern2-16-cmyk.psd.tif"
 PASS
 Comparing "pattern2-8-multichannel.psd.tif" and "ref/pattern2.tif"
 PASS
@@ -32,7 +32,7 @@ Comparing "pattern2-16-multichannel.psd.
 PASS
 Comparing "pattern2-8-grayscale.psd.tif" and "ref/pattern2-gray.tif"
 PASS
-Comparing "pattern2-16-grayscale.psd.tif" and "ref/pattern2-gray.tif"
+Comparing "pattern2-16-grayscale.psd.tif" and "ref/pattern2-16-grayscale.psd.tif"
 PASS
 Comparing "pattern2-8-indexed.psd.tif" and "ref/pattern2-alpha.tif"
 PASS
Binary files 2.5.10.1+dfsg-1/testsuite/psd-colormodes/ref/pattern2-16-cmyk.psd.tif and 2.5.12.0+dfsg-1/testsuite/psd-colormodes/ref/pattern2-16-cmyk.psd.tif differ
Binary files 2.5.10.1+dfsg-1/testsuite/psd-colormodes/ref/pattern2-16-grayscale.psd.tif and 2.5.12.0+dfsg-1/testsuite/psd-colormodes/ref/pattern2-16-grayscale.psd.tif differ
